/*----------------------------------------------------------------------------------------------------------*/
/*	Copyright (C) Palmstiernas Instrument AB. All Rights Reserved		*/
/*	Product:		SIMATIC PDM				*/
/*									*/
/*	Device:			D3 for PROFIBUS PA		*/
/*          			Profile 3					*/
/*	Description:	Device Description				*/
/*									*/
/*  $Revision:   1.0  $	    						*/
/*  $Date:   Jun 14 2010 13:56:00  $					*/
/*----------------------------------------------------------------------------------------------------------*/

MANUFACTURER	0x9b,
DEVICE_TYPE	0xd3,
DEVICE_REVISION 0x01,
DD_REVISION		1

/* Includes ------------------------------------------------------ */

#include "SI_HlpM.inc"
#include "SI_FileM.inc"
#include "SI_OptM.inc"

#include "SIPAST.inc"

//#include "SIPAST_CommError.inc"

#define YT1_LABEL	[func_ao_readback_value]
#define YT1_VALUE	func1_readback_value
#define	YT1_LRV	func1_pv_lower_range_value
#define YT1_URV	func1_pv_upper_range_value
#define YT2_LABEL	[func_ao_setpoint_value]
#define YT2_VALUE	func1_setpoint_value
#define	YT2_LRV	func1_pv_lower_range_value
#define YT2_URV	func1_pv_upper_range_value
#include "SI_YT.inc"




/***********************************************************************/
//#ifndef FUNC_AI_FAIL_SAFE_VALUE
//#define FUNC_AI_FAIL_SAFE_VALUE			0
//#define FUNC_AI_STORING_LAST_SETPOINT	1
//#define FUNC_AI_FAIL_SAFE_POSITION		2
//#endif

#define	BLOCK_MODE_RCAS				0x02
#define	BLOCK_MODE_AUTO				0x08
#define	BLOCK_MODE_MAN				0x10
#define	BLOCK_MODE_LOCAL_OVERRIDE		0x20
#define	BLOCK_MODE_OUT_OF_SERVICE		0x80

#define	DEVICE_TYPE				"D3"
#define	TAB_X_LABEL_0			"          x[0]"
#define	TAB_X_LABEL_1			"          x[1]"
#define	TAB_X_LABEL_2			"          x[2]"
#define	TAB_X_LABEL_3			"          x[3]"
#define	TAB_X_LABEL_4			"          x[4]"
#define	TAB_X_LABEL_5			"          x[5]"
#define	TAB_X_LABEL_6			"          x[6]"
#define	TAB_X_LABEL_7			"          x[7]"
#define	TAB_X_LABEL_8			"          x[8]"
#define	TAB_X_LABEL_9			"          x[9]"
#define	TAB_X_LABEL_10			"          x[10]"
#define	TAB_X_LABEL_11			"          x[11]"
#define	TAB_X_LABEL_12			"          x[12]"
#define	TAB_X_LABEL_13			"          x[13]"
#define	TAB_X_LABEL_14			"          x[14]"
#define	TAB_X_LABEL_15			"          x[15]"
#define	TAB_X_LABEL_16			"          x[16]"
#define	TAB_X_LABEL_17			"          x[17]"
#define	TAB_X_LABEL_18			"          x[18]"
#define	TAB_X_LABEL_19			"          x[19]"
#define	TAB_X_LABEL_20			"          x[20]"
#define	TAB_X_LABEL_21			"          x[21]"
#define	TAB_X_LABEL_22			"          x[22]"
#define	TAB_X_LABEL_23			"          x[23]"
#define	TAB_X_LABEL_24			"          x[24]"
#define	TAB_X_LABEL_25			"          x[25]"
#define	TAB_X_LABEL_26			"          x[26]"
#define	TAB_X_LABEL_27			"          x[27]"
#define	TAB_X_LABEL_28			"          x[28]"
#define	TAB_X_LABEL_29			"          x[29]"
#define	TAB_X_LABEL_30			"          x[30]"
#define	TAB_X_LABEL_31			"          x[31]"
#define	TAB_X_LABEL_32			"          x[32]"

#define	TAB_Y_LABEL_0			"          y[0]"
#define	TAB_Y_LABEL_1			"          y[1]"
#define	TAB_Y_LABEL_2			"          y[2]"
#define	TAB_Y_LABEL_3			"          y[3]"
#define	TAB_Y_LABEL_4			"          y[4]"
#define	TAB_Y_LABEL_5			"          y[5]"
#define	TAB_Y_LABEL_6			"          y[6]"
#define	TAB_Y_LABEL_7			"          y[7]"
#define	TAB_Y_LABEL_8			"          y[8]"
#define	TAB_Y_LABEL_9			"          y[9]"
#define	TAB_Y_LABEL_10			"          y[10]"
#define	TAB_Y_LABEL_11			"          y[11]"
#define	TAB_Y_LABEL_12			"          y[12]"
#define	TAB_Y_LABEL_13			"          y[13]"
#define	TAB_Y_LABEL_14			"          y[14]"
#define	TAB_Y_LABEL_15			"          y[15]"
#define	TAB_Y_LABEL_16			"          y[16]"
#define	TAB_Y_LABEL_17			"          y[17]"
#define	TAB_Y_LABEL_18			"          y[18]"
#define	TAB_Y_LABEL_19			"          y[19]"
#define	TAB_Y_LABEL_20			"          y[20]"
#define	TAB_Y_LABEL_21			"          y[21]"
#define	TAB_Y_LABEL_22			"          y[22]"
#define	TAB_Y_LABEL_23			"          y[23]"
#define	TAB_Y_LABEL_24			"          y[24]"
#define	TAB_Y_LABEL_25			"          y[25]"
#define	TAB_Y_LABEL_26			"          y[26]"
#define	TAB_Y_LABEL_27			"          y[27]"
#define	TAB_Y_LABEL_28			"          y[28]"
#define	TAB_Y_LABEL_29			"          y[29]"
#define	TAB_Y_LABEL_30			"          y[30]"
#define	TAB_Y_LABEL_31			"          y[31]"
#define	TAB_Y_LABEL_32			"          y[32]"


#define LIN_TABLE_USER			(trans1_lin_type == 1)
#define LIN_TABLE_3				(trans1_tab_actual_number > 3)
#define LIN_TABLE_5				(trans1_tab_actual_number > 5)
#define LIN_TABLE_9				(trans1_tab_actual_number > 9)
#define LIN_TABLE_17			(trans1_tab_actual_number > 17)
#define O_O_SERV				(trans1_target_mode == BLOCK_MODE_OUT_OF_SERVICE)
#define AO_O_O_SERV				(func1_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func1_target_mode == BLOCK_MODE_MAN)
#define TEMP_O_O_SERV			(func2_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func2_target_mode == BLOCK_MODE_MAN)
#define AUX_O_O_SERV			(func3_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func3_target_mode == BLOCK_MODE_MAN)


#define VALID_LIN_TABLE     \
IF (LIN_TABLE_USER)			\
{							\
	TRUE;					\
}							\
ELSE						\
{							\
	FALSE;					\
}
#define VALID_LIN_TABLE_SMALL     \
IF (LIN_TABLE_USER & LIN_TABLE_3)			\
{							\
	TRUE;					\
}							\
ELSE						\
{							\
	FALSE;					\
}

#define VALID_LIN_TABLE_MEDIUM     \
IF (LIN_TABLE_USER & LIN_TABLE_5)			\
{							\
	TRUE;					\
}							\
ELSE						\
{							\
	FALSE;					\
}
#define VALID_LIN_TABLE_LARGE     \
IF (LIN_TABLE_USER & LIN_TABLE_9)			\
{							\
	TRUE;					\
}							\
ELSE						\
{							\
	FALSE;					\
}
#define VALID_LIN_TABLE_VL     \
IF (LIN_TABLE_USER & LIN_TABLE_17)			\
{							\
	TRUE;					\
}							\
ELSE						\
{							\
	FALSE;					\
}
#define STATUS_INPUT_LIMIT(quality)					\
	IF ((quality) == 0x20)								\
	{													\
		{ 0x00,	[status_limit_OK]				},		\
		{ 0x03,	[status_limit_VALUE_CONSTANT]	}		\
	}													\
	ELSE {												\
		IF ((quality) == 0x30)							\
		{												\
			{ 0x00,	[status_limit_OK]				},	\
			{ 0x03,	[status_limit_VALUE_CONSTANT]	}		\
		}									\
		 ELSE {									\
			{ 0x00,	[status_limit_OK]				},	\
			{ 0x01,	[status_limit_UNDERFLOW]		},		\
			{ 0x02,	[status_limit_OVERFLOW]			},	\
			{ 0x03,	[status_limit_VALUE_CONSTANT]	}		\
		}												\
	}													\

#define STATUS_OUTPUT_LIMIT							\
		{ 0x00,	[status_limit_OK]				},	\
		{ 0x01,	[status_limit_UNDERFLOW]		},	\
		{ 0x02,	[status_limit_OVERFLOW]			},	\
		{ 0x03,	[status_limit_VALUE_CONSTANT]	}

#define STATUS_INPUT_NO_RCAS				\
		{ 0x20,	[status_GOOD_00]		},	\
		{ 0x21,	[status_GOOD_01]		},	\
		{ 0x22,	[status_GOOD_02]		},	\
		{ 0x23,	[status_GOOD_03]		},	\
		{ 0x24,	[status_GOOD_04]		},	\
		{ 0x25,	[status_GOOD_05]		},	\
		{ 0x26,	[status_GOOD_06]		},	\
		{ 0x28,	[status_GOOD_08]		},	\
		{ 0x10,	[status_UNCERTAIN_00]	},	\
		{ 0x11,	[status_UNCERTAIN_01]	},	\
		{ 0x12,	[status_UNCERTAIN_02]	},	\
		{ 0x13,	[status_UNCERTAIN_03]	},	\
		{ 0x14,	[status_UNCERTAIN_04]	},	\
		{ 0x15,	[status_UNCERTAIN_05]	},	\
		{ 0x16,	[status_UNCERTAIN_06]	},	\
		{ 0x17,	[status_UNCERTAIN_07]	},	\
		{ 0x00,	[status_BAD_00]		},	\
		{ 0x01,	[status_BAD_01]		},	\
		{ 0x03,	[status_BAD_03]		},	\
		{ 0x04,	[status_BAD_04]		},	\
		{ 0x06,	[status_BAD_06]		},	\
		{ 0x07,	[status_BAD_07]		}

#define STATUS_OUTPUT_NO_RCAS				\
		{ 0x20,	[status_GOOD_00]		},	\
		{ 0x21,	[status_GOOD_01]		},	\
		{ 0x22,	[status_GOOD_02]		},	\
		{ 0x23,	[status_GOOD_03]		},	\
		{ 0x24,	[status_GOOD_04]		},	\
		{ 0x25,	[status_GOOD_05]		},	\
		{ 0x26,	[status_GOOD_06]		},	\
		{ 0x28,	[status_GOOD_08]		},	\
		{ 0x10,	[status_UNCERTAIN_00]	},	\
		{ 0x11,	[status_UNCERTAIN_01]	},	\
		{ 0x12,	[status_UNCERTAIN_02]	},	\
		{ 0x13,	[status_UNCERTAIN_03]	},	\
		{ 0x14,	[status_UNCERTAIN_04]	},	\
		{ 0x15,	[status_UNCERTAIN_05]	},	\
		{ 0x16,	[status_UNCERTAIN_06]	},	\
		{ 0x17,	[status_UNCERTAIN_07]	},	\
		{ 0x00,	[status_BAD_00]		},	\
		{ 0x01,	[status_BAD_01]		},	\
		{ 0x02,	[status_BAD_02]		},	\
		{ 0x03,	[status_BAD_03]		},	\
		{ 0x04,	[status_BAD_04]		},	\
		{ 0x05,	[status_BAD_05]		},	\
		{ 0x06,	[status_BAD_06]		},	\
		{ 0x07,	[status_BAD_07]		}

#define STATUS_INPUT_RCAS					\
		{ 0x20,	[status_GOOD_00]		},	\
		{ 0x30,	[status_GOOD_RCAS_00]	},	\
		{ 0x31,	[status_GOOD_RCAS_01]	},	\
		{ 0x35,	[status_GOOD_RCAS_05]	},	\
		{ 0x38,	[status_GOOD_RCAS_08]	},	\
		{ 0x00,	[status_BAD_00]		},	\
		{ 0x01,	[status_BAD_01]		},	\
		{ 0x03,	[status_BAD_03]		},	\
		{ 0x04,	[status_BAD_04]		},	\
		{ 0x06,	[status_BAD_06]		},	\
		{ 0x07,	[status_BAD_07]		}

#define STATUS_OUTPUT_RCAS					\
		{ 0x30,	[status_GOOD_RCAS_00]	},	\
		{ 0x32,	[status_GOOD_RCAS_01]	},	\
		{ 0x32,	[status_GOOD_RCAS_02]	},	\
		{ 0x33,	[status_GOOD_RCAS_03]	},	\
		{ 0x34,	[status_GOOD_RCAS_04]	},	\
		{ 0x35,	[status_GOOD_RCAS_05]	},	\
		{ 0x36,	[status_GOOD_RCAS_06]	},	\
		{ 0x37,	[status_GOOD_RCAS_07]	},	\
		{ 0x38,	[status_GOOD_RCAS_08]	},	\
		{ 0x10,	[status_UNCERTAIN_00]	},	\
		{ 0x11,	[status_UNCERTAIN_01]	},	\
		{ 0x12,	[status_UNCERTAIN_02]	},	\
		{ 0x13,	[status_UNCERTAIN_03]	},	\
		{ 0x14,	[status_UNCERTAIN_04]	},	\
		{ 0x15,	[status_UNCERTAIN_05]	},	\
		{ 0x16,	[status_UNCERTAIN_06]	},	\
		{ 0x17,	[status_UNCERTAIN_07]	},	\
		{ 0x00,	[status_BAD_00]		},	\
		{ 0x01,	[status_BAD_01]		},	\
		{ 0x02,	[status_BAD_02]		},	\
		{ 0x03,	[status_BAD_03]		},	\
		{ 0x04,	[status_BAD_04]		},	\
		{ 0x05,	[status_BAD_05]		},	\
		{ 0x06,	[status_BAD_06]		},	\
		{ 0x07,	[status_BAD_07]		}

#define UNIT_LIST								    \
		{ 1000,	[unit_1000],	[unit_1000_help]	},	\
		{ 1001,	[unit_1001],	[unit_1001_help]	},	\
		{ 1002,	[unit_1002],	[unit_1002_help]	},	\
		{ 1003,	[unit_1003],	[unit_1003_help]	},	\
		{ 1004,	[unit_1004],	[unit_1004_help]	},	\
		{ 1005,	[unit_1005],	[unit_1005_help]	},	\
		{ 1006,	[unit_1006],	[unit_1006_help]	},	\
		{ 1007,	[unit_1007],	[unit_1007_help]	},	\
		{ 1008,	[unit_1008],	[unit_1008_help]	},	\
		{ 1009,	[unit_1009],	[unit_1009_help]	},	\
		{ 1010,	[unit_1010],	[unit_1010_help]	},	\
		{ 1011,	[unit_1011],	[unit_1011_help]	},	\
		{ 1012,	[unit_1012],	[unit_1012_help]	},	\
		{ 1013,	[unit_1013],	[unit_1013_help]	},	\
		{ 1014,	[unit_1014],	[unit_1014_help]	},	\
		{ 1015,	[unit_1015],	[unit_1015_help]	},	\
		{ 1016,	[unit_1016],	[unit_1016_help]	},	\
		{ 1017,	[unit_1017],	[unit_1017_help]	},	\
		{ 1018,	[unit_1018],	[unit_1018_help]	},	\
		{ 1019,	[unit_1019],	[unit_1019_help]	},	\
		{ 1020,	[unit_1020],	[unit_1020_help]	},	\
		{ 1021,	[unit_1021],	[unit_1021_help]	},	\
		{ 1022,	[unit_1022],	[unit_1022_help]	},	\
		{ 1023,	[unit_1023],	[unit_1023_help]	},	\
		{ 1024,	[unit_1024],	[unit_1024_help]	},	\
		{ 1025,	[unit_1025],	[unit_1025_help]	},	\
		{ 1026,	[unit_1026],	[unit_1026_help]	},	\
		{ 1027,	[unit_1027],	[unit_1027_help]	},	\
		{ 1028,	[unit_1028],	[unit_1028_help]	},	\
		{ 1029,	[unit_1029],	[unit_1029_help]	},	\
		{ 1030,	[unit_1030],	[unit_1030_help]	},	\
		{ 1031,	[unit_1031],	[unit_1031_help]	},	\
		{ 1032,	[unit_1032],	[unit_1032_help]	},	\
		{ 1033,	[unit_1033],	[unit_1033_help]	},	\
		{ 1034,	[unit_1034],	[unit_1034_help]	},	\
		{ 1035,	[unit_1035],	[unit_1035_help]	},	\
		{ 1036,	[unit_1036],	[unit_1036_help]	},	\
		{ 1037,	[unit_1037],	[unit_1037_help]	},	\
		{ 1038,	[unit_1038],	[unit_1038_help]	},	\
		{ 1039,	[unit_1039],	[unit_1039_help]	},	\
		{ 1040,	[unit_1040],	[unit_1040_help]	},	\
		{ 1041,	[unit_1041],	[unit_1041_help]	},	\
		{ 1042,	[unit_1042],	[unit_1042_help]	},	\
		{ 1043,	[unit_1043],	[unit_1043_help]	},	\
		{ 1044,	[unit_1044],	[unit_1044_help]	},	\
		{ 1045,	[unit_1045],	[unit_1045_help]	},	\
		{ 1046,	[unit_1046],	[unit_1046_help]	},	\
		{ 1047,	[unit_1047],	[unit_1047_help]	},	\
		{ 1048,	[unit_1048],	[unit_1048_help]	},	\
		{ 1049,	[unit_1049],	[unit_1049_help]	},	\
		{ 1050,	[unit_1050],	[unit_1050_help]	},	\
		{ 1051,	[unit_1051],	[unit_1051_help]	},	\
		{ 1052,	[unit_1052],	[unit_1052_help]	},	\
		{ 1053,	[unit_1053],	[unit_1053_help]	},	\
		{ 1054,	[unit_1054],	[unit_1054_help]	},	\
		{ 1055,	[unit_1055],	[unit_1055_help]	},	\
		{ 1056,	[unit_1056],	[unit_1056_help]	},	\
		{ 1057,	[unit_1057],	[unit_1057_help]	},	\
		{ 1058,	[unit_1058],	[unit_1058_help]	},	\
		{ 1059,	[unit_1059],	[unit_1059_help]	},	\
		{ 1060,	[unit_1060],	[unit_1060_help]	},	\
		{ 1061,	[unit_1061],	[unit_1061_help]	},	\
		{ 1062,	[unit_1062],	[unit_1062_help]	},	\
		{ 1063,	[unit_1063],	[unit_1063_help]	},	\
		{ 1064,	[unit_1064],	[unit_1064_help]	},	\
		{ 1065,	[unit_1065],	[unit_1065_help]	},	\
		{ 1066,	[unit_1066],	[unit_1066_help]	},	\
		{ 1067,	[unit_1067],	[unit_1067_help]	},	\
		{ 1068,	[unit_1068],	[unit_1068_help]	},	\
		{ 1069,	[unit_1069],	[unit_1069_help]	},	\
		{ 1070,	[unit_1070],	[unit_1070_help]	},	\
		{ 1071,	[unit_1071],	[unit_1071_help]	},	\
		{ 1072,	[unit_1072],	[unit_1072_help]	},	\
		{ 1073,	[unit_1073],	[unit_1073_help]	},	\
		{ 1074,	[unit_1074],	[unit_1074_help]	},	\
		{ 1075,	[unit_1075],	[unit_1075_help]	},	\
		{ 1076,	[unit_1076],	[unit_1076_help]	},	\
		{ 1077,	[unit_1077],	[unit_1077_help]	},	\
		{ 1078,	[unit_1078],	[unit_1078_help]	},	\
		{ 1079,	[unit_1079],	[unit_1079_help]	},	\
		{ 1080,	[unit_1080],	[unit_1080_help]	},	\
		{ 1081,	[unit_1081],	[unit_1081_help]	},	\
		{ 1082,	[unit_1082],	[unit_1082_help]	},	\
		{ 1083,	[unit_1083],	[unit_1083_help]	},	\
		{ 1084,	[unit_1084],	[unit_1084_help]	},	\
		{ 1085,	[unit_1085],	[unit_1085_help]	},	\
		{ 1086,	[unit_1086],	[unit_1086_help]	},	\
		{ 1087,	[unit_1087],	[unit_1087_help]	},	\
		{ 1088,	[unit_1088],	[unit_1088_help]	},	\
		{ 1089,	[unit_1089],	[unit_1089_help]	},	\
		{ 1090,	[unit_1090],	[unit_1090_help]	},	\
		{ 1091,	[unit_1091],	[unit_1091_help]	},	\
		{ 1092,	[unit_1092],	[unit_1092_help]	},	\
		{ 1093,	[unit_1093],	[unit_1093_help]	},	\
		{ 1094,	[unit_1094],	[unit_1094_help]	},	\
		{ 1095,	[unit_1095],	[unit_1095_help]	},	\
		{ 1096,	[unit_1096],	[unit_1096_help]	},	\
		{ 1097,	[unit_1097],	[unit_1097_help]	},	\
		{ 1098,	[unit_1098],	[unit_1098_help]	},	\
		{ 1099,	[unit_1099],	[unit_1099_help]	},	\
		{ 1100,	[unit_1100],	[unit_1100_help]	},	\
		{ 1101,	[unit_1101],	[unit_1101_help]	},	\
		{ 1102,	[unit_1102],	[unit_1102_help]	},	\
		{ 1103,	[unit_1103],	[unit_1103_help]	},	\
		{ 1104,	[unit_1104],	[unit_1104_help]	},	\
		{ 1105,	[unit_1105],	[unit_1105_help]	},	\
		{ 1106,	[unit_1106],	[unit_1106_help]	},	\
		{ 1107,	[unit_1107],	[unit_1107_help]	},	\
		{ 1108,	[unit_1108],	[unit_1108_help]	},	\
		{ 1109,	[unit_1109],	[unit_1109_help]	},	\
		{ 1110,	[unit_1110],	[unit_1110_help]	},	\
		{ 1111,	[unit_1111],	[unit_1111_help]	},	\
		{ 1112,	[unit_1112],	[unit_1112_help]	},	\
		{ 1113,	[unit_1113],	[unit_1113_help]	},	\
		{ 1114,	[unit_1114],	[unit_1114_help]	},	\
		{ 1115,	[unit_1115],	[unit_1115_help]	},	\
		{ 1116,	[unit_1116],	[unit_1116_help]	},	\
		{ 1117,	[unit_1117],	[unit_1117_help]	},	\
		{ 1118,	[unit_1118],	[unit_1118_help]	},	\
		{ 1119,	[unit_1119],	[unit_1119_help]	},	\
		{ 1120,	[unit_1120],	[unit_1120_help]	},	\
		{ 1121,	[unit_1121],	[unit_1121_help]	},	\
		{ 1122,	[unit_1122],	[unit_1122_help]	},	\
		{ 1123,	[unit_1123],	[unit_1123_help]	},	\
		{ 1124,	[unit_1124],	[unit_1124_help]	},	\
		{ 1125,	[unit_1125],	[unit_1125_help]	},	\
		{ 1126,	[unit_1126],	[unit_1126_help]	},	\
		{ 1127,	[unit_1127],	[unit_1127_help]	},	\
		{ 1128,	[unit_1128],	[unit_1128_help]	},	\
		{ 1129,	[unit_1129],	[unit_1129_help]	},	\
		{ 1130,	[unit_1130],	[unit_1130_help]	},	\
		{ 1131,	[unit_1131],	[unit_1131_help]	},	\
		{ 1132,	[unit_1132],	[unit_1132_help]	},	\
		{ 1133,	[unit_1133],	[unit_1133_help]	},	\
		{ 1134,	[unit_1134],	[unit_1134_help]	},	\
		{ 1135,	[unit_1135],	[unit_1135_help]	},	\
		{ 1136,	[unit_1136],	[unit_1136_help]	},	\
		{ 1137,	[unit_1137],	[unit_1137_help]	},	\
		{ 1138,	[unit_1138],	[unit_1138_help]	},	\
		{ 1139,	[unit_1139],	[unit_1139_help]	},	\
		{ 1140,	[unit_1140],	[unit_1140_help]	},	\
		{ 1141,	[unit_1141],	[unit_1141_help]	},	\
		{ 1142,	[unit_1142],	[unit_1142_help]	},	\
		{ 1143,	[unit_1143],	[unit_1143_help]	},	\
		{ 1144,	[unit_1144],	[unit_1144_help]	},	\
		{ 1145,	[unit_1145],	[unit_1145_help]	},	\
		{ 1146,	[unit_1146],	[unit_1146_help]	},	\
		{ 1147,	[unit_1147],	[unit_1147_help]	},	\
		{ 1148,	[unit_1148],	[unit_1148_help]	},	\
		{ 1149,	[unit_1149],	[unit_1149_help]	},	\
		{ 1150,	[unit_1150],	[unit_1150_help]	},	\
		{ 1151,	[unit_1151],	[unit_1151_help]	},	\
		{ 1152,	[unit_1152],	[unit_1152_help]	},	\
		{ 1153,	[unit_1153],	[unit_1153_help]	},	\
		{ 1154,	[unit_1154],	[unit_1154_help]	},	\
		{ 1155,	[unit_1155],	[unit_1155_help]	},	\
		{ 1156,	[unit_1156],	[unit_1156_help]	},	\
		{ 1157,	[unit_1157],	[unit_1157_help]	},	\
		{ 1158,	[unit_1158],	[unit_1158_help]	},	\
		{ 1159,	[unit_1159],	[unit_1159_help]	},	\
		{ 1160,	[unit_1160],	[unit_1160_help]	},	\
		{ 1161,	[unit_1161],	[unit_1161_help]	},	\
		{ 1162,	[unit_1162],	[unit_1162_help]	},	\
		{ 1163,	[unit_1163],	[unit_1163_help]	},	\
		{ 1164,	[unit_1164],	[unit_1164_help]	},	\
		{ 1165,	[unit_1165],	[unit_1165_help]	},	\
		{ 1166,	[unit_1166],	[unit_1166_help]	},	\
		{ 1167,	[unit_1167],	[unit_1167_help]	},	\
		{ 1168,	[unit_1168],	[unit_1168_help]	},	\
		{ 1169,	[unit_1169],	[unit_1169_help]	},	\
		{ 1170,	[unit_1170],	[unit_1170_help]	},	\
		{ 1171,	[unit_1171],	[unit_1171_help]	},	\
		{ 1172,	[unit_1172],	[unit_1172_help]	},	\
		{ 1173,	[unit_1173],	[unit_1173_help]	},	\
		{ 1174,	[unit_1174],	[unit_1174_help]	},	\
		{ 1175,	[unit_1175],	[unit_1175_help]	},	\
		{ 1176,	[unit_1176],	[unit_1176_help]	},	\
		{ 1177,	[unit_1177],	[unit_1177_help]	},	\
		{ 1178,	[unit_1178],	[unit_1178_help]	},	\
		{ 1179,	[unit_1179],	[unit_1179_help]	},	\
		{ 1180,	[unit_1180],	[unit_1180_help]	},	\
		{ 1181,	[unit_1181],	[unit_1181_help]	},	\
		{ 1182,	[unit_1182],	[unit_1182_help]	},	\
		{ 1183,	[unit_1183],	[unit_1183_help]	},	\
		{ 1184,	[unit_1184],	[unit_1184_help]	},	\
		{ 1185,	[unit_1185],	[unit_1185_help]	},	\
		{ 1186,	[unit_1186],	[unit_1186_help]	},	\
		{ 1187,	[unit_1187],	[unit_1187_help]	},	\
		{ 1188,	[unit_1188],	[unit_1188_help]	},	\
		{ 1189,	[unit_1189],	[unit_1189_help]	},	\
		{ 1190,	[unit_1190],	[unit_1190_help]	},	\
		{ 1191,	[unit_1191],	[unit_1191_help]	},	\
		{ 1192,	[unit_1192],	[unit_1192_help]	},	\
		{ 1193,	[unit_1193],	[unit_1193_help]	},	\
		{ 1194,	[unit_1194],	[unit_1194_help]	},	\
		{ 1195,	[unit_1195],	[unit_1195_help]	},	\
		{ 1196,	[unit_1196],	[unit_1196_help]	},	\
		{ 1197,	[unit_1197],	[unit_1197_help]	},	\
		{ 1198,	[unit_1198],	[unit_1198_help]	},	\
		{ 1199,	[unit_1199],	[unit_1199_help]	},	\
		{ 1200,	[unit_1200],	[unit_1200_help]	},	\
		{ 1201,	[unit_1201],	[unit_1201_help]	},	\
		{ 1202,	[unit_1202],	[unit_1202_help]	},	\
		{ 1203,	[unit_1203],	[unit_1203_help]	},	\
		{ 1204,	[unit_1204],	[unit_1204_help]	},	\
		{ 1205,	[unit_1205],	[unit_1205_help]	},	\
		{ 1206,	[unit_1206],	[unit_1206_help]	},	\
		{ 1207,	[unit_1207],	[unit_1207_help]	},	\
		{ 1208,	[unit_1208],	[unit_1208_help]	},	\
		{ 1209,	[unit_1209],	[unit_1209_help]	},	\
		{ 1210,	[unit_1210],	[unit_1210_help]	},	\
		{ 1211,	[unit_1211],	[unit_1211_help]	},	\
		{ 1212,	[unit_1212],	[unit_1212_help]	},	\
		{ 1213,	[unit_1213],	[unit_1213_help]	},	\
		{ 1214,	[unit_1214],	[unit_1214_help]	},	\
		{ 1215,	[unit_1215],	[unit_1215_help]	},	\
		{ 1216,	[unit_1216],	[unit_1216_help]	},	\
		{ 1217,	[unit_1217],	[unit_1217_help]	},	\
		{ 1218,	[unit_1218],	[unit_1218_help]	},	\
		{ 1219,	[unit_1219],	[unit_1219_help]	},	\
		{ 1220,	[unit_1220],	[unit_1220_help]	},	\
		{ 1221,	[unit_1221],	[unit_1221_help]	},	\
		{ 1222,	[unit_1222],	[unit_1222_help]	},	\
		{ 1223,	[unit_1223],	[unit_1223_help]	},	\
		{ 1224,	[unit_1224],	[unit_1224_help]	},	\
		{ 1225,	[unit_1225],	[unit_1225_help]	},	\
		{ 1226,	[unit_1226],	[unit_1226_help]	},	\
		{ 1227,	[unit_1227],	[unit_1227_help]	},	\
		{ 1228,	[unit_1228],	[unit_1228_help]	},	\
		{ 1229,	[unit_1229],	[unit_1229_help]	},	\
		{ 1230,	[unit_1230],	[unit_1230_help]	},	\
		{ 1231,	[unit_1231],	[unit_1231_help]	},	\
		{ 1232,	[unit_1232],	[unit_1232_help]	},	\
		{ 1233,	[unit_1233],	[unit_1233_help]	},	\
		{ 1234,	[unit_1234],	[unit_1234_help]	},	\
		{ 1235,	[unit_1235],	[unit_1235_help]	},	\
		{ 1236,	[unit_1236],	[unit_1236_help]	},	\
		{ 1237,	[unit_1237],	[unit_1237_help]	},	\
		{ 1238,	[unit_1238],	[unit_1238_help]	},	\
		{ 1239,	[unit_1239],	[unit_1239_help]	},	\
		{ 1240,	[unit_1240],	[unit_1240_help]	},	\
		{ 1241,	[unit_1241],	[unit_1241_help]	},	\
		{ 1242,	[unit_1242],	[unit_1242_help]	},	\
		{ 1243,	[unit_1243],	[unit_1243_help]	},	\
		{ 1244,	[unit_1244],	[unit_1244_help]	},	\
		{ 1245,	[unit_1245],	[unit_1245_help]	},	\
		{ 1246,	[unit_1246],	[unit_1246_help]	},	\
		{ 1247,	[unit_1247],	[unit_1247_help]	},	\
		{ 1248,	[unit_1248],	[unit_1248_help]	},	\
		{ 1249,	[unit_1249],	[unit_1249_help]	},	\
		{ 1250,	[unit_1250],	[unit_1250_help]	},	\
		{ 1251,	[unit_1251],	[unit_1251_help]	},	\
		{ 1252,	[unit_1252],	[unit_1252_help]	},	\
		{ 1253,	[unit_1253],	[unit_1253_help]	},	\
		{ 1254,	[unit_1254],	[unit_1254_help]	},	\
		{ 1255,	[unit_1255],	[unit_1255_help]	},	\
		{ 1256,	[unit_1256],	[unit_1256_help]	},	\
		{ 1257,	[unit_1257],	[unit_1257_help]	},	\
		{ 1258,	[unit_1258],	[unit_1258_help]	},	\
		{ 1259,	[unit_1259],	[unit_1259_help]	},	\
		{ 1260,	[unit_1260],	[unit_1260_help]	},	\
		{ 1261,	[unit_1261],	[unit_1261_help]	},	\
		{ 1262,	[unit_1262],	[unit_1262_help]	},	\
		{ 1263,	[unit_1263],	[unit_1263_help]	},	\
		{ 1264,	[unit_1264],	[unit_1264_help]	},	\
		{ 1265,	[unit_1265],	[unit_1265_help]	},	\
		{ 1266,	[unit_1266],	[unit_1266_help]	},	\
		{ 1267,	[unit_1267],	[unit_1267_help]	},	\
		{ 1268,	[unit_1268],	[unit_1268_help]	},	\
		{ 1269,	[unit_1269],	[unit_1269_help]	},	\
		{ 1270,	[unit_1270],	[unit_1270_help]	},	\
		{ 1271,	[unit_1271],	[unit_1271_help]	},	\
		{ 1272,	[unit_1272],	[unit_1272_help]	},	\
		{ 1273,	[unit_1273],	[unit_1273_help]	},	\
		{ 1274,	[unit_1274],	[unit_1274_help]	},	\
		{ 1275,	[unit_1275],	[unit_1275_help]	},	\
		{ 1276,	[unit_1276],	[unit_1276_help]	},	\
		{ 1277,	[unit_1277],	[unit_1277_help]	},	\
		{ 1278,	[unit_1278],	[unit_1278_help]	},	\
		{ 1279,	[unit_1279],	[unit_1279_help]	},	\
		{ 1280,	[unit_1280],	[unit_1280_help]	},	\
		{ 1281,	[unit_1281],	[unit_1281_help]	},	\
		{ 1282,	[unit_1282],	[unit_1282_help]	},	\
		{ 1283,	[unit_1283],	[unit_1283_help]	},	\
		{ 1284,	[unit_1284],	[unit_1284_help]	},	\
		{ 1285,	[unit_1285],	[unit_1285_help]	},	\
		{ 1286,	[unit_1286],	[unit_1286_help]	},	\
		{ 1287,	[unit_1287],	[unit_1287_help]	},	\
		{ 1288,	[unit_1288],	[unit_1288_help]	},	\
		{ 1289,	[unit_1289],	[unit_1289_help]	},	\
		{ 1290,	[unit_1290],	[unit_1290_help]	},	\
		{ 1291,	[unit_1291],	[unit_1291_help]	},	\
		{ 1292,	[unit_1292],	[unit_1292_help]	},	\
		{ 1293,	[unit_1293],	[unit_1293_help]	},	\
		{ 1294,	[unit_1294],	[unit_1294_help]	},	\
		{ 1295,	[unit_1295],	[unit_1295_help]	},	\
		{ 1296,	[unit_1296],	[unit_1296_help]	},	\
		{ 1297,	[unit_1297],	[unit_1297_help]	},	\
		{ 1298,	[unit_1298],	[unit_1298_help]	},	\
		{ 1299,	[unit_1299],	[unit_1299_help]	},	\
		{ 1300,	[unit_1300],	[unit_1300_help]	},	\
		{ 1301,	[unit_1301],	[unit_1301_help]	},	\
		{ 1302,	[unit_1302],	[unit_1302_help]	},	\
		{ 1303,	[unit_1303],	[unit_1303_help]	},	\
		{ 1304,	[unit_1304],	[unit_1304_help]	},	\
		{ 1305,	[unit_1305],	[unit_1305_help]	},	\
		{ 1306,	[unit_1306],	[unit_1306_help]	},	\
		{ 1307,	[unit_1307],	[unit_1307_help]	},	\
		{ 1308,	[unit_1308],	[unit_1308_help]	},	\
		{ 1309,	[unit_1309],	[unit_1309_help]	},	\
		{ 1310,	[unit_1310],	[unit_1310_help]	},	\
		{ 1311,	[unit_1311],	[unit_1311_help]	},	\
		{ 1312,	[unit_1312],	[unit_1312_help]	},	\
		{ 1313,	[unit_1313],	[unit_1313_help]	},	\
		{ 1314,	[unit_1314],	[unit_1314_help]	},	\
		{ 1315,	[unit_1315],	[unit_1315_help]	},	\
		{ 1316,	[unit_1316],	[unit_1316_help]	},	\
		{ 1317,	[unit_1317],	[unit_1317_help]	},	\
		{ 1318,	[unit_1318],	[unit_1318_help]	},	\
		{ 1319,	[unit_1319],	[unit_1319_help]	},	\
		{ 1320,	[unit_1320],	[unit_1320_help]	},	\
		{ 1321,	[unit_1321],	[unit_1321_help]	},	\
		{ 1322,	[unit_1322],	[unit_1322_help]	},	\
		{ 1323,	[unit_1323],	[unit_1323_help]	},	\
		{ 1324,	[unit_1324],	[unit_1324_help]	},	\
		{ 1325,	[unit_1325],	[unit_1325_help]	},	\
		{ 1326,	[unit_1326],	[unit_1326_help]	},	\
		{ 1327,	[unit_1327],	[unit_1327_help]	},	\
		{ 1328,	[unit_1328],	[unit_1328_help]	},	\
		{ 1329,	[unit_1329],	[unit_1329_help]	},	\
		{ 1330,	[unit_1330],	[unit_1330_help]	},	\
		{ 1331,	[unit_1331],	[unit_1331_help]	},	\
		{ 1332,	[unit_1332],	[unit_1332_help]	},	\
		{ 1333,	[unit_1333],	[unit_1333_help]	},	\
		{ 1334,	[unit_1334],	[unit_1334_help]	},	\
		{ 1335,	[unit_1335],	[unit_1335_help]	},	\
		{ 1336,	[unit_1336],	[unit_1336_help]	},	\
		{ 1337,	[unit_1337],	[unit_1337_help]	},	\
		{ 1338,	[unit_1338],	[unit_1338_help]	},	\
		{ 1339,	[unit_1339],	[unit_1339_help]	},	\
		{ 1340,	[unit_1340],	[unit_1340_help]	},	\
		{ 1341,	[unit_1341],	[unit_1341_help]	},	\
		{ 1342,	[unit_1342],	[unit_1342_help]	},	\
		{ 1343,	[unit_1343],	[unit_1343_help]	},	\
		{ 1344,	[unit_1344],	[unit_1344_help]	},	\
		{ 1345,	[unit_1345],	[unit_1345_help]	},	\
		{ 1346,	[unit_1346],	[unit_1346_help]	},	\
		{ 1347,	[unit_1347],	[unit_1347_help]	},	\
		{ 1348,	[unit_1348],	[unit_1348_help]	},	\
		{ 1349,	[unit_1349],	[unit_1349_help]	},	\
		{ 1350,	[unit_1350],	[unit_1350_help]	},	\
		{ 1351,	[unit_1351],	[unit_1351_help]	},	\
		{ 1352,	[unit_1352],	[unit_1352_help]	},	\
		{ 1353,	[unit_1353],	[unit_1353_help]	},	\
		{ 1354,	[unit_1354],	[unit_1354_help]	},	\
		{ 1355,	[unit_1355],	[unit_1355_help]	},	\
		{ 1356,	[unit_1356],	[unit_1356_help]	},	\
		{ 1357,	[unit_1357],	[unit_1357_help]	},	\
		{ 1358,	[unit_1358],	[unit_1358_help]	},	\
		{ 1359,	[unit_1359],	[unit_1359_help]	},	\
		{ 1360,	[unit_1360],	[unit_1360_help]	},	\
		{ 1361,	[unit_1361],	[unit_1361_help]	},	\
		{ 1362,	[unit_1362],	[unit_1362_help]	},	\
		{ 1363,	[unit_1363],	[unit_1363_help]	},	\
		{ 1364,	[unit_1364],	[unit_1364_help]	},	\
		{ 1365,	[unit_1365],	[unit_1365_help]	},	\
		{ 1366,	[unit_1366],	[unit_1366_help]	},	\
		{ 1367,	[unit_1367],	[unit_1367_help]	},	\
		{ 1368,	[unit_1368],	[unit_1368_help]	},	\
		{ 1369,	[unit_1369],	[unit_1369_help]	},	\
		{ 1370,	[unit_1370],	[unit_1370_help]	},	\
		{ 1371,	[unit_1371],	[unit_1371_help]	},	\
		{ 1372,	[unit_1372],	[unit_1372_help]	},	\
		{ 1373,	[unit_1373],	[unit_1373_help]	},	\
		{ 1374,	[unit_1374],	[unit_1374_help]	},	\
		{ 1375,	[unit_1375],	[unit_1375_help]	},	\
		{ 1376,	[unit_1376],	[unit_1376_help]	},	\
		{ 1377,	[unit_1377],	[unit_1377_help]	},	\
		{ 1378,	[unit_1378],	[unit_1378_help]	},	\
		{ 1379,	[unit_1379],	[unit_1379_help]	},	\
		{ 1380,	[unit_1380],	[unit_1380_help]	},	\
		{ 1381,	[unit_1381],	[unit_1381_help]	},	\
		{ 1382,	[unit_1382],	[unit_1382_help]	},	\
		{ 1383,	[unit_1383],	[unit_1383_help]	},	\
		{ 1384,	[unit_1384],	[unit_1384_help]	},	\
		{ 1385,	[unit_1385],	[unit_1385_help]	},	\
		{ 1386,	[unit_1386],	[unit_1386_help]	},	\
		{ 1387,	[unit_1387],	[unit_1387_help]	},	\
		{ 1388,	[unit_1388],	[unit_1388_help]	},	\
		{ 1389,	[unit_1389],	[unit_1389_help]	},	\
		{ 1390,	[unit_1390],	[unit_1390_help]	},	\
		{ 1391,	[unit_1391],	[unit_1391_help]	},	\
		{ 1392,	[unit_1392],	[unit_1392_help]	},	\
		{ 1393,	[unit_1393],	[unit_1393_help]	},	\
		{ 1394,	[unit_1394],	[unit_1394_help]	},	\
		{ 1395,	[unit_1395],	[unit_1395_help]	},	\
		{ 1396,	[unit_1396],	[unit_1396_help]	},	\
		{ 1397,	[unit_1397],	[unit_1397_help]	},	\
		{ 1398,	[unit_1398],	[unit_1398_help]	},	\
		{ 1399,	[unit_1399],	[unit_1399_help]	},	\
		{ 1400,	[unit_1400],	[unit_1400_help]	},	\
		{ 1401,	[unit_1401],	[unit_1401_help]	},	\
		{ 1402,	[unit_1402],	[unit_1402_help]	},	\
		{ 1403,	[unit_1403],	[unit_1403_help]	},	\
		{ 1404,	[unit_1404],	[unit_1404_help]	},	\
		{ 1405,	[unit_1405],	[unit_1405_help]	},	\
		{ 1406,	[unit_1406],	[unit_1406_help]	},	\
		{ 1407,	[unit_1407],	[unit_1407_help]	},	\
		{ 1408,	[unit_1408],	[unit_1408_help]	},	\
		{ 1409,	[unit_1409],	[unit_1409_help]	},	\
		{ 1410,	[unit_1410],	[unit_1410_help]	},	\
		{ 1411,	[unit_1411],	[unit_1411_help]	},	\
		{ 1412,	[unit_1412],	[unit_1412_help]	},	\
		{ 1413,	[unit_1413],	[unit_1413_help]	},	\
		{ 1414,	[unit_1414],	[unit_1414_help]	},	\
		{ 1415,	[unit_1415],	[unit_1415_help]	},	\
		{ 1416,	[unit_1416],	[unit_1416_help]	},	\
		{ 1417,	[unit_1417],	[unit_1417_help]	},	\
		{ 1418,	[unit_1418],	[unit_1418_help]	},	\
		{ 1419,	[unit_1419],	[unit_1419_help]	},	\
		{ 1420,	[unit_1420],	[unit_1420_help]	},	\
		{ 1421,	[unit_1421],	[unit_1421_help]	},	\
		{ 1422,	[unit_1422],	[unit_1422_help]	},	\
		{ 1423,	[unit_1423],	[unit_1423_help]	},	\
		{ 1424,	[unit_1424],	[unit_1424_help]	},	\
		{ 1425,	[unit_1425],	[unit_1425_help]	},	\
		{ 1426,	[unit_1426],	[unit_1426_help]	},	\
		{ 1427,	[unit_1427],	[unit_1427_help]	},	\
		{ 1428,	[unit_1428],	[unit_1428_help]	},	\
		{ 1429,	[unit_1429],	[unit_1429_help]	},	\
		{ 1430,	[unit_1430],	[unit_1430_help]	},	\
		{ 1431,	[unit_1431],	[unit_1431_help]	},	\
		{ 1432,	[unit_1432],	[unit_1432_help]	},	\
		{ 1433,	[unit_1433],	[unit_1433_help]	},	\
		{ 1434,	[unit_1434],	[unit_1434_help]	},	\
		{ 1435,	[unit_1435],	[unit_1435_help]	},	\
		{ 1436,	[unit_1436],	[unit_1436_help]	},	\
		{ 1437,	[unit_1437],	[unit_1437_help]	},	\
		{ 1438,	[unit_1438],	[unit_1438_help]	},	\
		{ 1439,	[unit_1439],	[unit_1439_help]	},	\
		{ 1440,	[unit_1440],	[unit_1440_help]	},	\
		{ 1441,	[unit_1441],	[unit_1441_help]	},	\
		{ 1442,	[unit_1442],	[unit_1442_help]	},	\
		{ 1443,	[unit_1443],	[unit_1443_help]	},	\
		{ 1444,	[unit_1444],	[unit_1444_help]	},	\
		{ 1445,	[unit_1445],	[unit_1445_help]	},	\
		{ 1446,	[unit_1446],	[unit_1446_help]	},	\
		{ 1447,	[unit_1447],	[unit_1447_help]	},	\
		{ 1448,	[unit_1448],	[unit_1448_help]	},	\
		{ 1449,	[unit_1449],	[unit_1449_help]	},	\
		{ 1450,	[unit_1450],	[unit_1450_help]	},	\
		{ 1451,	[unit_1451],	[unit_1451_help]	},	\
		{ 1452,	[unit_1452],	[unit_1452_help]	},	\
		{ 1453,	[unit_1453],	[unit_1453_help]	},	\
		{ 1454,	[unit_1454],	[unit_1454_help]	},	\
		{ 1455,	[unit_1455],	[unit_1455_help]	},	\
		{ 1456,	[unit_1456],	[unit_1456_help]	},	\
		{ 1457,	[unit_1457],	[unit_1457_help]	},	\
		{ 1458,	[unit_1458],	[unit_1458_help]	},	\
		{ 1459,	[unit_1459],	[unit_1459_help]	},	\
		{ 1460,	[unit_1460],	[unit_1460_help]	},	\
		{ 1461,	[unit_1461],	[unit_1461_help]	},	\
		{ 1462,	[unit_1462],	[unit_1462_help]	},	\
		{ 1463,	[unit_1463],	[unit_1463_help]	},	\
		{ 1464,	[unit_1464],	[unit_1464_help]	},	\
		{ 1465,	[unit_1465],	[unit_1465_help]	},	\
		{ 1466,	[unit_1466],	[unit_1466_help]	},	\
		{ 1467,	[unit_1467],	[unit_1467_help]	},	\
		{ 1468,	[unit_1468],	[unit_1468_help]	},	\
		{ 1469,	[unit_1469],	[unit_1469_help]	},	\
		{ 1470,	[unit_1470],	[unit_1470_help]	},	\
		{ 1471,	[unit_1471],	[unit_1471_help]	},	\
		{ 1472,	[unit_1472],	[unit_1472_help]	},	\
		{ 1473,	[unit_1473],	[unit_1473_help]	},	\
		{ 1474,	[unit_1474],	[unit_1474_help]	},	\
		{ 1475,	[unit_1475],	[unit_1475_help]	},	\
		{ 1476,	[unit_1476],	[unit_1476_help]	},	\
		{ 1477,	[unit_1477],	[unit_1477_help]	},	\
		{ 1478,	[unit_1478],	[unit_1478_help]	},	\
		{ 1479,	[unit_1479],	[unit_1479_help]	},	\
		{ 1480,	[unit_1480],	[unit_1480_help]	},	\
		{ 1481,	[unit_1481],	[unit_1481_help]	},	\
		{ 1482,	[unit_1482],	[unit_1482_help]	},	\
		{ 1483,	[unit_1483],	[unit_1483_help]	},	\
		{ 1484,	[unit_1484],	[unit_1484_help]	},	\
		{ 1485,	[unit_1485],	[unit_1485_help]	},	\
		{ 1486,	[unit_1486],	[unit_1486_help]	},	\
		{ 1487,	[unit_1487],	[unit_1487_help]	},	\
		{ 1488,	[unit_1488],	[unit_1488_help]	},	\
		{ 1489,	[unit_1489],	[unit_1489_help]	},	\
		{ 1490,	[unit_1490],	[unit_1490_help]	},	\
		{ 1491,	[unit_1491],	[unit_1491_help]	},	\
		{ 1492,	[unit_1492],	[unit_1492_help]	},	\
		{ 1493,	[unit_1493],	[unit_1493_help]	},	\
		{ 1494,	[unit_1494],	[unit_1494_help]	},	\
		{ 1495,	[unit_1495],	[unit_1495_help]	},	\
		{ 1496,	[unit_1496],	[unit_1496_help]	},	\
		{ 1497,	[unit_1497],	[unit_1497_help]	},	\
		{ 1498,	[unit_1498],	[unit_1498_help]	},	\
		{ 1499,	[unit_1499],	[unit_1499_help]	},	\
		{ 1500,	[unit_1500],	[unit_1500_help]	},	\
		{ 1501,	[unit_1501],	[unit_1501_help]	},	\
		{ 1502,	[unit_1502],	[unit_1502_help]	},	\
		{ 1503,	[unit_1503],	[unit_1503_help]	},	\
		{ 1504,	[unit_1504],	[unit_1504_help]	},	\
		{ 1505,	[unit_1505],	[unit_1505_help]	},	\
		{ 1506,	[unit_1506],	[unit_1506_help]	},	\
		{ 1507,	[unit_1507],	[unit_1507_help]	},	\
		{ 1508,	[unit_1508],	[unit_1508_help]	},	\
		{ 1509,	[unit_1509],	[unit_1509_help]	},	\
		{ 1510,	[unit_1510],	[unit_1510_help]	},	\
		{ 1511,	[unit_1511],	[unit_1511_help]	},	\
		{ 1512,	[unit_1512],	[unit_1512_help]	},	\
		{ 1513,	[unit_1513],	[unit_1513_help]	},	\
		{ 1514,	[unit_1514],	[unit_1514_help]	},	\
		{ 1515,	[unit_1515],	[unit_1515_help]	},	\
		{ 1516,	[unit_1516],	[unit_1516_help]	},	\
		{ 1517,	[unit_1517],	[unit_1517_help]	},	\
		{ 1518,	[unit_1518],	[unit_1518_help]	},	\
		{ 1519,	[unit_1519],	[unit_1519_help]	},	\
		{ 1520,	[unit_1520],	[unit_1520_help]	}	\


/***********************************************************************/
/*    RENAME Variables					   */
/***********************************************************************/

COLLECTION OF VARIABLE rename_value 	
{
    MEMBERS
    {
		PHYS_ST_REV,			phys_st_rev,					[blk_block_object_PHYSICAL];
		TRANS_ST_REV,			trans1_st_rev,					[blk_block_object_TRANSDUCER];
		FUNC_ST_REV,			func1_st_rev,					[blk_block_object_FUNCTION];
/*		TRANS_SELF_CAL_RESET,		trans1_self_calibration_cmd,			[trans_act_self_calibration_message];   */
    }
}

/***********************************************************************/
/*    Physical Block					    */
/***********************************************************************/

BLOCK physical_block
{
	TYPE	PHYSICAL;
	NUMBER	1;
}

VARIABLE phys_blk_reserve
{
	LABEL		[blk_reserved];
	HELP		[blk_reserved_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE phys_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		{	1,	[blk_block_object_PHYSICAL]	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[phys_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	2,	[phys_blk_parent_class_ACTUATOR]	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_class
{
	LABEL		[blk_class];
	HELP		[phys_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		DEFAULT_VALUE	250;
		{	250,	[not_used]		}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_dd_reference
{
	LABEL		[blk_dd_reference];
	HELP		[blk_dd_reference_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4);
	HANDLING	READ;
}

VARIABLE phys_blk_dd_rev
{
	LABEL		[blk_dd_rev];
	HELP		[blk_dd_rev_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2);
	HANDLING	READ;
}

VARIABLE phys_blk_profile
{
	LABEL		[blk_profile];
	HELP		[blk_profile_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		{ 0x4001,	[blk_profile_PA_COMPACT_A]	},
		{ 0x4002,	[blk_profile_PA_COMPACT_B]	},
		{ 0x4081,	[blk_profile_PA_SIMPLE_A]	},
		{ 0x4082,	[blk_profile_PA_SIMPLE_B]	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_profile_rev
{
	LABEL		[blk_profile_rev];
	HELP		[blk_profile_rev_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0300;
		{	0x025A,	"2.90"	},
		{	0x025B,	"2.91"	},
		{	0x025C,	"2.92"	},
		{	0x025D,	"2.93"	},
		{	0x025E,	"2.94"	},
		{	0x025F,		"2.95"	},
		{	0x0260,		"2.96"	},
		{	0x0261,		"2.97"	},
		{	0x0262,		"2.98"	},
		{	0x0263,		"2.99"	},
		{	0x0300,		"3.0"	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_execution_time
{
	LABEL		[blk_execution_time];
	HELP		[blk_execution_time_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(1);
	HANDLING	READ;
	
}

VARIABLE phys_blk_num_parameters
{
	LABEL		[blk_num_parameters];
	HELP		[blk_num_parameters_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE phys_blk_index_view_1
{
	LABEL		[blk_index_view_1];
	HELP		[blk_index_view_1_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE phys_blk_num_view_lists
{
	LABEL		[blk_num_view_lists];
	HELP		[blk_num_view_lists_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE phys_st_rev
{
	LABEL		[st_rev];
	HELP		[st_rev_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ;
}

VARIABLE phys_tag_desc
{
	LABEL		[tag_desc];		
	HELP		[tag_desc_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32);
	HANDLING	READ & WRITE;
}

VARIABLE phys_strategy
{
	LABEL		[strategy];		
	HELP		[strategy_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_alert_key
{
	LABEL		[alert_key];		
	HELP		[alert_key_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_target_mode
{
	LABEL		[target_mode];		
	HELP		[target_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08;
		{	0x08,	[mode_AUTO]				}
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_actual_mode
{
	LABEL		[actual_mode];		
	HELP		[actual_mode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]		}
	}
	HANDLING	READ;
}

VARIABLE phys_permitted_mode
{
	LABEL		[permitted_mode];		
	HELP		[permitted_mode_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]		}
	}
	HANDLING	READ;
}

VARIABLE phys_normal_mode
{
	LABEL		[normal_mode];		
	HELP		[normal_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE phys_current_state_alarm_sum
{
	LABEL		[current_state_alarm_sum];		
	HELP		[current_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]		}
	}
	HANDLING	READ;
}

VARIABLE phys_unacknowledged_state_alarm_sum
{
	LABEL		[unacknowledged_state_alarm_sum];		
	HELP		[unacknowledged_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]		}
	}
	HANDLING	READ;
}

VARIABLE phys_unreported_state_alarm_sum
{
	LABEL		[unreported_state_alarm_sum];		
	HELP		[unreported_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE phys_disabled_state_alarm_sum
{
	LABEL		[disabled_state_alarm_sum];		
	HELP		[disabled_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE phys_software_rev
{
	LABEL		[phys_software_revision];
	HELP		[phys_software_revision_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ;
}

VARIABLE phys_hardware_rev
{
	LABEL		[phys_hardware_revision];
	HELP		[phys_hardware_revision_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ;
}

VARIABLE phys_device_man_id
{
	LABEL		[phys_device_man_id];
	HELP		[phys_device_man_id_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0x9b;
		{ 0x9b,	"PMV"},
		{ 250,	[not_used]	},
		{ 251,	[none]		},
		{ 252,	[unknown]	},
		{ 253,	[special]	}
	}
	HANDLING	READ;
}

VARIABLE phys_device_id
{
	LABEL		[phys_device_type];
	HELP		[phys_device_type_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE DEVICE_TYPE;
	}
	HANDLING	READ;
}

VARIABLE phys_device_ser_num
{
	LABEL		[phys_serial_num];
	HELP		[phys_device_ser_num_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ;
}

#define DIA_HW_ELECTR			0x01000000		/* 0x00000001 */
#define DIA_HW_MECH				0x02000000		/* 0x00000002 */
#define DIA_TEMP_MOTOR			0x04000000		/* 0x00000004 */
#define DIA_TEMP_ELECTR			0x08000000		/* 0x00000008 */
#define DIA_MEM_CHKSUM			0x10000000		/* 0x00000010 */
#define DIA_MEASUREMENT			0x20000000		/* 0x00000020 */
#define DIA_NOT_INIT				0x40000000		/* 0x00000040 */
#define DIA_INIT_ERR				0x80000000		/* 0x00000080 */
#define DIA_ZERO_ERR				0x00010000		/* 0x00000100 */
#define DIA_SUPPLY				0x00020000		/* 0x00000200 */
#define DIA_CONF_INVAL			0x00040000		/* 0x00000400 */
#define DIA_WARMSTART			0x00080000		/* 0x00000800 */
#define DIA_COLDSTART			0x00100000		/* 0x00001000 */
#define DIA_MAINTENANCE			0x00200000		/* 0x00002000 */
#define DIA_CHARACT				0x00400000		/* 0x00004000 */
#define DIA_IDENT_VIOL			0x00800000		/* 0x00008000 */
#define EXTENSION_AVAILABLE		0x00000080		/* 0x80000000 */

VARIABLE phys_diagnosis
{
	LABEL		[phys_diagnosis];
	HELP		[phys_diagnosis_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (4)
	{
		{	0,						[dia_OK],					[dia_OK_help]					},
		{	DIA_HW_ELECTR,			[dia_HW_ELECTR],			[dia_HW_ELECTR_help]			},
		{	DIA_HW_MECH,			[dia_HW_MECH],				[dia_HW_MECH_help]				},
		{	DIA_TEMP_MOTOR,			[dia_TEMP_MOTOR],			[dia_TEMP_MOTOR_help]			},
		{	DIA_TEMP_ELECTR,		[dia_TEMP_ELECTR],			[dia_TEMP_ELECTR_help]			},
		{	DIA_MEM_CHKSUM,			[dia_MEM_CHKSUM],			[dia_MEM_CHKSUM_help]			},
		{	DIA_MEASUREMENT,		[dia_MEASUREMENT],			[dia_MEASUREMENT_help]			},
		{	DIA_NOT_INIT,			[dia_NOT_INIT],				[dia_NOT_INIT_help]				},
		{	DIA_INIT_ERR,			[dia_INIT_ERR],				[dia_INIT_ERR_help]				},
		{	DIA_ZERO_ERR,			[dia_ZERO_ERR],				[dia_ZERO_ERR_help]				},
		{	DIA_SUPPLY,				[dia_SUPPLY],				[dia_SUPPLY_help]				},
		{	DIA_CONF_INVAL,			[dia_CONF_INVAL],			[dia_CONF_INVAL_help]			},
		{	DIA_WARMSTART,			[dia_WARMSTART],			[dia_WARMSTART_help]			},
		{	DIA_COLDSTART,			[dia_COLDSTART],			[dia_COLDSTART_help]			},
		{	DIA_MAINTENANCE,		[dia_MAINTENANCE],			[dia_MAINTENANCE_help]			},
		{	DIA_CHARACT,			[dia_CHARACT],				[dia_CHARACT_help]				},
		{	EXTENSION_AVAILABLE,	[dia_EXTENSION_AVAILABLE],	[dia_EXTENSION_AVAILABLE_help]	}
	}
	HANDLING	READ;
}

VARIABLE phys_diagnosis_mask
{
	LABEL		[phys_diagnosis_mask];
	HELP		[phys_diagnosis_mask_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (4)
	{
		{	DIA_HW_ELECTR,			[dia_HW_ELECTR],			[dia_HW_ELECTR_help]			},
		{	DIA_HW_MECH,			[dia_HW_MECH],				[dia_HW_MECH_help]				},
		{	DIA_TEMP_MOTOR,			[dia_TEMP_MOTOR],			[dia_TEMP_MOTOR_help]			},
		{	DIA_TEMP_ELECTR,		[dia_TEMP_ELECTR],			[dia_TEMP_ELECTR_help]			},
		{	DIA_MEM_CHKSUM,			[dia_MEM_CHKSUM],			[dia_MEM_CHKSUM_help]			},
		{	DIA_MEASUREMENT,		[dia_MEASUREMENT],			[dia_MEASUREMENT_help]			},
		{	DIA_NOT_INIT,			[dia_NOT_INIT],				[dia_NOT_INIT_help]				},
		{	DIA_INIT_ERR,			[dia_INIT_ERR],				[dia_INIT_ERR_help]				},
		{	DIA_ZERO_ERR,			[dia_ZERO_ERR],				[dia_ZERO_ERR_help]				},
		{	DIA_SUPPLY,				[dia_SUPPLY],				[dia_SUPPLY_help]				},
		{	DIA_CONF_INVAL,			[dia_CONF_INVAL],			[dia_CONF_INVAL_help]			},
		{	DIA_WARMSTART,			[dia_WARMSTART],			[dia_WARMSTART_help]			},
		{	DIA_COLDSTART,			[dia_COLDSTART],			[dia_COLDSTART_help]			},
		{	DIA_MAINTENANCE,		[dia_MAINTENANCE],			[dia_MAINTENANCE_help]			},
		{	DIA_CHARACT,			[dia_CHARACT],				[dia_CHARACT_help]				},
		{	EXTENSION_AVAILABLE,	[dia_EXTENSION_AVAILABLE],	[dia_EXTENSION_AVAILABLE_help]	}
	}
	HANDLING	READ;
}

VARIABLE phys_write_locking						/* optional */
{
	LABEL		[phys_write_locking];
	HELP		[phys_write_locking_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	2457;
		{ 2457,		[off]	},
		{ 0,		[on]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_factory_reset						/* optional */
{
	LABEL		[phys_factory_reset];
	HELP		[phys_factory_reset_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0;
		{ 0,		[no_function]			},
		{ 1,		[factory_reset_PARAMS]	},
		{ 2506,		[phys_device_reset_cmd]	},
		{ 2712,		[factory_reset_ADDRESS]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_descriptor						/* optional */
{
	LABEL		[phys_descriptor];
	HELP		[phys_descriptor_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32)
	{
		DEFAULT_VALUE "PMV D3";// jonas
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_message							/* optional */
{
	LABEL		[phys_message];
	HELP		[phys_message_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32)
	{
		DEFAULT_VALUE "Positioner"; // jonas
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_install_date						/* optional */
{
	LABEL		"PMV Controlled Date";//[phys_install_date];
	HELP		"The date then the positioner was controlled by PMV";//[phys_install_date_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE "16.07.2002"; // 01.10.1999
	}
	HANDLING	READ;// & WRITE; jonas
}
VARIABLE phys_ident_number
{
	LABEL		[phys_ident_number];
	HELP		[phys_ident_number_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[phys_ident_number_PROFILE]		},
		{	3,	"Multivariable"}
	}
	HANDLING	READ & WRITE;
}

/*---------------------------------------------------------------------*/
/*    Physical Block: Actuator 										   */
/*---------------------------------------------------------------------*/


/***********************************************************************/
/*    Transducer Block: Actuator 									   */
/***********************************************************************/

BLOCK transducer_block_1
{
	TYPE	TRANSDUCER;
	NUMBER	1;
}

trans1_blk_reserve			LIKE VARIABLE	phys_blk_reserve
{
}

VARIABLE trans1_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	3,	[blk_block_object_TRANSDUCER]	}
	}
	HANDLING	READ;
}

VARIABLE trans1_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[trans_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	5,	[trans_blk_parent_class_VALVE]	}
	}
	HANDLING	READ;
}

VARIABLE trans1_blk_class
{
	LABEL		[blk_class];
	HELP		[trans_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	2,	[trans_act_blk_class_ELECTRO_PNEU]				},
		{	250,	[not_used] 							},
		{	251,	[none]								},
		{	252,	[unknown]							},
		{	253,	[special]							}
	}
	HANDLING	READ;
}

trans1_blk_dd_reference						LIKE VARIABLE	phys_blk_dd_reference
{											
}											
											
trans1_blk_dd_rev						LIKE VARIABLE	phys_blk_dd_rev
{											
}											
											
trans1_blk_profile						LIKE VARIABLE	phys_blk_profile
{											
}											
											
trans1_blk_profile_rev						LIKE VARIABLE	phys_blk_profile_rev
{											
}											
											
trans1_blk_execution_time					LIKE VARIABLE	phys_blk_execution_time
{											
}											
											
trans1_blk_num_parameters					LIKE VARIABLE	phys_blk_num_parameters
{											
}											
											
trans1_blk_index_view_1						LIKE VARIABLE	phys_blk_index_view_1
{											
}											
											
trans1_blk_num_view_lists					LIKE VARIABLE	phys_blk_num_view_lists
{											
}											
											
trans1_st_rev							LIKE VARIABLE	phys_st_rev
{											
}											
											
trans1_tag_desc						LIKE VARIABLE	phys_tag_desc
{											
}											
											
trans1_strategy							LIKE VARIABLE	phys_strategy
{											
}											
											
trans1_alert_key						LIKE VARIABLE	phys_alert_key
{											
}											

trans1_target_mode						LIKE VARIABLE	phys_target_mode
{
	REDEFINE TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08;
		{	0x08,	[mode_AUTO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]		}
	}
}

trans1_actual_mode					LIKE VARIABLE	phys_actual_mode
{
}

trans1_permitted_mode					LIKE VARIABLE	phys_permitted_mode
{
}

trans1_normal_mode					LIKE VARIABLE	phys_normal_mode
{
}

trans1_current_state_alarm_sum				LIKE VARIABLE	phys_current_state_alarm_sum
{
}

trans1_unacknowledged_state_alarm_sum		LIKE VARIABLE	phys_unacknowledged_state_alarm_sum
{
}

trans1_unreported_state_alarm_sum			LIKE VARIABLE	phys_unreported_state_alarm_sum
{
}

trans1_disabled_state_alarm_sum			LIKE VARIABLE	phys_disabled_state_alarm_sum
{
}




/*-------------------------------------------------------------------------------------*/
/*    Transducer Block: Actuator ELECTRO PNEUMATIC	   */
/*-------------------------------------------------------------------------------------*/

VARIABLE trans1_act_stroke_time_dec				/* optional */
{
	LABEL		[trans_act_stroke_time_dec];
	HELP		[trans_act_stroke_time_dec_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
			DEFAULT_VALUE	0.0;
	}
	CONSTANT_UNIT	[sec];
	HANDLING	READ;
}

VARIABLE trans1_act_stroke_time_inc				/* optional */
{
	LABEL		[trans_act_stroke_time_inc];
	HELP		[trans_act_stroke_time_inc_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
			DEFAULT_VALUE	0.0;
	}
	CONSTANT_UNIT	[sec];
	HANDLING	READ;
}


/*--- Table Object ----------------------------------------------------*/

VARIABLE trans1_tab_entry						/* optional */
{
	LABEL		[lin_tab_entry];
	HELP		[lin_tab_entry_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	1;
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_tab_min_number					/* optional */
{
	LABEL		[lin_tab_min_number];	
	HELP		[lin_tab_min_number_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	21;
	}
	HANDLING	READ;
}

VARIABLE trans1_tab_max_number					/* optional */
{
	LABEL		[lin_tab_max_number];	
	HELP		[lin_tab_max_number_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	21;
	}
	HANDLING	READ;
}

VARIABLE trans1_tab_actual_number				/* optional */
{
	LABEL		[lin_tab_actual_number];	
	HELP		[lin_tab_actual_number_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	33;
		{	3,	"3"		},
		{	5,	"5"		},
		{	9,	"9"		},
		{	17,	"17"		},
		{	33 , "33" 		}

	}
	HANDLING	READ & WRITE;
	VALIDITY    VALID_LIN_TABLE
}

VARIABLE trans1_tab_op_code						/* optional */
{
	LABEL		[lin_tab_op_code];	
	HELP		[lin_tab_op_code_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[lin_tab_op_code_NOT_INIT]		},
		{	1,	[lin_tab_op_code_START]			},
		{	3,	[lin_tab_op_code_END]			},
		{	4,	[lin_tab_op_code_DELETE_VALUE]		},
		{	5,	[lin_tab_op_code_INSERT_VALUE]		},
		{	6,	[lin_tab_op_code_REPLACE_VALUE]		}
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_tab_status						/* optional */
{
	LABEL		[lin_tab_status];	
	HELP		[lin_tab_status_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[lin_tab_status_NOT_INIT]		},
		{	1,	[lin_tab_status_GOOD]			},
		{	2,	[lin_tab_status_NOT_INC]		},
		{	3,	[lin_tab_status_NOT_DEC]		},
		{	4,	[lin_tab_status_NOT_ENOUGH_VALUES]	},
		{	5,	[lin_tab_status_TOO_MANY_VALUES]	},
		{	6,	[lin_tab_status_GRADIENT]		},
		{	7,	[lin_tab_status_NOT_ACCEPTED]		}
	}
	HANDLING	READ;
}

/*--- x|y-Value: Entry 0 ----------------------------------------------*/
		   

VARIABLE trans1_tab_y_gen					/* optional */
{
	LABEL		TAB_Y_LABEL_0;
	HELP		[lin_tab_y_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	CONSTANT_UNIT		[Percent];
	HANDLING	READ & WRITE;
	VALIDITY    VALID_LIN_TABLE
}
VARIABLE trans1_tab_x_gen					/* optional */
{
	LABEL		TAB_Y_LABEL_0;
	HELP		[lin_tab_y_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
 	}
	CONSTANT_UNIT		[Percent];
	HANDLING	READ & WRITE;
	VALIDITY    VALID_LIN_TABLE
}
VARIABLE trans1_tab_y_value_0					/* optional */
{
	LABEL		TAB_Y_LABEL_0;
	HELP		[lin_tab_y_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
		MIN_VALUE		0.0;
		MAX_VALUE		100.0;
	}
	CONSTANT_UNIT		[Percent];
	HANDLING	READ & WRITE;
	VALIDITY    VALID_LIN_TABLE
}

trans1_tab_x_value_0		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_X_LABEL_0;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (0),
		method_read_tab_size
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
 /*		method_start_table_transfer,	 */
		method_set_tab_entry (0),
		method_read_tab_size
	}
}

/*--- x|y-Value: Entry 1 ----------------------------------------------*/

trans1_tab_y_value_1		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_1;
	REDEFINE	DEFAULT_VALUE	5.0;
}

trans1_tab_x_value_1		LIKE VARIABLE	trans1_tab_y_value_1
{
	REDEFINE	LABEL			TAB_X_LABEL_1;
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (1)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (1)
	}
}


/*--- x|y-Value: Entry 2 ----------------------------------------------*/

trans1_tab_y_value_2		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_2;
	REDEFINE	DEFAULT_VALUE	10.0;
}

trans1_tab_x_value_2		LIKE VARIABLE	trans1_tab_y_value_2
{
	REDEFINE	LABEL			TAB_X_LABEL_2;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (2)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (2)
	}
}

/*--- x|y-Value: Entry 3 ----------------------------------------------*/

trans1_tab_y_value_3		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_3;
	REDEFINE	DEFAULT_VALUE	15.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_SMALL;
}

trans1_tab_x_value_3		LIKE VARIABLE	trans1_tab_y_value_3
{
	REDEFINE	LABEL			TAB_X_LABEL_3;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (3)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (3)
	}
}

/*--- x|y-Value: Entry 4 ----------------------------------------------*/

trans1_tab_y_value_4		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_4;
	REDEFINE	DEFAULT_VALUE	20.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_SMALL;
}

trans1_tab_x_value_4		LIKE VARIABLE	trans1_tab_y_value_4
{
	REDEFINE	LABEL			TAB_X_LABEL_4;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (4)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (4)
	}
}

/*--- x|y-Value: Entry 5 ----------------------------------------------*/

trans1_tab_y_value_5		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_5;
	REDEFINE	DEFAULT_VALUE	25.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_MEDIUM;
}

trans1_tab_x_value_5		LIKE VARIABLE	trans1_tab_y_value_5
{
	REDEFINE	LABEL			TAB_X_LABEL_5;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (5)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (5)
	}
}


/*--- x|y-Value: Entry 6 ----------------------------------------------*/

trans1_tab_y_value_6		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_6;
	REDEFINE	DEFAULT_VALUE	30.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_MEDIUM;
}

trans1_tab_x_value_6		LIKE VARIABLE	trans1_tab_y_value_6
{										
	REDEFINE	LABEL			TAB_X_LABEL_6;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (6)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (6)
	}
}										
										
/*--- x|y-Value: Entry 7 ----------------------------------------------*/

trans1_tab_y_value_7		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_7;
	REDEFINE	DEFAULT_VALUE	35.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_MEDIUM;
}

trans1_tab_x_value_7		LIKE VARIABLE	trans1_tab_y_value_7
{											
	REDEFINE	LABEL			TAB_X_LABEL_7;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (7)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (7)
	}
}											
											
/*--- x|y-Value: Entry 8 ----------------------------------------------*/

trans1_tab_y_value_8		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_8;
	REDEFINE	DEFAULT_VALUE	40.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_MEDIUM;

}

trans1_tab_x_value_8		LIKE VARIABLE	trans1_tab_y_value_8
{											
	REDEFINE	LABEL			TAB_X_LABEL_8;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (8)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (8)
	}
}											
											
/*--- x|y-Value: Entry 9 ----------------------------------------------*/

trans1_tab_y_value_9		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_9;
	REDEFINE	DEFAULT_VALUE	45.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_LARGE;

}

trans1_tab_x_value_9		LIKE VARIABLE	trans1_tab_y_value_9
{											
	REDEFINE	LABEL			TAB_X_LABEL_9;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (9)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (9)
	}
}											
											
/*--- x|y-Value: Entry 10 ---------------------------------------------*/

trans1_tab_y_value_10		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_10;
	REDEFINE	DEFAULT_VALUE	50.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_LARGE;

}

trans1_tab_x_value_10		LIKE VARIABLE	trans1_tab_y_value_10
{											
	REDEFINE	LABEL			TAB_X_LABEL_10;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (10)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (10)
	}
}											
											
/*--- x|y-Value: Entry 11 ---------------------------------------------*/

trans1_tab_y_value_11		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_11;
	REDEFINE	DEFAULT_VALUE	55.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_LARGE;
}

trans1_tab_x_value_11		LIKE VARIABLE	trans1_tab_y_value_11
{											
	REDEFINE	LABEL			TAB_X_LABEL_11;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (11)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (11)
	}
}											
											
/*--- x|y-Value: Entry 12 ---------------------------------------------*/

trans1_tab_y_value_12		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_12;
	REDEFINE	DEFAULT_VALUE	60.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_LARGE;
}

trans1_tab_x_value_12		LIKE VARIABLE	trans1_tab_y_value_12
{										
	REDEFINE	LABEL			TAB_X_LABEL_12;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (12)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (12)
	}
}										
										
/*--- x|y-Value: Entry 13 ---------------------------------------------*/

trans1_tab_y_value_13		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_13;
	REDEFINE	DEFAULT_VALUE	65.0;
    	REDEFINE 	VALIDITY    VALID_LIN_TABLE_LARGE;

}

trans1_tab_x_value_13		LIKE VARIABLE	trans1_tab_y_value_13
{										
	REDEFINE	LABEL			TAB_X_LABEL_13;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (13)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (13)
	}
}										
										
/*--- x|y-Value: Entry 14 ---------------------------------------------*/

trans1_tab_y_value_14		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_14;
	REDEFINE	DEFAULT_VALUE	70.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_LARGE;

}

trans1_tab_x_value_14		LIKE VARIABLE	trans1_tab_y_value_14
{											
	REDEFINE	LABEL			TAB_X_LABEL_14;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (14)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (14)
	}
}											
											
/*--- x|y-Value: Entry 15 ---------------------------------------------*/

trans1_tab_y_value_15		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_15;
	REDEFINE	DEFAULT_VALUE	75.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_LARGE;
}

trans1_tab_x_value_15		LIKE VARIABLE	trans1_tab_y_value_15
{										
	REDEFINE	LABEL			TAB_X_LABEL_15;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (15)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (15)
	}
}										
										
/*--- x|y-Value: Entry 16 ---------------------------------------------*/

trans1_tab_y_value_16		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_16;
	REDEFINE	DEFAULT_VALUE	80.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_LARGE;
}

trans1_tab_x_value_16		LIKE VARIABLE	trans1_tab_y_value_16
{											
	REDEFINE	LABEL			TAB_X_LABEL_16;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (16)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (16)
	}
}											
											
/*--- x|y-Value: Entry 17 ---------------------------------------------*/

trans1_tab_y_value_17		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_17;
	REDEFINE	DEFAULT_VALUE	85.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_17		LIKE VARIABLE	trans1_tab_y_value_17
{											
	REDEFINE	LABEL			TAB_X_LABEL_17;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (17)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (17)
	}
}											
											
/*--- x|y-Value: Entry 18 ---------------------------------------------*/

trans1_tab_y_value_18		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_18;
	REDEFINE	DEFAULT_VALUE	90.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;

}

trans1_tab_x_value_18		LIKE VARIABLE	trans1_tab_y_value_18
{											
	REDEFINE	LABEL			TAB_X_LABEL_18;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (18)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (18)
	}
}											
											
/*--- x|y-Value: Entry 19 ---------------------------------------------*/

trans1_tab_y_value_19		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_19;
	REDEFINE	DEFAULT_VALUE	95.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_19		LIKE VARIABLE	trans1_tab_y_value_19
{											
	REDEFINE	LABEL			TAB_X_LABEL_19;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (19)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (19)
	}
}											
											
/*--- x|y-Value: Entry 20 ---------------------------------------------*/

trans1_tab_y_value_20		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_20;
	REDEFINE	DEFAULT_VALUE	100.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_20		LIKE VARIABLE	trans1_tab_y_value_20
{											
	REDEFINE	LABEL			TAB_X_LABEL_20;
	REDEFINE	HELP			[lin_tab_y_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (20)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (20)
	}
}
											
/*--- x|y-Value: Entry 21 ---------------------------------------------*/

trans1_tab_y_value_21		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_21;
	REDEFINE	DEFAULT_VALUE	55.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_21		LIKE VARIABLE	trans1_tab_y_value_21
{											
	REDEFINE	LABEL			TAB_X_LABEL_21;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (21)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (21)
	}
}											
											
/*--- x|y-Value: Entry 22 ---------------------------------------------*/

trans1_tab_y_value_22		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_22;
	REDEFINE	DEFAULT_VALUE	60.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_22		LIKE VARIABLE	trans1_tab_y_value_22
{										
	REDEFINE	LABEL			TAB_X_LABEL_22;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (22)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (22)
	}
}										
										
/*--- x|y-Value: Entry 23 ---------------------------------------------*/

trans1_tab_y_value_23		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_23;
	REDEFINE	DEFAULT_VALUE	65.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_23		LIKE VARIABLE	trans1_tab_y_value_23
{										
	REDEFINE	LABEL			TAB_X_LABEL_23;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (23)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (23)
	}
}										
										
/*--- x|y-Value: Entry 24 ---------------------------------------------*/

trans1_tab_y_value_24		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_24;
	REDEFINE	DEFAULT_VALUE	70.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_24		LIKE VARIABLE	trans1_tab_y_value_24
{											
	REDEFINE	LABEL			TAB_X_LABEL_24;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (24)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (24)
	}
}											
											
/*--- x|y-Value: Entry 25 ---------------------------------------------*/

trans1_tab_y_value_25		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_25;
	REDEFINE	DEFAULT_VALUE	75.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_25		LIKE VARIABLE	trans1_tab_y_value_25
{										
	REDEFINE	LABEL			TAB_X_LABEL_25;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (25)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (25)
	}
}										
										
/*--- x|y-Value: Entry 26 ---------------------------------------------*/

trans1_tab_y_value_26		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_26;
	REDEFINE	DEFAULT_VALUE	80.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_26		LIKE VARIABLE	trans1_tab_y_value_26
{											
	REDEFINE	LABEL			TAB_X_LABEL_26;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (26)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (26)
	}
}											
											
/*--- x|y-Value: Entry 27 ---------------------------------------------*/

trans1_tab_y_value_27		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_27;
	REDEFINE	DEFAULT_VALUE	85.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;	
}

trans1_tab_x_value_27		LIKE VARIABLE	trans1_tab_y_value_27
{											
	REDEFINE	LABEL			TAB_X_LABEL_27;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (27)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (27)
	}
}											
											
/*--- x|y-Value: Entry 28 ---------------------------------------------*/

trans1_tab_y_value_28		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_28;
	REDEFINE	DEFAULT_VALUE	90.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_28		LIKE VARIABLE	trans1_tab_y_value_28
{											
	REDEFINE	LABEL			TAB_X_LABEL_28;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (28)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (28)
	}
}											
											
/*--- x|y-Value: Entry 29 ---------------------------------------------*/

trans1_tab_y_value_29		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_29;
	REDEFINE	DEFAULT_VALUE	95.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_29		LIKE VARIABLE	trans1_tab_y_value_29
{											
	REDEFINE	LABEL			TAB_X_LABEL_29;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (29)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (29)
	}
}											
/*--- x|y-Value: Entry 30 ---------------------------------------------*/
 trans1_tab_y_value_30		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_30;
	REDEFINE	DEFAULT_VALUE	95.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_30		LIKE VARIABLE	trans1_tab_y_value_30
{											
	REDEFINE	LABEL			TAB_X_LABEL_30;
	REDEFINE	HELP			[lin_tab_y_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (30)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (30)
	}
	DELETE		POST_WRITE_ACTIONS;
}
											
/*--- x|y-Value: Entry 31 ---------------------------------------------*/

trans1_tab_y_value_31		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_31;
	REDEFINE	DEFAULT_VALUE	95.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_31		LIKE VARIABLE	trans1_tab_y_value_31
{											
	REDEFINE	LABEL			TAB_X_LABEL_31;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (31)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (31)
	}
}											
											
/*--- x|y-Value: Entry 32 ---------------------------------------------*/

trans1_tab_y_value_32		LIKE VARIABLE	trans1_tab_y_value_0
{
	REDEFINE	LABEL			TAB_Y_LABEL_32;
	REDEFINE	DEFAULT_VALUE	100.0;
	REDEFINE 	VALIDITY    VALID_LIN_TABLE_VL;
}

trans1_tab_x_value_32		LIKE VARIABLE	trans1_tab_y_value_32
{										
	REDEFINE	LABEL			TAB_X_LABEL_32;
	REDEFINE	HELP			[lin_tab_x_value_help];
	REDEFINE	PRE_READ_ACTIONS
	{
		method_set_tab_entry (32)
	}
	REDEFINE	PRE_WRITE_ACTIONS
	{
		method_set_tab_entry (32)
	}
}
/*---------------------------------------------------------------------*/
VARIABLE trans1_deadband
{
	LABEL		[trans_act_deadband];
	HELP		[trans_act_deadband_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.5;
		MIN_VALUE		0.2;
		MAX_VALUE		20.0;
		DISPLAY_FORMAT ".1f" ;
		EDIT_FORMAT ".1f" ;
	}
	CONSTANT_UNIT	[Percent];
	HANDLING	READ & WRITE;
}

VARIABLE trans1_device_calib_date				/* optional */
{
	LABEL		[trans_act_device_calib_date];
	HELP		[trans_act_device_calib_date_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE "01.03.2000";
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_valve_ser_num			/* optional */
{
	LABEL		[phys_serial_num];
	HELP		[phys_valve_serial_num_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	   //	HANDLING	READ & WRITE;
    	HANDLING	READ & WRITE;
}
VARIABLE trans1_device_config_date				/* optional */
{
	LABEL		[trans_act_device_config_date];
	HELP		[trans_act_device_config_date_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE "01.03.2000";
	}
	   //	HANDLING	READ & WRITE;
	HANDLING	READ & WRITE;
}

VARIABLE trans1_lin_type
{
	LABEL		[trans_lin_type];
	HELP		[trans_lin_type_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{ 0,	[linear]					},
		{ 1,	"Custom Curve"},//[lin_type_TABLE]	},
		{ 10,	"Square Root"				},
		{ 50,	[lin_type_PERC_1_33]			},
		{ 51,	[lin_type_PERC_1_33_INVERSE]		}
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_actuator_action
{
	LABEL		[phys_actuator_action];
	HELP		"This value don't change the actuator. It's only for the user to know what happends when power loss";//[phys_actuator_action_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[phys_actuator_action_NOT_INIT]		},
		{	1,	[phys_actuator_action_OPEN]			},
		{	2,	[phys_actuator_action_CLOSE]			},
		{	3,	[phys_actuator_action_NONE]			}
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_additional_gear_ser_number		/* optional */
{
	LABEL		[phys_serial_num];
	HELP		[phys_additional_gear_serial_num_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ & WRITE;
}

VARIABLE trans1_additional_gear_id				/* optional */
{
	LABEL		[phys_device_id];
	HELP		[phys_device_id_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ & WRITE;
}

VARIABLE trans1_additional_gear_install_date		/* optional */
{
	LABEL		[phys_install_date];
	HELP		[phys_additional_gear_install_date_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE "01.03.2000";
	}
	HANDLING	READ & WRITE;
}


VARIABLE trans1_actuator_type
 {
	LABEL		[phys_actuator_type];
	HELP		[phys_actuator_type_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[phys_actuator_type_ELECTRO_PNEUMATIC]	}
	}
	HANDLING	READ;
}

VARIABLE trans1_rated_travel_value
{
	LABEL		[trans_act_rated_travel_value];
	HELP		[trans_act_rated_travel_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE		90;	// jonas
		MIN_VALUE		5;	// jonas
		MAX_VALUE		157;	// jonas
	}
	CONSTANT_UNIT
	IF	(	trans1_valve_type == 0)
		{
			"mm";
		}
	 ELSE
		{
			"deg";
		}
	HANDLING	
	IF	(	trans1_valve_type == 0)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
}

VARIABLE trans1_actuator_man
{
	LABEL		[phys_device_man_id];
	HELP		[phys_device_man_id_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ & WRITE;
}
VARIABLE trans1_actuator_ser_num		/* optional */
{
	LABEL		[phys_serial_num];
	HELP		[phys_actuator_serial_num_help];
	CLASS	CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ & WRITE;
}
VARIABLE trans1_self_calibration_cmd
{
	LABEL		[trans_act_self_calibration_cmd];
	HELP		[trans_act_self_calibration_cmd_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{ 0,	[no_function]		  			},
		{ 2,	[trans_act_self_calibration_cmd_START]		},  
		{ 3,	"autotune"					},
		{ 4,	"leak test"	 				},
		{ 255,	"abort"						}

	}
	HANDLING	READ & WRITE;

}

VARIABLE trans1_self_calibration_status
{
	LABEL		[trans_act_self_calibration_status];
	HELP		[trans_act_self_calibration_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	0;
		{ 0,		"Calibration OK"		},
		{ 1,		"Calibration running"		},
		{ 2,		"No movement of stroke"		},
		{ 3,	      "Potmeter failure"		},
		{ 4,		"Fast downstroke"		},
		{ 5,		"Fast upstroke"			},
		{ 16,		"Leaktest OK"			},
		{ 17,		"Leaktest running"		},
		{ 18,		"Leaktest leaking"		},
		{ 32,		"Tuning OK"			},
		{ 33,		"Pulse Tuning"			},
		{ 34,		"Step tuning"			}
	}
	HANDLING	READ;
}
VARIABLE trans1_servo_gain_1
{
	LABEL		"P";
	HELP		"P parameter is used for regulation";//[trans_servo_gain_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	5.0;
		MIN_VALUE		0.0;
		MAX_VALUE		1000.0;
//		MAX_VALUE		2875.0;			//hla 14.06.2007
	}
	HANDLING	READ & WRITE;

}
VARIABLE trans1_servo_rate_1
{
	LABEL		"D";
	HELP		"D parameter is used for regulation";//[trans_servo_rate_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.05;
		MIN_VALUE		0.0;
		MAX_VALUE		9999.99;
	}
	HANDLING	READ & WRITE;
}
VARIABLE trans1_servo_reset_1
{
	LABEL		"I";
	HELP		"I parameter is used for regulation";//[trans_servo_reset_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	1.0;
		MIN_VALUE		0.0;
		MAX_VALUE		256.0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_setp_cutoff_dec
{
	LABEL		"Cut Off Low Value";// [trans_act_setp_cutoff_dec];
	HELP		[trans_act_setp_cutoff_dec_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.1;
		MIN_VALUE		-20.0;
		MAX_VALUE		110.0;
	}
	CONSTANT_UNIT	[Percent];
	HANDLING	READ & WRITE;
}

VARIABLE trans1_setp_cutoff_inc
{
	LABEL		"Cut Off High Value";// [trans_act_setp_cutoff_inc];
	HELP		[trans_act_setp_cutoff_inc_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	99.9;
		MIN_VALUE		-10.0;
		MAX_VALUE		120.0;
	}
	CONSTANT_UNIT	[Percent];
	HANDLING	READ & WRITE;

}

VARIABLE trans1_additional_gear_man				/* optional */
{
	LABEL		[phys_device_man_id];
	HELP		[phys_device_man_id_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ & WRITE;
}


VARIABLE trans1_total_valve_travel				/* optional */
{
	LABEL		[trans_act_total_valve_travel];
	HELP		[trans_act_total_valve_travel_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING	READ;
}

VARIABLE trans1_total_valve_travel_limit		/* optional */
{
	LABEL		[trans_act_total_valve_travel_limit];
	HELP		[trans_act_total_valve_travel_limit_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	1.0e+15;
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_travel_limit_lower_value
{
	LABEL		"Limit Low Value";// [trans_act_travel_limit_lower_value];
	HELP		[trans_act_travel_limit_lower_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
		MIN_VALUE		-20.0;
		MAX_VALUE		110.0;
	}
	CONSTANT_UNIT	[Percent];
	HANDLING	READ & WRITE;
}
VARIABLE trans1_valve_type
{
	LABEL		[phys_valve_type];
	HELP		"Linear or Rotating Actuator. Linear gets the ability to change stroke length.";//[phys_valve_type_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	1;// jonas
		{	0,		"Linear"	},
		{	1,		"Rotating"	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_travel_limit_upper_value
{
	LABEL		"Limit High Value";//[trans_act_travel_limit_upper_value];
	HELP		[trans_act_travel_limit_upper_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	100.0;
		MIN_VALUE		-10.0;
		MAX_VALUE		120.0;
	}
	CONSTANT_UNIT	[Percent];
	HANDLING	READ & WRITE;
}

VARIABLE trans1_travel_rate_dec
{
	LABEL		[trans_act_travel_time_dec];
	HELP		[trans_act_travel_time_dec_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
		MIN_VALUE		0.0;
		MAX_VALUE		600.0;
	}
	CONSTANT_UNIT	[sec];
	HANDLING	READ & WRITE;
}

VARIABLE trans1_travel_rate_inc
{
	LABEL		[trans_act_travel_time_inc];
	HELP		[trans_act_travel_time_inc_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
		MIN_VALUE		0.0;
		MAX_VALUE		600.0;
	}
	CONSTANT_UNIT	[sec];
	HANDLING	READ & WRITE;
}

 VARIABLE trans1_valve_man
{
	LABEL		[phys_device_man_id];
	HELP		[phys_device_man_id_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ & WRITE;
}

VARIABLE trans1_valve_maintenance_date			/* optional */
{
	LABEL		[trans_act_valve_maintenance_date];
	HELP		[trans_act_valve_maintenance_date_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE "01.03.2000";
	}
	HANDLING	READ & WRITE;

}

VARIABLE trans1_positioning_value
{
	LABEL		[trans_act_positioning_value];
	HELP		[trans_act_positioning_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	CONSTANT_UNIT	[Percent];
	HANDLING	READ;
}

VARIABLE trans1_positioning_status_quality
{
	LABEL		[status_quality];
	HELP		[trans_act_positioning_status_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	HANDLING	READ & WRITE;
}
 
trans1_positioning_status_limit				LIKE VARIABLE	trans1_positioning_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_OUTPUT_LIMIT
	}
}
 
VARIABLE trans1_feedback_value
{
	LABEL		[trans_act_feedback_value];
	HELP		[trans_act_feedback_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	CONSTANT_UNIT	[Percent];
	HANDLING	READ;
}

VARIABLE trans1_feedback_status_quality
{
	LABEL		[status_quality];
	HELP		[trans_act_feedback_status_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_OUTPUT_NO_RCAS
	}
	HANDLING	READ;
}
 
trans1_feedback_status_limit				LIKE VARIABLE	trans1_feedback_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_OUTPUT_LIMIT
	}
}
/*------------------------------------------------------------*/

/*        D3 specific variables    */


/*-----------------------------------------------------------*/
 				
VARIABLE setpoint_mode_code
{ 
	LABEL		"Setpoint Source";
	HELP		"The user may select from where D3 shall take its setpoint";
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		{	1,	"Local Override"	},
		{	0,	"PROFIbus"		}
	}
	HANDLING	READ & WRITE;	 
}
 VARIABLE        acc_travel
{ 
	LABEL		"accumulated travel";
	HELP		"Accumulated travel is the accumulated value for the travel range for the valve. The unit is % of travel range" ;
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	CONSTANT_UNIT  [Percent];
	HANDLING	READ;
}


VARIABLE        n_cycles 
{
	LABEL		"No of cycles";
	HELP		"Accumulated travel divided by two times the travel range gives the number of travel cycles for the valve.";
	CLASS		CONTAINED;
	TYPE		INTEGER (2);
	HANDLING	READ;
} 
 VARIABLE        acc_dev
{ 
	LABEL   	"Mean Deviation.";
	HELP		"The mean value for the deviation between setpoint and actual position of the valve.";
	CLASS   CONTAINED; 
 	TYPE FLOAT
	{ 
		DEFAULT_VALUE  0.0;
	}
	HANDLING   READ;
	CONSTANT_UNIT [Percent];
}
VARIABLE		lever_length
{
	LABEL	"Stroke Length"; // jonas
	HELP		"The stroke length of the valve. Valve type linear gets the ability to change stroke length";
	CLASS 	CONTAINED;
	TYPE INTEGER (2)
	{
		DEFAULT_VALUE	50;		// jonas
		MIN_VALUE		5;		// jonas
		MAX_VALUE		157;		// jonas
	}
	CONSTANT_UNIT	"mm";	
    	HANDLING	
	IF	(trans1_valve_type == 0)
		{
			READ & WRITE;
		}
	 ELSE
		{
			READ;
		}
}
VARIABLE gain
{
	LABEL		"Gain";
	HELP		"Regulator gain";
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	1.0;
		MIN_VALUE		0.0;
		MAX_VALUE		2.0; // jonas
	}
	HANDLING	READ & WRITE;
}
 
VARIABLE    travel_control_high
{ 
	LABEL		"Travel Control High End";
	HELP		"The user may specify the operation of the valve at the high end";
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE 1;// jonas
		{	0,	"No Action"	},
		{	1,	"Cut Off"	},
		{	2,	"Limited"	}
	}
	HANDLING	READ & WRITE;
}
VARIABLE    travel_control_low
{ 
	LABEL		"Travel Control Low End";
	HELP		"The user may specify the operation of the valve at the low end";
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE 1;// jonas
		{	0,	"No Action"	},
		{	1,	"Cut Off"	},
		{	2,	"Limited"	}
	}
	HANDLING	READ & WRITE;
}


 /* - - - - - - - - - - -
 ---------------------------------------------------------------*/
 /* from 'display'Menu */

VARIABLE        language_code
{ 
	LABEL   	"Language";
	HELP		"The user can select the language used for the local display";
	CLASS   CONTAINED; 
	TYPE ENUMERATED (1)
	{
		{   0, "English"  },   
		{   1, "Svenska"  }, 
		{   2, "Deutsch"  }, 
		{   3, "Franais"  },
		{   4, "Italiano"  },
		{   5, "Espaol"  }
	}
	HANDLING	READ & WRITE;
}

VARIABLE        display_code 
{
	LABEL   	"Default Display";
	HELP		"The user can select the default menu on the local display"; 
	CLASS   CONTAINED; 
	TYPE ENUMERATED (1)
	{ 
		{   0, "Position"  },
		{   1, "Setpoint + Position"  },  
		{   2, "Setpoint + Deviation"  },  
		{   3, "Menu" }   
	}
	HANDLING	READ & WRITE;
}

/* - - - - - - - - - - -
----------------------------------------------------------------------*/

/*  menu 'protection' */ /* Change password */


 VARIABLE        write_protect_pw
{ 
	LABEL   "Write Protect Password";
	HELP	"Password for the local display. It is used for write protection. Leagal passwords are numbers in the range 0000-9999";
	CLASS   CONTAINED; 
	TYPE UNSIGNED_INTEGER (2)
	{ 
		MAX_VALUE 9999;
		DEFAULT_VALUE 0;
	}
	HANDLING   WRITE; 
 
}
VARIABLE        reset_pw
{ 
	LABEL   "Reset Password";
	HELP	"Password for the local display. It is used for reset protection. Leagal passwords are numbers in the range 0000-9999";
	CLASS   CONTAINED; 
	TYPE UNSIGNED_INTEGER (2)
	{ 
		MAX_VALUE 9999;
		DEFAULT_VALUE 0;
	}
	HANDLING   WRITE; 
 
}

VARIABLE        advanced_m_pw
{ 
	LABEL   "Full Menu Password";
	HELP	"Password for the local display. The password is required to enter the configuration menus from the local display. Leagal passwords are numbers in the range 0000-9999";
	CLASS   CONTAINED; 
	TYPE UNSIGNED_INTEGER (2)
	{ 
		MAX_VALUE 9999;
		DEFAULT_VALUE 0;
	}
	HANDLING   WRITE; 
}
VARIABLE        expert_m_pw 
{
	LABEL   "Expert Menu Password";
	HELP	"Password for the local display. It is used to protect tuning of local control parameters. Leagal passwords are numbers in the range 0000-9999";
	CLASS   CONTAINED; 
	TYPE UNSIGNED_INTEGER (2)
	{ 
		MAX_VALUE 9999;
		DEFAULT_VALUE 0;
	}
	HANDLING   WRITE; 
} 
VARIABLE actuator_function
{ 
	LABEL   "Actuator function";
	HELP		"Single acting and double acting actuators are supported";
	CLASS   CONTAINED; 
 	TYPE ENUMERATED (1)
	{
		{  1, "Single acting" }, 
		{  0, "Double acting" } 
	}
	HANDLING	READ & WRITE;
}
 
VARIABLE dev_alarm_stat_code
{ 
	LABEL   "Deviation Alarm";
	HELP		"Enables the alarm position - setpoint deviation alarm evaluation";
	CLASS   CONTAINED; 
 	TYPE ENUMERATED (1)
	{
		DEFAULT_VALUE	0;	// jonas
		{  0, "Off" }, 
		{  1, "On" } 
	}
	HANDLING	READ & WRITE;
}
VARIABLE	dev_alarm_distance
{ 
	LABEL   "Deviation Limit";
	HELP		"The deviation alarm limit";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	10.0;
		MIN_VALUE		0.0;	// jonas
		MAX_VALUE		99.9;	// jonas
	}
	HANDLING	READ & WRITE;
	CONSTANT_UNIT [Percent];  
}
VARIABLE	dev_alarm_time 
{
	LABEL   "Deviation Time To Trigger";
	HELP	"The time that a alarm shall persists before the alarm is triggered";
	CLASS CONTAINED;
	TYPE FLOAT 
	{
		DEFAULT_VALUE	10.0; 
		MIN_VALUE		0.1; 	// hla	14.06.2007
		MAX_VALUE		120.0; 	// hla	14.06.2007
//		MIN_VALUE		0.0; 	// jonas
//		MAX_VALUE		99.9; 	// joans
	}			    
	CONSTANT_UNIT [sec]; 
	HANDLING	READ & WRITE;
} 
VARIABLE	dev_en_output
{ 
	LABEL   "Deviation Alarm Output";
	HELP	"Enables the valave output action for the alarm";
 	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE	1;	// jonas
		{  0, "Off" },
		{  1, "On"	} 
	}
	HANDLING	READ & WRITE;
}

 VARIABLE	dev_valve_action
{ 
	LABEL   "Deviation Alarm Valve Action";
	HELP	"The action that a valve will take in case of alarm";
	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE	0;	// jonas
		{  0, "Do Nothing" }, 
		{  1, "Goto Open"	},
		{  2, "Goto Close" }, 
		{  3, "Manual" } 
	}
	HANDLING	READ & WRITE; 
} 


VARIABLE limit2_alarm_stat_code
{ 
	LABEL   "Limit Alarm";
	HELP		"Enables the alarm limit alarm evaluation";
	CLASS   CONTAINED; 
 	TYPE ENUMERATED (1)
	{
		DEFAULT_VALUE	0;	// jonas
		{  0, "Off" }, 
		{  1, "On" } 
	}
	HANDLING	READ & WRITE;
}

VARIABLE	limit2_position_min
{ 
	LABEL   "Limit Lo-Lo Alarm";
	HELP	"Limit lower alarm position";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	0.0;
		MIN_VALUE		-20.0;	// jonas
		MAX_VALUE		120.0;	// jonas
	}
	CONSTANT_UNIT [Percent];
	HANDLING	READ & WRITE; 
} 
               
VARIABLE	limit2_position_max
{ 
	LABEL   "Limit Hi-Hi Alarm";
	HELP	"Limit higher alarm position";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	100.0;
		MIN_VALUE		-20.0; // jonas
		MAX_VALUE		120.0; // jonas
	}
	CONSTANT_UNIT [Percent];
	HANDLING	READ & WRITE; 
} 
VARIABLE	limit2_hysteresis
{ 
	LABEL   "Limit Hysteresis";
	HELP	"Limit lower alarm hysteresis";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	2.0; // jonas
		MIN_VALUE		0.0; // jonas
		MAX_VALUE		20.0; // jonas
	}
	CONSTANT_UNIT [Percent];
	HANDLING	READ & WRITE;
} 
VARIABLE	limit2_en_output
{ 
	LABEL   "Limit Alarm Output";
	HELP	"Enables the valave output action for the alarm";
 	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE	0;	// jonas
		{  0, "Off" },
		{  1, "On"	} 
	}
	HANDLING	READ & WRITE;
}

VARIABLE	limit2_valve_action
{ 
	LABEL   "Limit2 Alarm Valve Action";
	HELP	"The action that a valve will take in case of alarm";
	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE	0;	// jonas
		{  0, "Do Nothing" }, 
		{  1, "Goto Open"},
		{  2, "Goto Close" }, 
		{  3, "Manual" } 
	}
	HANDLING	READ & WRITE;
} 
VARIABLE limit1_alarm_stat_code
{ 
	LABEL   "Limit Alarm";
	HELP		"Enables the alarm limit alarm evaluation";
	CLASS   CONTAINED; 
 	TYPE ENUMERATED (1)
	{
		DEFAULT_VALUE	0;	// jonas
		{  0, "Off" }, 
		{  1, "On" } 
	}
	HANDLING	READ & WRITE;
}

VARIABLE	limit1_position_min
{ 
	LABEL   "Limit Lo Alarm";
	HELP	"Limit lower alarm position";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	0.0;
		MIN_VALUE		-20.0; // jonas
		MAX_VALUE		120.0; // jonas
	}
	CONSTANT_UNIT [Percent];
	HANDLING	READ & WRITE; 
} 
               
VARIABLE	limit1_position_max
{ 
	LABEL   "Limit Hi Alarm";
	HELP	"Limit higher alarm position";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	100.0;
		MIN_VALUE		-20.0; // jonas
		MAX_VALUE		120.0; // jonas
	}
	CONSTANT_UNIT [Percent];
	HANDLING	READ & WRITE;
} 
VARIABLE	limit1_hysteresis
{ 
	LABEL   "Limit Hysteresis";
	HELP	[limit_hysteresis_help];//"Limit lower alarm hysteresis";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	2.0; // jonas
		MIN_VALUE		0.0; // jonas
		MAX_VALUE		20.0; // jonas
	}
	CONSTANT_UNIT [Percent];
	HANDLING	READ & WRITE;
} 
VARIABLE	limit1_en_output
{ 
	LABEL   "Limit Alarm Output";
	HELP	"Enables the valave output action for the alarm";
 	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE	0;	// jonas
		{  0, "Off" },
		{  1, "On"	} 
	}
	HANDLING	READ & WRITE;
}

 VARIABLE	limit1_valve_action
{ 
	LABEL   "Limit Alarm Valve";
	HELP	"The action that a valve will take in case of alarm";
	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE	0;	// jonas
		{  0, "Do Nothing" }, 
		{  1, "Goto Open"	},
		{  2, "Goto Close" }, 
		{  3, "Manual" } 
	}
	HANDLING	READ & WRITE;
}
VARIABLE aux_alarm_stat_code
{ 
	LABEL   "Aux Alarm";
	HELP		"Enables the alarm auxillary input alarm evaluation";
	CLASS   CONTAINED; 
 	TYPE ENUMERATED (1)
	{
		DEFAULT_VALUE	0;	// jonas
		{  0, "Off" }, 
		{  1, "On" } 
	}
	HANDLING	READ & WRITE;
}

VARIABLE	aux_min_value
{ 
	LABEL   "Aux Min Alarm";
	HELP	"Auxillary input lower alarm position";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	0.0;	// jonas
		MIN_VALUE		-20.0; // jonas
		MAX_VALUE		110.0; // jonas
	}
	CONSTANT_UNIT [Percent];
	HANDLING	READ & WRITE;
} 
               
VARIABLE	aux_max_value
{ 
	LABEL   "Aux Max Alarm";
	HELP	"Auxillary input higher alarm position";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	100.0;	// jonas
		MIN_VALUE		-10.0; // jonas
		MAX_VALUE		120.0; // jonas
	}
	CONSTANT_UNIT [Percent];
	HANDLING	READ & WRITE;
} 
VARIABLE	aux_hysteresis
{ 
	LABEL   "Aux Hysteresis";
	HELP	"Auxillary input alarm hysteresis";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	2.0;	// jonas
	}
	CONSTANT_UNIT [Percent];
	HANDLING	READ & WRITE;
} 
VARIABLE	aux_en_output
{ 
	LABEL   "Aux Alarm Output";
	HELP	"Enables the valave output action for the alarm";
 	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE	0;	// jonas
		{  0, "Off" },
		{  1, "On"	} 
	}
	HANDLING	READ & WRITE;
}

 VARIABLE	aux_valve_action
{ 
	LABEL   "Aux Alarm Valve Action";
	HELP	"The action that a valve will take in case of alarm";
	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE	0;	// jonas
		{  0, "Do Nothing" }, 
		{  1, "Goto Open"	},
		{  2, "Goto Close" }, 
		{  3, "Manual" } 
	}
	HANDLING	READ & WRITE;
}

VARIABLE temp_alarm_stat_code
{ 
	LABEL   "Temp Alarm";
	HELP		"Enables the temperature alarm evaluation";
	CLASS   CONTAINED; 
 	TYPE ENUMERATED (1)
	{
		DEFAULT_VALUE	0;	// jonas
		{  0, "Off" }, 
		{  1, "On" } 
	}
	HANDLING	READ & WRITE;
}

VARIABLE	temp_min
{ 
	LABEL   "Temp Min Alarm";
	HELP	"Auxillary input lower alarm position";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
	}
	HANDLING	READ & WRITE;
} 
               
VARIABLE	temp_max
{ 
	LABEL   "Temp Max Alarm";
	HELP	"Temperature higher alarm position";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
	}
	HANDLING	READ & WRITE;
} 
VARIABLE	temp_hysteresis
{ 
	LABEL   "Temp Hysteresis";
	HELP	"Temperature Alarm Hysteresis";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
	}
	HANDLING	READ & WRITE;
} 
VARIABLE	temp_en_output
{ 
	LABEL   "Temp Alarm Output";
	HELP	"Enables the valve output action for the alarm";
 	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE	0;	// jonas
		{  0, "Off" },
		{  1, "On"	} 
	}
	HANDLING	READ & WRITE;
}

 VARIABLE	temp_valve_action
{ 
	LABEL   "Temp Alarm Valve Action";
	HELP	"The action that a valve will take in case of alarm";
	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE	0;	// jonas
		{  0, "Do Nothing" }, 
		{  1, "Goto Open"	},
		{  2, "Goto Close" }, 
		{  3, "Manual" } 
	}
	HANDLING	READ & WRITE;
}


VARIABLE diff_alarm_stat_code
{ 
	LABEL   "Diff Alarm";
	HELP		"Enables the difference beween setpoint and valve position, alarm evaluation";
	CLASS   CONTAINED; 
 	TYPE ENUMERATED (1)
	{
		DEFAULT_VALUE	0;	// jonas
		{  0, "Off" }, 
		{  1, "On" } 
	}
	HANDLING	READ & WRITE;
}
             
VARIABLE	diff_alarm_distance
{ 
	LABEL   "Diff Alarm Distance";
	HELP	"The distance between setpoint and the regulated postion, that will trigger an alarm";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	10.0;
		MIN_VALUE		0.0;		//hla 14.06.2007
		MAX_VALUE		100.0;		//hla 14.06.2007
	}
	HANDLING	READ & WRITE;
} 

VARIABLE	diff_en_output
{ 
	LABEL   "Diff Alarm Output";
	HELP	"Enables the valave output action for the alarm";
 	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE	0;	// jonas
		{  0, "Off" },
		{  1, "On"	} 
	}
	HANDLING	READ & WRITE;
}

 VARIABLE	diff_valve_action
{ 
	LABEL   "Diff Alarm Valve Action";
	HELP	"The action that a valve will take in case of alarm";
	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE	0;	// jonas
		{  0, "Do Nothing" }, 
		{  1, "Goto Open"	},
		{  2, "Goto Close" }, 
		{  3, "Manual" } 
	}
	HANDLING	READ & WRITE;
}


/* ----Menus from Tuning -------------------------------------------*/


VARIABLE        toggle_time 
{
	LABEL   "Toggle Time";
	HELP	"The user can figure a time for toggling of the valve. Toggling could be used for test and debug purposes";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	1.0;
	}
	HANDLING READ & WRITE;
	CONSTANT_UNIT [sec];
} 
VARIABLE        toggle_period 
{
	LABEL   "Toggle Period";
	HELP	"The user can figure a periode for toggling of the valve. Toggling could be used for test and debug purposes";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	1.0;
	}
	HANDLING READ & WRITE;
	CONSTANT_UNIT [sec];
}
VARIABLE        toggle_amplitude 
{
	LABEL   "Toggle Amplitude";
	HELP	"The user can figure the amplitude of the toggling signal for the valve. Toggling could be used for test and debug purposes";
	CLASS CONTAINED;
	TYPE FLOAT
	{ 
		DEFAULT_VALUE	1.0;
	}
	HANDLING READ & WRITE;
	CONSTANT_UNIT [Percent];
}
VARIABLE	toggle_enable
{ 
	LABEL   "En/diable Toggle";
	HELP	"Starts and stops togle";
	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE  0;
		{0, "Stop" }, 
		{1, "Start"	}
	}
	HANDLING WRITE; 
}


 VARIABLE	actuator_size

{ 
	LABEL   "Actuator Size";
	HELP	"Storage for the size of the actuator. This parameter is used for waitig time in travelcalibration";
	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE 	1; // jonas
		{  0, "Small" }, 
		{  1, "Medium"	},
		{  2, "Large" }, 
		{  3, "Extra Large" } 
	}
	HANDLING	READ & WRITE;
}    
 VARIABLE	failsafe_alarm_en_out
{ 
	LABEL   "Failsafe Output";
	HELP	"Enables the alarm output for the failsafe";
 	CLASS CONTAINED;
	TYPE ENUMERATED (1)
	{ 
		DEFAULT_VALUE 	0; // jonas
		{  0, "Off" },
		{  1, "On"	} 
	}
	HANDLING	READ & WRITE;
}
 
 /* ---------------------------------------------------------- */


 /*		* *  Definition of Commands			 * */


 /* ------------------------------------------------------------ */
/* -----   		Device specific commands ----- */ 
/* --------------------------------------------------------------- */


COMMAND    write_setpoint_mode
{ 
	BLOCK transducer_block_1;
	INDEX 80;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			setpoint_mode_code
		}
		REPLY
		{
		}
	}
}
COMMAND    read_setpoint_mode
{ 
	BLOCK transducer_block_1;
	INDEX 80;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			setpoint_mode_code
		}
	}
}

COMMAND    read_acc_travel
{ 
	BLOCK transducer_block_1;
	INDEX 81;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			acc_travel
		}
	} 
}
COMMAND    read_n_cycles
{ 
	BLOCK transducer_block_1;
	INDEX 82;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			n_cycles		
		}
	} 
} 
COMMAND    read_acc_dev
{ 
	BLOCK transducer_block_1;
	INDEX 83;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			acc_dev
		}
	} 
}
COMMAND    write_lever_length
{ 
	BLOCK transducer_block_1;
	INDEX 87;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			lever_length
		}
		REPLY
		{
		}
	}
}
COMMAND    read_lever_length
{ 
	BLOCK transducer_block_1;
	INDEX 87;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			lever_length
		}
	}
}
COMMAND    write_gain
{ 
	BLOCK transducer_block_1;
	INDEX 88;	  
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			gain
		}
		REPLY
		{
		}
	}
}
COMMAND    read_gain
{ 
	BLOCK transducer_block_1;
	INDEX 88;	  
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			gain
		}
	}
}

COMMAND    write_travel_control_high
{ 
	BLOCK transducer_block_1;
	INDEX 93;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			travel_control_high
		}
		REPLY
		{
		}
	}
}
COMMAND    read_travel_control_high
{ 
	BLOCK transducer_block_1;
	INDEX 93;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			travel_control_high
		}
	}
}
COMMAND    write_travel_control_low
{ 
	BLOCK transducer_block_1;
	INDEX 94;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			travel_control_low
		}
		REPLY
		{
		}
	}
}
COMMAND    read_travel_control_low
{ 
	BLOCK transducer_block_1;
	INDEX 94;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			travel_control_low
		}
	}
}
COMMAND    set_actuator_function 
{
 
	BLOCK transducer_block_1;
	INDEX 102;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			actuator_function
		}
		REPLY
		{
		}
	}
}
COMMAND    read_actuator_function
{ 
	BLOCK transducer_block_1;
	INDEX 102;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			actuator_function
		}
	}
}
COMMAND    set_language 
{
 
	BLOCK transducer_block_1;
	INDEX 104;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			language_code
		}
		REPLY
		{
		}
	}
}
COMMAND    read_language
{ 
	BLOCK transducer_block_1;
	INDEX 104;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			language_code
		}
	}
}

COMMAND    set_default_display 
{ 
	BLOCK transducer_block_1;
	INDEX 105;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			display_code
		}
		REPLY
		{
		}
	}
}
COMMAND    read_display_code
{ 
	BLOCK transducer_block_1;
	INDEX 105;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			display_code
		}
	}
}
COMMAND    write_prot_password
{ 
	BLOCK transducer_block_1;
	INDEX 106;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			write_protect_pw
		}
		REPLY
		{
		}
	}
}
COMMAND    write_reset_pw
{ 
	BLOCK transducer_block_1;
	INDEX 107;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			reset_pw
		}
		REPLY
		{
		}
	}
}

COMMAND    advanced_password
{ 
	BLOCK transducer_block_1;
	INDEX 108;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			advanced_m_pw
		}
		REPLY
		{
		}
	}
}
COMMAND    expert_password
{ 
	BLOCK transducer_block_1;
	INDEX 109;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			expert_m_pw
		}
		REPLY
		{
		}
	}
}
COMMAND    set_dev_alarm_stat_code
{ 
	BLOCK transducer_block_1;
	INDEX 110;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			dev_alarm_stat_code
		}
		REPLY
		{
		}
	}
}
COMMAND    read_dev_alarm_stat_code
{ 
	BLOCK transducer_block_1;
	INDEX 110;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			dev_alarm_stat_code
		}
	}
}
COMMAND    read_dev_alarm_distance
{ 
	BLOCK transducer_block_1;
	INDEX 111;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			dev_alarm_distance
		}
	}
}
COMMAND    set_dev_alarm_distance
{ 
	BLOCK transducer_block_1;
	INDEX 111;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			dev_alarm_distance
		}
		REPLY
		{
		}
	}
}

COMMAND    set_dev_alarm_time
{ 
	BLOCK transducer_block_1;
	INDEX 112;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			dev_alarm_time
		}
		REPLY
		{
		}
	}
}
COMMAND    read_dev_alarm_time
{ 
	BLOCK transducer_block_1;
	INDEX 112;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			dev_alarm_time
		}
	}
}
COMMAND    set_dev_alarm_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 113;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			dev_en_output
		}
		REPLY
		{
		}
	}
}
COMMAND    read_dev_alarm_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 113;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			dev_en_output
		}
	}
}

COMMAND    read_dev_valve_action
{ 
	BLOCK transducer_block_1;
	INDEX 114;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			dev_valve_action
		}
	}
}
COMMAND    set_dev_valve_action
{ 
	BLOCK transducer_block_1;
	INDEX 114;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			dev_valve_action
		}
		REPLY
		{
		}
	}
}

COMMAND    set_lim1_alarm_stat_code
{ 
	BLOCK transducer_block_1;
	INDEX 115;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			limit1_alarm_stat_code
		}
		REPLY
		{
		}
	}
}
COMMAND    read_lim1_alarm_stat_code
{ 
	BLOCK transducer_block_1;
	INDEX 115;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			limit1_alarm_stat_code
		}
	}
}
COMMAND    read_limit1_position_min
{ 
	BLOCK transducer_block_1;
	INDEX 116;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			limit1_position_min
		}
	}
}
COMMAND    set_limit1_position_min
{ 
	BLOCK transducer_block_1;
	INDEX 116;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			limit1_position_min
		}
		REPLY
		{
		}
	}
}

COMMAND    read_limit1_position_max
{ 
	BLOCK transducer_block_1;
	INDEX 117;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			limit1_position_max
		}
	}
}
COMMAND    set_limit1_position_max
{ 
	BLOCK transducer_block_1;
	INDEX 117;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			limit1_position_max
		}
		REPLY
		{
		}
	}
}

COMMAND    set_limit1_hysteresis
{ 
	BLOCK transducer_block_1;
	INDEX 118;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			limit1_hysteresis
		}
		REPLY
		{
		}
	}
}
COMMAND    read_limit1_hysteresis
{ 
	BLOCK transducer_block_1;
	INDEX 118;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			limit1_hysteresis
		}
	}
}
COMMAND    set_limit1_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 119;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			limit1_en_output
		}
		REPLY
		{
		}
	}
}
COMMAND    read_limit1_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 119;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			limit1_en_output
		}
	}
}

COMMAND    set_limit1_valve_action
{ 
	BLOCK transducer_block_1;
	INDEX 120;
	OPERATION   WRITE; 
	TRANSACTION
	{ 
		REQUEST
		{ 
			limit1_valve_action
		} 
		REPLY
		{ 
		} 
	}
}
 
COMMAND    read_limit1_valve_action
{ 
	BLOCK transducer_block_1;
	INDEX 120;
	OPERATION   READ; 
	TRANSACTION
	{ 
		REQUEST
		{
		                  
		} 
		REPLY
		{ 
			limit1_valve_action
		} 
	}
}

COMMAND    set_limit2_alarm_stat_code
{ 
	BLOCK transducer_block_1;
	INDEX 121;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			limit2_alarm_stat_code
		}
		REPLY
		{
		}
	}
}
COMMAND    read_limit2_alarm_stat_code
{ 
	BLOCK transducer_block_1;
	INDEX 121;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			limit2_alarm_stat_code
		}
	}
}
COMMAND    read_limit2_position_min
{ 
	BLOCK transducer_block_1;
	INDEX 122;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			limit2_position_min
		}
	}
}
COMMAND    set_limit2_position_min
{ 
	BLOCK transducer_block_1;
	INDEX 122;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			limit2_position_min
		}
		REPLY
		{
		}
	}
}

COMMAND    read_limit2_position_max
{ 
	BLOCK transducer_block_1;
	INDEX 123;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			limit2_position_max
		}
	}
}
COMMAND    set_limit2_position_max
{ 
	BLOCK transducer_block_1;
	INDEX 123;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			limit2_position_max
		}
		REPLY
		{
		}
	}
}

COMMAND    set_limit2_hysteresis
{ 
	BLOCK transducer_block_1;
	INDEX 124;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			limit2_hysteresis
		}
		REPLY
		{
		}
	}
}
COMMAND    read_limit2_hysteresis
{ 
	BLOCK transducer_block_1;
	INDEX 124;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			limit2_hysteresis
		}
	}
}
COMMAND    set_limit2_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 125;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			limit2_en_output
		}
		REPLY
		{
		}
	}
}
COMMAND    read_limit2_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 125;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			limit2_en_output
		}
	}
}

COMMAND    set_limit2_valve_action
{ 
	BLOCK transducer_block_1;
	INDEX 126;
	OPERATION   WRITE; 
	TRANSACTION
	{ 
		REQUEST
		{ 
			limit2_valve_action
		} 
		REPLY
		{ 
		} 
	}
}
 
COMMAND    read_limit2_valve_action
{ 
	BLOCK transducer_block_1;
	INDEX 126;
	OPERATION   READ; 
	TRANSACTION
	{ 
		REQUEST
		{
		                  
		} 
		REPLY
		{ 
			limit2_valve_action
		} 
	}
}
COMMAND    set_aux_alarm_stat_code
{ 
	BLOCK transducer_block_1;
	INDEX 127;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			aux_alarm_stat_code
		}
		REPLY
		{
		}
	}
}
COMMAND    read_aux_alarm_stat_code
{ 
	BLOCK transducer_block_1;
	INDEX 127;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			aux_alarm_stat_code
		}
	}
}
COMMAND    read_aux_position_min
{ 
	BLOCK transducer_block_1;
	INDEX 128;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			aux_min_value
		}
	}
}
COMMAND    set_aux_position_min
{ 
	BLOCK transducer_block_1;
	INDEX 128;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			aux_min_value
		}
		REPLY
		{
		}
	}
}

COMMAND    read_aux_position_max
{ 
	BLOCK transducer_block_1;
	INDEX 129;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			aux_max_value
		}
	}
}
COMMAND    set_aux_position_max
{ 
	BLOCK transducer_block_1;
	INDEX 129;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			aux_max_value
		}
		REPLY
		{
		}
	}
}

COMMAND    set_aux_hysteresis
{ 
	BLOCK transducer_block_1;
	INDEX 130;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			aux_hysteresis
		}
		REPLY
		{
		}
	}
}
COMMAND    read_aux_hysteresis
{ 
	BLOCK transducer_block_1;
	INDEX 130;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			aux_hysteresis
		}
	}
}
COMMAND    set_aux_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 131;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			aux_en_output
		}
		REPLY
		{
		}
	}
}
COMMAND    read_aux_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 131;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			aux_en_output
		}
	}
}

COMMAND    set_aux_valve_action
{ 
	BLOCK transducer_block_1;
	INDEX 132;
	OPERATION   WRITE; 
	TRANSACTION
	{ 
		REQUEST
		{ 
			aux_valve_action
		} 
		REPLY
		{ 
		} 
	}
}
 
COMMAND    read_aux_valve_action
{ 
	BLOCK transducer_block_1;
	INDEX 132;
	OPERATION   READ; 
	TRANSACTION
	{ 
		REQUEST
		{
		                  
		} 
		REPLY
		{ 
			aux_valve_action
		} 
	}
}


COMMAND    set_temp_alarm_stat_code
{ 
	BLOCK transducer_block_1;
	INDEX 133;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			temp_alarm_stat_code
		}
		REPLY
		{
		}
	}
}
COMMAND    read_temp_alarm_stat_code
{ 
	BLOCK transducer_block_1;
	INDEX 133;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			temp_alarm_stat_code
		}
	}
}
COMMAND    read_temp_min
{ 
	BLOCK transducer_block_1;
	INDEX 134;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			temp_min
		}
	}
}
COMMAND    set_temp_min
{ 
	BLOCK transducer_block_1;
	INDEX 134;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			temp_min
		}
		REPLY
		{
		}
	}
}

COMMAND    read_temp_max
{ 
	BLOCK transducer_block_1;
	INDEX 135;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			temp_max
		}
	}
}
COMMAND    set_temp_max
{ 
	BLOCK transducer_block_1;
	INDEX 135;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			temp_max
		}
		REPLY
		{
		}
	}
}

COMMAND    set_temp_hysteresis
{ 
	BLOCK transducer_block_1;
	INDEX 136;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			temp_hysteresis
		}
		REPLY
		{
		}
	}
}
COMMAND    read_temp_hysteresis
{ 
	BLOCK transducer_block_1;
	INDEX 136;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			temp_hysteresis
		}
	}
}
COMMAND    set_temp_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 137;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			temp_en_output
		}
		REPLY
		{
		}
	}
}
COMMAND    read_temp_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 137;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			temp_en_output
		}
	}
}

COMMAND    set_temp_valve_action
{ 
	BLOCK transducer_block_1;
	INDEX 138;
	OPERATION   WRITE; 
	TRANSACTION
	{ 
		REQUEST
		{ 
			temp_valve_action
		} 
		REPLY
		{ 
		} 
	}
}
 
COMMAND    read_temp_valve_action
{ 
	BLOCK transducer_block_1;
	INDEX 138;
	OPERATION   READ; 
	TRANSACTION
	{ 
		REQUEST
		{
		                  
		} 
		REPLY
		{ 
			temp_valve_action
		} 
	}
}

COMMAND    set_diff_alarm_stat_code
{ 
	BLOCK transducer_block_1;
	INDEX 139;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			diff_alarm_stat_code
		}
		REPLY
		{
		}
	}
}
COMMAND    read_diff_alarm_stat_code
{ 
	BLOCK transducer_block_1;
	INDEX 139;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			diff_alarm_stat_code
		}
	}
}
COMMAND    read_diff_distance
{ 
	BLOCK transducer_block_1;
	INDEX 140;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			diff_alarm_distance
		}
	}
}
COMMAND    set_diff_distance
{ 
	BLOCK transducer_block_1;
	INDEX 140;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			diff_alarm_distance
		}
		REPLY
		{
		}
	}
}

COMMAND    set_diff_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 141;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			diff_en_output
		}
		REPLY
		{
		}
	}
}
COMMAND    read_diff_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 141;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			diff_en_output
		}
	}
}

COMMAND    set_diff_valve_action
{ 
	BLOCK transducer_block_1;
	INDEX 142;
	OPERATION   WRITE; 
	TRANSACTION
	{ 
		REQUEST
		{ 
			diff_valve_action
		} 
		REPLY
		{ 
		} 
	}
}
 
COMMAND    read_diff_valve_action
{ 
	BLOCK transducer_block_1;
	INDEX 142;
	OPERATION   READ; 
	TRANSACTION
	{ 
		REQUEST
		{
		                  
		} 
		REPLY
		{ 
			diff_valve_action
		} 
	}
}
COMMAND    set_toggle_time
{ 
	BLOCK transducer_block_1;
	INDEX 148;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			toggle_time
		}
		REPLY
		{
		}
	}
}
COMMAND    read_toggle_time
{ 
	BLOCK transducer_block_1;
	INDEX 148;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			toggle_time
		}
	}
}

COMMAND    set_toggle_amplitude
{ 
	BLOCK transducer_block_1;
	INDEX 149;
	OPERATION   WRITE; 
	TRANSACTION
	{ 
		REQUEST
		{ 
			toggle_amplitude
		} 
		REPLY
		{ 
		} 
	}
}
 
COMMAND    read_toggle_amplitude
{ 
	BLOCK transducer_block_1;
	INDEX 149;
	OPERATION   READ; 
	TRANSACTION
	{ 
		REQUEST
		{
		                  
		} 
		REPLY
		{ 
			toggle_amplitude
		} 
	}
}
COMMAND    set_toggle_period
{ 
	BLOCK transducer_block_1;
	INDEX 150;
	OPERATION   WRITE; 
	TRANSACTION
	{ 
		REQUEST
		{ 
			toggle_period
		} 
		REPLY
		{ 
		} 
	}
}
 
COMMAND    read_toggle_period
{ 
	BLOCK transducer_block_1;
	INDEX 150;
	OPERATION   READ; 
	TRANSACTION
	{ 
		REQUEST
		{
		                  
		} 
		REPLY
		{ 
			toggle_period
		} 
	}
}


COMMAND    set_enable_toggle
{ 
	BLOCK transducer_block_1;
	INDEX 151;
	OPERATION   WRITE; 
	TRANSACTION    
	{ 
		REQUEST
		{              	
		} 
		REPLY
		{ 
		 	toggle_enable   
		} 
	}
}

COMMAND    write_actuator_size
{ 
	BLOCK transducer_block_1;
	INDEX 152;
	OPERATION   WRITE; 
	TRANSACTION
	{ 
		REQUEST
		{ 
			actuator_size
		} 
		REPLY
		{ 
		} 
	}
}
 
COMMAND    read_actuator_size
{ 
	BLOCK transducer_block_1;
	INDEX 152;
	OPERATION   READ; 
	TRANSACTION
	{ 
		REQUEST
		{
		                  
		} 
		REPLY
		{ 
			actuator_size
		} 
	}
}
/* 
COMMAND    write_valve_rotation
{ 
	BLOCK transducer_block_1;
	INDEX 153;
	OPERATION   WRITE; 
	TRANSACTION
	{ 
		REQUEST
		{ 
			max_rotation
		} 
		REPLY
		{ 
		} 
	}
}
 
COMMAND    read_max_rotation
{ 
	BLOCK transducer_block_1;
	INDEX 153;
	OPERATION   READ; 
	TRANSACTION
	{ 
		REQUEST
		{
		                  
		} 
		REPLY
		{ 
			max_rotation
		} 
	}
}   
*/
COMMAND    write_failsafe_alarm_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 154;
	OPERATION   WRITE; 
	TRANSACTION
	{ 
		REQUEST
		{ 
			failsafe_alarm_en_out
		} 
		REPLY
		{ 
		} 
	}
}
 
COMMAND    read_failsafe_alarm_en_out
{ 
	BLOCK transducer_block_1;
	INDEX 154;
	OPERATION   READ; 
	TRANSACTION
	{ 
		REQUEST
		{
		                  
		} 
		REPLY
		{ 
			failsafe_alarm_en_out
		} 
	}
}   


/* ---------------------------------------------------------- */



/*------------------------------------------------------------------------------------*/

/***********************************************************************/
/*    Transducer Block: Temperture 									   */
/***********************************************************************/

BLOCK transducer_block_2
{
	TYPE	TRANSDUCER;
	NUMBER	2;
}

trans2_blk_reserve			LIKE VARIABLE	phys_blk_reserve
{
}

VARIABLE trans2_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	3,	[blk_block_object_TRANSDUCER]	}
	}
	HANDLING	READ;
}

VARIABLE trans2_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[trans_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	240,	"Temperature TB"	}
	}
	HANDLING	READ;
}

VARIABLE trans2_blk_class
{
	LABEL		[blk_class];
	HELP		[trans_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	2,	"Temperature"				},
		{	250,	[not_used] 							},
		{	251,	[none]								},
		{	252,	[unknown]							},
		{	253,	[special]							}
	}
	HANDLING	READ;
}

trans2_blk_dd_reference						LIKE VARIABLE	phys_blk_dd_reference
{											
}											
											
trans2_blk_dd_rev						LIKE VARIABLE	phys_blk_dd_rev
{											
}											
											
trans2_blk_profile						LIKE VARIABLE	phys_blk_profile
{											
}											
											
trans2_blk_profile_rev						LIKE VARIABLE	phys_blk_profile_rev
{											
}											
											
trans2_blk_execution_time					LIKE VARIABLE	phys_blk_execution_time
{											
}											
											
trans2_blk_num_parameters					LIKE VARIABLE	phys_blk_num_parameters
{											
}											
											
trans2_blk_index_view_1						LIKE VARIABLE	phys_blk_index_view_1
{											
}											
											
trans2_blk_num_view_lists					LIKE VARIABLE	phys_blk_num_view_lists
{											
}											
											
trans2_st_rev							LIKE VARIABLE	phys_st_rev
{											
}											
											
trans2_tag_desc						LIKE VARIABLE	phys_tag_desc
{											
}											
											
trans2_strategy							LIKE VARIABLE	phys_strategy
{											
}											
											
trans2_alert_key						LIKE VARIABLE	phys_alert_key
{											
}											

trans2_target_mode						LIKE VARIABLE	phys_target_mode
{
	REDEFINE TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08;
		{	0x08,	[mode_AUTO]				},
		{	0x20,	[mode_LO]				}
	}
}

trans2_actual_mode					LIKE VARIABLE	phys_actual_mode
{
}

trans2_permitted_mode					LIKE VARIABLE	phys_permitted_mode
{
}

trans2_normal_mode					LIKE VARIABLE	phys_normal_mode
{
}

trans2_current_state_alarm_sum				LIKE VARIABLE	phys_current_state_alarm_sum
{
}

trans2_unacknowledged_state_alarm_sum		LIKE VARIABLE	phys_unacknowledged_state_alarm_sum
{
}

trans2_unreported_state_alarm_sum			LIKE VARIABLE	phys_unreported_state_alarm_sum
{
}

trans2_disabled_state_alarm_sum			LIKE VARIABLE	phys_disabled_state_alarm_sum
{
}




/*-------------------------------------------------------------------------------------*/
/*    Transducer Block: Temperature	   */
/*-------------------------------------------------------------------------------------*/
#define	BLOCK_MODE_LO				0x20

VARIABLE trans2_meas_value
{
	LABEL		"Temperature";		
	HELP		[func_ao_setpoint_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
		DISPLAY_FORMAT ".2f" ;
	}
	HANDLING	READ;
}

VARIABLE trans2_meas_value_status_quality
{
	LABEL		[status_quality];		
	HELP		[func_ao_setpoint_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit
	}
	HANDLING	READ;
}
VARIABLE func2_AO_setpoint_status_quality
{
	LABEL		[status_quality];		
	HELP		[func_ao_setpoint_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit_func2_AO
	}
	HANDLING	READ & WRITE;
}
func2_AO_setpoint_status_limit					LIKE VARIABLE	func2_AO_setpoint_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_LIMIT (func2_AO_setpoint_status_quality)
	}
}
VARIABLE func2_AO_rcas_in_status_quality
{
	LABEL		[status_quality];
	HELP		[func_rcas_in_status_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit_func2_AO
	}
	HANDLING	READ & WRITE;
}

func2_AO_rcas_in_status_limit					LIKE VARIABLE	func2_AO_rcas_in_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_INPUT_LIMIT (func2_AO_rcas_in_status_quality)
	}
}
VARIABLE func2_AO_simulate_status_quality
{
	LABEL		[status_quality];
	HELP		[func_simulate_status_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit_func2_AO
	}
	HANDLING	READ & WRITE;
}

func2_AO_simulate_status_limit					LIKE VARIABLE	func2_AO_simulate_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_INPUT_LIMIT (func2_AO_simulate_status_quality)
	}
}
VARIABLE func2_AO_target_mode
{
	LABEL		[target_mode];		
	HELP		[target_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{	0x02,	[mode_RCAS]				},
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ & WRITE;
}
VARIABLE func2_AO_out_status_quality
{
	LABEL		[status_quality];
	HELP		[func_out_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		IF ((func2_AO_target_mode == BLOCK_MODE_MAN) || (func2_AO_target_mode == BLOCK_MODE_LO))
		{
			STATUS_INPUT_NO_RCAS
		}
		ELSE {
			STATUS_OUTPUT_NO_RCAS
		}
	}
	POST_EDIT_ACTIONS
	{
		IF ((func2_AO_target_mode == BLOCK_MODE_MAN) || (func2_AO_target_mode == BLOCK_MODE_LO))
		{
			method_set_status_limit_func2_AO
		}
	}
	HANDLING
		IF ((func2_AO_target_mode == BLOCK_MODE_MAN) || (func2_AO_target_mode == BLOCK_MODE_LO))
		{
			READ & WRITE;
		}
		ELSE {
			READ;
		}
}
func2_AO_out_status_limit						LIKE VARIABLE	func2_AO_out_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		IF ((func2_AO_target_mode == BLOCK_MODE_MAN) || (func2_AO_target_mode == BLOCK_MODE_LO))
		{
			STATUS_INPUT_LIMIT (func2_AO_out_status_quality)
		}
		ELSE {
			STATUS_OUTPUT_LIMIT
		}
	}
}

METHOD method_set_status_limit_func2_AO
{
	CLASS		INPUT;
	DEFINITION
	{
		int	quality;
		int block_mode;			/* !!! temp.: bis Methoden mit Aufrufparametern funktionieren !!! */

		quality = ivar_value(func2_AO_setpoint_status_quality);
		if ((quality == 0x20) || (quality == 0x30))
			iassign(func2_AO_setpoint_status_limit, 0);

		quality = ivar_value(func2_AO_rcas_in_status_quality);
		if ((quality == 0x20) || (quality == 0x30))
			iassign(func2_AO_rcas_in_status_limit, 0);

		quality = ivar_value(func2_AO_simulate_status_quality);
		if ((quality == 0x20) || (quality == 0x30))
			iassign(func2_AO_simulate_status_limit, 0);

		block_mode	= ivar_value(func2_AO_target_mode);
		quality		= ivar_value(func2_AO_out_status_quality);
		if (((block_mode == BLOCK_MODE_MAN) || (block_mode == BLOCK_MODE_LO)) && ((quality == 0x20) || (quality == 0x30)))
			iassign(func2_AO_out_status_limit, 0);
	}
}

trans2_meas_value_status_limit					LIKE VARIABLE	func2_AO_setpoint_status_quality
//trans2_meas_value_status_limit					LIKE VARIABLE	func2_setpoint_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_LIMIT (func2_AO_setpoint_status_quality)
//		STATUS_INPUT_LIMIT (func2_setpoint_status_quality)
	}
}
VARIABLE trans2_temperature_unit			     
{
	LABEL		"Temperature unit";
	HELP		[func_out_scale_unit_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	1001;
/* Temperature */
		{ 1000,	[unit_1000],	[unit_1000_help]	},	\
		{ 1001,	[unit_1001],	[unit_1001_help]	},	\
		{ 1002,	[unit_1002],	[unit_1002_help]	}
	}
	   //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	trans1_actual_mode == BLOCK_MODE_OUT_OF_SERVICE)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
}

/*
VARIABLE trans2_bias						
{
	LABEL		"Calibration Value";
	HELP		[lin_tab_entry_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	25.0; // jonas
		MIN_VALUE		-40.0;// jonas
		MAX_VALUE		393.1;// jonas
		DISPLAY_FORMAT ".1f" ;
		EDIT_FORMAT ".1f" ;
	}
	   //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	trans1_actual_mode == BLOCK_MODE_OUT_OF_SERVICE)
                   {
                        READ & WRITE;
                   }
                   ELSE
                   {
                        READ;
                   }

}
*/
VARIABLE trans2_calib_unit			     
{
	LABEL		"Calibration Unit";
	HELP		[func_out_scale_unit_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	1000;
/* Temperature */
		{ 1000,	[unit_1000],	[unit_1000_help]	}	
		}
	HANDLING	READ;
}
 /***********************************************************************/
/*    Transducer Block: Auxilary 									   */
/***********************************************************************/

BLOCK transducer_block_3
{
	TYPE	TRANSDUCER;
	NUMBER	3;
}

trans3_blk_reserve			LIKE VARIABLE	phys_blk_reserve
{
}

VARIABLE trans3_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	3,	[blk_block_object_TRANSDUCER]	}
	}
	HANDLING	READ;
}

VARIABLE trans3_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[trans_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	240,	"PMV specific TB"	}
	}
	HANDLING	READ;
}

VARIABLE trans3_blk_class
{
	LABEL		[blk_class];
	HELP		[trans_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	3,	"Auxillary input"				},
		{	250,	[not_used] 							},
		{	251,	[none]								},
		{	252,	[unknown]							},
		{	253,	[special]							}
	}
	HANDLING	READ;
}

trans3_blk_dd_reference						LIKE VARIABLE	phys_blk_dd_reference
{											
}											
											
trans3_blk_dd_rev						LIKE VARIABLE	phys_blk_dd_rev
{											
}											
											
trans3_blk_profile						LIKE VARIABLE	phys_blk_profile
{											
}											
											
trans3_blk_profile_rev						LIKE VARIABLE	phys_blk_profile_rev
{											
}											
											
trans3_blk_execution_time					LIKE VARIABLE	phys_blk_execution_time
{											
}											
											
trans3_blk_num_parameters					LIKE VARIABLE	phys_blk_num_parameters
{											
}											
											
trans3_blk_index_view_1						LIKE VARIABLE	phys_blk_index_view_1
{											
}											
											
trans3_blk_num_view_lists					LIKE VARIABLE	phys_blk_num_view_lists
{											
}											
											
trans3_st_rev							LIKE VARIABLE	phys_st_rev
{											
}											
											
trans3_tag_desc						LIKE VARIABLE	phys_tag_desc
{											
}											
											
trans3_strategy							LIKE VARIABLE	phys_strategy
{											
}											
											
trans3_alert_key						LIKE VARIABLE	phys_alert_key
{											
}											

trans3_target_mode						LIKE VARIABLE	phys_target_mode
{
	REDEFINE TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08;
		{	0x08,	[mode_AUTO]				}
	}
}

trans3_actual_mode					LIKE VARIABLE	phys_actual_mode
{
}

trans3_permitted_mode					LIKE VARIABLE	phys_permitted_mode
{
}

trans3_normal_mode					LIKE VARIABLE	phys_normal_mode
{
}

trans3_current_state_alarm_sum				LIKE VARIABLE	phys_current_state_alarm_sum
{
}

trans3_unacknowledged_state_alarm_sum		LIKE VARIABLE	phys_unacknowledged_state_alarm_sum
{
}

trans3_unreported_state_alarm_sum			LIKE VARIABLE	phys_unreported_state_alarm_sum
{
}

trans3_disabled_state_alarm_sum			LIKE VARIABLE	phys_disabled_state_alarm_sum
{
}




/*-------------------------------------------------------------------------------------*/
/*    Transducer Block: Aux input	   */
/*-------------------------------------------------------------------------------------*/
/*
VARIABLE trans3_cal_point_hi
{
	LABEL		"High Calibration Point";		
	HELP		"Enter the value presently meassured on the aux input for calibration";
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE    20.0;
		DISPLAY_FORMAT ".3f" ;
	}
	   //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	trans1_actual_mode == BLOCK_MODE_OUT_OF_SERVICE)
		{
				WRITE;
		}
}
VARIABLE trans3_cal_point_lo
{
	LABEL		"Low Calibration Point";		
	HELP		"Enter the value presently measured on the aux input for calibration";
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	4.0;
		DISPLAY_FORMAT ".3f" ;
	}
	   //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	trans1_actual_mode == BLOCK_MODE_OUT_OF_SERVICE)
		{
				WRITE;
		}
}
*/
VARIABLE trans3_cal_point_hi
{
	LABEL		"High Calibration Point";		
	HELP		"Enter the value presently meassured on the aux input for calibration";
	CLASS		CONTAINED & DYNAMIC;
      TYPE        FLOAT
      {
//            DEFAULT_VALUE     4.0;  // jonas 2007.10.17
            DEFAULT_VALUE     20.0;
            MIN_VALUE         4.0;
            MAX_VALUE         20.0;
            DISPLAY_FORMAT ".3f" ;
      }

      HANDLING
            IF ( trans1_actual_mode == BLOCK_MODE_OUT_OF_SERVICE )
                   {
//                        READ & WRITE;   // jonas 2007.10.17
                        WRITE;
                   }
/*                   ELSE
                   {
                        READ;
                   }
*/
}
VARIABLE trans3_cal_point_lo
{
	LABEL		"Low Calibration Point";		
	HELP		"Enter the value presently measured on the aux input for calibration";
	CLASS		CONTAINED & DYNAMIC;
      TYPE        FLOAT
      {
            DEFAULT_VALUE     4.0;
            MIN_VALUE         4.0;
            MAX_VALUE         20.0;
            DISPLAY_FORMAT ".3f" ;
      }

      HANDLING
            IF ( trans1_actual_mode == BLOCK_MODE_OUT_OF_SERVICE )
                   {
//                        READ & WRITE;  // jonas 2007.10.17
                        WRITE;
                   }
/*                   ELSE
                   {
                        READ;
                   }
*/
}


VARIABLE trans3_cal_unit			     
{
	LABEL		"Calibration Unit";
	HELP		"Unit for calibration factors";
	CLASS		CONTAINED & SERVICE;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	1211;
/* mA */
		{ 1211,	[unit_1211],	[unit_1211_help]	}	
		}
	HANDLING	READ;
}

VARIABLE trans3_primary_value
{
	LABEL		"Aux input";		
	HELP		"Dynamic value - 4-20 mA input to D3";
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DISPLAY_FORMAT ".3f" ;
	}
	HANDLING	READ;
}

VARIABLE trans3_primary_value_status_quality
{
	LABEL		[status_quality];		
	HELP		[func_ao_setpoint_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit
	}
	HANDLING	READ;
}

//trans3_primary_value_status_limit					LIKE VARIABLE	func1_setpoint_status_quality
trans3_primary_value_status_limit					LIKE VARIABLE	func2_AO_setpoint_status_quality
//trans3_primary_value_status_limit					LIKE VARIABLE	func2_setpoint_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_LIMIT (func2_AO_setpoint_status_quality)
//		STATUS_INPUT_LIMIT (func2_setpoint_status_quality)
	}
}
VARIABLE trans3_primary_value_unit			     
{
	LABEL		"Aux unit";
	HELP		"Unit for presentation of aux input value";
	CLASS		CONTAINED & SERVICE;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	1342;// jonas
/* Aux */
		{ 1211,	[unit_1211],	[unit_1211_help]	},	\
		{ 1342,	[unit_1342],	[unit_1342_help]	}	}
	   //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	trans1_actual_mode == BLOCK_MODE_OUT_OF_SERVICE)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
}


/***********************************************************************/
/*    Function Block                                                	     */
/***********************************************************************/
//#include "SIPASTAI_300.inc"

BLOCK function_block_1
{
	TYPE	FUNCTION;
	NUMBER	1;
}

func1_blk_reserve							LIKE VARIABLE	phys_blk_reserve
{
}

VARIABLE func1_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	2,	[blk_block_object_FUNCTION]		}
	}
	HANDLING	READ;
}

VARIABLE func1_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[func_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	2,	[func_blk_parent_class_OUTPUT]	}
	}
	HANDLING	READ;
}

VARIABLE func1_blk_class
{
	LABEL		[blk_class];
	HELP		[func_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	1,	[func_blk_class_AO]		}
	}	
	HANDLING	READ;
}

func1_blk_dd_reference						LIKE VARIABLE	phys_blk_dd_reference
{											
}											
											
func1_blk_dd_rev						LIKE VARIABLE	phys_blk_dd_rev
{											
}											
											
func1_blk_profile						LIKE VARIABLE	phys_blk_profile
{											
}											
											
func1_blk_profile_rev						LIKE VARIABLE	phys_blk_profile_rev
{											
}											
											
func1_blk_execution_time					LIKE VARIABLE	phys_blk_execution_time
{											
}											
											
func1_blk_num_parameters					LIKE VARIABLE	phys_blk_num_parameters
{											
}											
											
func1_blk_index_view_1						LIKE VARIABLE	phys_blk_index_view_1
{											
}

func1_blk_num_view_lists					LIKE VARIABLE	phys_blk_num_view_lists
{											
}											
											
func1_st_rev								LIKE VARIABLE	phys_st_rev
{											
} 											
											
func1_tag_desc								LIKE VARIABLE	phys_tag_desc
{											
}											
											
func1_strategy								LIKE VARIABLE	phys_strategy
{											
}											
											
func1_alert_key								LIKE VARIABLE	phys_alert_key
{											
}

func1_target_mode							LIKE VARIABLE	phys_target_mode
{
	REDEFINE TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{	0x02,	[mode_RCAS]				},
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
}

func1_actual_mode							LIKE VARIABLE	phys_actual_mode
{
	REDEFINE TYPE		ENUMERATED (1)
	{
		{	0x02,	[mode_RCAS]				},
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
}

func1_permitted_mode						LIKE VARIABLE	phys_permitted_mode
{
	REDEFINE TYPE		BIT_ENUMERATED (1)
	{
		{	0x02,	[mode_RCAS]				},
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
}

func1_normal_mode							LIKE VARIABLE	phys_normal_mode
{
	REDEFINE TYPE		ENUMERATED (1)
	{
		{	0x02,	[mode_RCAS]				},
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
}

func1_current_state_alarm_sum				LIKE VARIABLE	phys_current_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

func1_unacknowledged_state_alarm_sum		LIKE VARIABLE	phys_unacknowledged_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

func1_unreported_state_alarm_sum			LIKE VARIABLE	phys_unreported_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

func1_disabled_state_alarm_sum				LIKE VARIABLE	phys_disabled_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

VARIABLE func1_batch_id
{
	LABEL		[func_batch_id];		
	HELP		[func_batch_id_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4)
	{
		DEFAULT_VALUE	0;
	}
    	HANDLING	READ & WRITE;
}

VARIABLE func1_batch_unit
{
	LABEL		[func_batch_unit];		
	HELP		[func_batch_unit_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
    	HANDLING	READ & WRITE;
}

VARIABLE func1_batch_operation
{
	LABEL		[func_batch_operation];		
	HELP		[func_batch_operation_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
    	HANDLING	READ & WRITE;
}

VARIABLE func1_batch_phase
{
	LABEL		[func_batch_phase];		
	HELP		[func_batch_phase_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
    	HANDLING	READ & WRITE;
}

/****************************************************************************************/
/*    Function Block: Analog Output							           */
/****************************************************************************************/

VARIABLE func1_setpoint_value
{
	LABEL		[func_ao_setpoint_value];		
	HELP		[func_ao_setpoint_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
		DISPLAY_FORMAT ".2f" ;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_setpoint_status_quality
{
	LABEL		[status_quality];		
	HELP		[func_ao_setpoint_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit
	}
	HANDLING	READ & WRITE;
}

func1_setpoint_status_limit					LIKE VARIABLE	func1_setpoint_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_LIMIT (func1_setpoint_status_quality)
	}
}


VARIABLE func1_pv_upper_range_value
{
	LABEL		[func_pv_scale_upper_value];
	HELP		[func_pv_scale_upper_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	100.0;
	}
    	HANDLING	READ & WRITE;
}

VARIABLE func1_pv_lower_range_value
{
	LABEL		[func_pv_scale_lower_value];
	HELP		[func_pv_scale_lower_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
    	HANDLING	READ & WRITE;
}

VARIABLE func1_pv_unit
{
	LABEL		[func_pv_scale_unit];
	HELP		[func_pv_scale_unit_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	1342;
		{ 1342,  [Percent],	[Percent_help]	}
/*		{ 1005,  [degrees],	[degrees_help]	}
		{ 1012,  [cm],		[cmhelp]	}
		{ 1013,  [mm],		[mm_help]	}
		{ 1019,  [in],		[in_help]	} */
	}
    	HANDLING	READ & WRITE;
}

VARIABLE func1_pv_decimal_point
{
	LABEL		[decimal_point];
	HELP		[decimal_point_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,   "0"		},
		{	1,   "1"		},
		{	2,   "2"		},
		{	3,   "3"		},
		{	4,   "4"		},
		{	5,   "5"		},
		{	6,   "6"		}
	}
    	HANDLING	READ & WRITE;
}

VARIABLE func1_readback_value
{
	LABEL		[func_ao_readback_value];		
	HELP		[func_ao_readback_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
		DISPLAY_FORMAT ".2f" ;
	}
	HANDLING	READ;
}

VARIABLE func1_readback_status_quality
{
	LABEL		[status_quality];		
	HELP		[func_ao_readback_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_OUTPUT_NO_RCAS
	}
	HANDLING	READ;
}

func1_readback_status_limit					LIKE VARIABLE	func1_readback_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_OUTPUT_LIMIT
	}
}

VARIABLE func1_rcas_in_value
{
	LABEL		[func_rcas_in_value];
	HELP		[func_rcas_in_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_rcas_in_status_quality
{
	LABEL		[status_quality];		
	HELP		[func_rcas_in_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x0;
//fbi		DEFAULT_VALUE	0x1B;
		STATUS_INPUT_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit
	}
   	HANDLING	READ & WRITE;
}

func1_rcas_in_status_limit					LIKE VARIABLE	func1_rcas_in_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_INPUT_LIMIT (func1_rcas_in_status_quality)
	}
}
VARIABLE func1_in_channel
{
	LABEL		[func_channel];
	HELP		[func_channel_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0x13A;
	}
   //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	func1_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func1_target_mode == BLOCK_MODE_MAN)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
 
}

func1_out_channel							LIKE VARIABLE	func1_in_channel
{
	REDEFINE TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0x139;
	}
}

VARIABLE func1_fsafe_time
{
	LABEL		[func_ao_fsafe_time];
	HELP		[func_ao_fsafe_time_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;// jonas
		MIN_VALUE		0.0;
		MAX_VALUE		100.0;
	}
	CONSTANT_UNIT	[sec];
    	HANDLING	READ & WRITE;
}

VARIABLE func1_fsafe_type
{
	LABEL		[func_ao_fsafe_type];
	HELP		[func_ao_fsafe_type_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	2;
		{	0,	"Fail Safe Value"/*[func_ao_fsafe_type_FAIL_SAFE_VALUE]*/		},
		{	1,	"Last Value"/*[func_ao_fsafe_type_STORING_LAST_SETPOINT]*/	}
		{	2,	[func_ao_fsafe_type_FAIL_SAFE_POSITION]		}
	}
    	HANDLING	READ & WRITE;
}

VARIABLE func1_fsafe_value
{
	LABEL		[func_ao_fsafe_value];
	HELP		[func_ao_fsafe_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
		MIN_VALUE		0.0;
		MAX_VALUE		100.0;
	}
    	HANDLING	READ & WRITE;
}
VARIABLE func1_rcas_out_value
{
	LABEL		[func_rcas_out_value];
	HELP		[func_rcas_out_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func1_rcas_out_status_quality
{
	LABEL		[status_quality];
	HELP		[func_rcas_out_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_OUTPUT_RCAS
	}
	HANDLING	READ;
}

func1_rcas_out_status_limit					LIKE VARIABLE	func1_rcas_out_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_OUTPUT_LIMIT
	}
}
VARIABLE func1_position_discrete_value
{
	LABEL		[func_ao_position_discrete_value];
	HELP		[func_ao_position_discrete_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[func_ao_position_discrete_status_NOT_INIT]			},	
		{	1,	[func_ao_position_discrete_status_CLOSED]			},
		{	2,	[func_ao_position_discrete_status_OPENED]			},
		{	3,	[func_ao_position_discrete_status_INTERMEDIATE]		}
	}
	HANDLING	READ;
}

VARIABLE func1_position_discrete_status_quality
{
	LABEL		[status_quality];		
	HELP		[func_ao_position_discrete_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_OUTPUT_NO_RCAS
	}
	HANDLING	READ;
}

func1_position_discrete_status_limit		LIKE VARIABLE	func1_position_discrete_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_OUTPUT_LIMIT
	}
}

VARIABLE func1_setpoint_deviation
{
	LABEL		[func_ao_setpoint_deviation];
	HELP		[func_ao_setpoint_deviation_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	CONSTANT_UNIT	[Percent];
	HANDLING	READ;
}

#define CB_dia_OK			0x00000000		/* kein Bit */
#define CB_FAIL_SAFE			0x00010000		/* Bit  0 */
#define CB_REQ_LOC_OP			0x00020000		/* Bit  1 */
#define CB_LOCAL_OP			0x00040000		/* Bit  2 */
#define CB_OVERRIDE			0x00080000		/* Bit  3 */
#define CB_DISC_DIR			0x00100000		/* Bit  4 */
#define CB_TORQUE_D_OP			0x00200000		/* Bit  5 */
#define CB_TORQUE_D_CL			0x00400000		/* Bit  6 */
#define CB_TRAV_TIME			0x00800000		/* Bit  7 */
#define CB_ACT_OPEN			0x00000100		/* Bit  8 */
#define CB_ACT_CLOSE			0x00000200		/* Bit  9 */
#define CB_UPDATE_EVT			0x00000400		/* Bit 10 */
#define CB_SIMULATE			0x00000800		/* Bit 11 */
#define CB_DISTURBANCE			0x00001000		/* Bit 12 */
#define CB_CONTR_ERR			0x00002000		/* Bit 13 */
#define CB_CONTR_INACT			0x00004000		/* Bit 14 */
#define CB_SELFTEST			0x00008000		/* Bit 15 */
#define CB_ADD_INPUT		    0x00000002		/* Bit 17 */	
#define CB_TOT_VALVE_TRAV		0x00000001		/* Bit 16 */

VARIABLE func1_check_back
{
	LABEL		[func_check_back];
	HELP		[func_check_back_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (3)
	{
		{	CB_dia_OK,		[dia_OK],			[dia_OK_help]				},
		{	CB_FAIL_SAFE,		[cb_FAIL_SAFE],			[cb_FAIL_SAFE_help]			},
		{	CB_REQ_LOC_OP,		[cb_REQ_LOC_OP],		[cb_REQ_LOC_OP_help]		},
		{	CB_LOCAL_OP,		[cb_LOCAL_OP],			[cb_LOCAL_OP_help]			},
		{	CB_OVERRIDE,		[cb_OVERRIDE],			[cb_OVERRIDE_help]			},
		{	CB_DISC_DIR,		[cb_DISC_DIR],			[cb_DISC_DIR_help]			},
		{	CB_TORQUE_D_OP,		[cb_TORQUE_D_OP],		[cb_TORQUE_D_OP_help]		},
		{	CB_TORQUE_D_CL,		[cb_TORQUE_D_CL],		[cb_TORQUE_D_CL_help]		},
		{	CB_TRAV_TIME,		[cb_TRAV_TIME],			[cb_TRAV_TIME_help]			},
		{	CB_ACT_OPEN,		[cb_ACT_OPEN],			[cb_ACT_OPEN_help]			},
		{	CB_ACT_CLOSE,		[cb_ACT_CLOSE],			[cb_ACT_CLOSE_help]			},
		{	CB_UPDATE_EVT,		[cb_UPDATE_EVT],		[cb_UPDATE_EVT_help]		},
		{	CB_SIMULATE,		[cb_SIMULATE],			[cb_SIMULATE_help]			},
		{	CB_DISTURBANCE,		[cb_DISTURBANCE],		[cb_DISTURBANCE_help]		},
		{	CB_CONTR_ERR,		[cb_CONTR_ERR],			[cb_CONTR_ERR_help]			},
		{	CB_CONTR_INACT,		[cb_CONTR_INACT],		[cb_CONTR_INACT_help]		},
		{	CB_SELFTEST,		[cb_SELFTEST],			[cb_SELFTEST_help]			},
		{	CB_ADD_INPUT,	    "AUX active",	"Indicates that an additional input (i.e for diagnostics) is activated"},
		{	CB_TOT_VALVE_TRAV,	[cb_TOT_VALVE_TRAV],	[cb_TOT_VALVE_TRAV_help]	}
	}
	HANDLING	READ;
}

VARIABLE func1_check_back_mask
{
	LABEL		[func_check_back_mask];
	HELP		[func_check_back_mask_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (3)
	{
		{	CB_FAIL_SAFE,		[cb_FAIL_SAFE],			[cb_FAIL_SAFE_help]			},
		{	CB_REQ_LOC_OP,		[cb_REQ_LOC_OP],		[cb_REQ_LOC_OP_help]		},
		{	CB_LOCAL_OP,		[cb_LOCAL_OP],			[cb_LOCAL_OP_help]			},
		{	CB_OVERRIDE,		[cb_OVERRIDE],			[cb_OVERRIDE_help]			},
		{	CB_DISC_DIR,		[cb_DISC_DIR],			[cb_DISC_DIR_help]			},
		{	CB_TORQUE_D_OP,		[cb_TORQUE_D_OP],		[cb_TORQUE_D_OP_help]		},
		{	CB_TORQUE_D_CL,		[cb_TORQUE_D_CL],		[cb_TORQUE_D_CL_help]		},
		{	CB_TRAV_TIME,		[cb_TRAV_TIME],			[cb_TRAV_TIME_help]			},
		{	CB_ACT_OPEN,		[cb_ACT_OPEN],			[cb_ACT_OPEN_help]			},
		{	CB_ACT_CLOSE,		[cb_ACT_CLOSE],			[cb_ACT_CLOSE_help]			},
		{	CB_UPDATE_EVT,		[cb_UPDATE_EVT],		[cb_UPDATE_EVT_help]		},
		{	CB_SIMULATE,		[cb_SIMULATE],			[cb_SIMULATE_help]			},
		{	CB_DISTURBANCE,		[cb_DISTURBANCE],		[cb_DISTURBANCE_help]		},
		{	CB_CONTR_ERR,		[cb_CONTR_ERR],			[cb_CONTR_ERR_help]			},
		{	CB_CONTR_INACT,		[cb_CONTR_INACT],		[cb_CONTR_INACT_help]		},
		{	CB_SELFTEST,		[cb_SELFTEST],			[cb_SELFTEST_help]			},
		{	CB_TOT_VALVE_TRAV,	[cb_TOT_VALVE_TRAV],	[cb_TOT_VALVE_TRAV_help]	}
	}
	HANDLING	READ;
}

VARIABLE func1_simulate_value
{
	LABEL		[func_simulate_value];
	HELP		[func_ao_simulate_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
   //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	func1_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func1_target_mode == BLOCK_MODE_MAN)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
	
}

VARIABLE func1_simulate_status_quality
{
	LABEL		[status_quality];		
	HELP		[func_simulate_status_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit
	}
   //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	func1_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func1_target_mode == BLOCK_MODE_MAN)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
}

func1_simulate_status_limit					LIKE VARIABLE	func1_simulate_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_INPUT_LIMIT (func1_simulate_status_quality)
	}
}

VARIABLE func1_simulation_enabled
{
	LABEL		[func_simulation_enabled];
	HELP		[func_simulation_enabled_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[disabled]		},
		{	1,	[enabled]		}
	}
//   	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	func1_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func1_target_mode == BLOCK_MODE_MAN)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
}

VARIABLE func1_increase_close
{
	LABEL		[func_ao_increase_close];
	HELP		"Direction of positioner. Direct (increasing of setpoint input results in opening of the valve). Reverse (increasing of setpoint input results in closing of the valve)."; /*[func_ao_increase_close_help];*/
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0, "Direct" /*[func_ao_increase_close_RISING]*/},
		{	1, "Reverse" /*[func_ao_increase_close_FALLING]*/}
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_out_value
{
	LABEL		[func_out_value];
	HELP		[func_ao_out_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING
		IF (func1_target_mode == BLOCK_MODE_MAN)
		{
			READ & WRITE;
		}
		ELSE {
			READ;
		}
}

VARIABLE func1_out_status_quality
{
	LABEL		[status_quality];		
	HELP		[func_out_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		IF (func1_target_mode == BLOCK_MODE_MAN)
		{
			STATUS_INPUT_NO_RCAS
		}
		ELSE {
			STATUS_OUTPUT_NO_RCAS
		}
	}
	POST_EDIT_ACTIONS
	{
		IF (func1_target_mode == BLOCK_MODE_MAN)
		{
			method_set_status_limit
		}
	}
	HANDLING
		IF (func1_target_mode == BLOCK_MODE_MAN)
		{
			READ & WRITE;
		}
		ELSE {
			READ;
		}
}

func1_out_status_limit						LIKE VARIABLE	func1_out_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		IF (func1_target_mode == BLOCK_MODE_MAN)
		{
			STATUS_INPUT_LIMIT (func1_out_status_quality)
		}
		ELSE {
			STATUS_OUTPUT_LIMIT
		}
	}
}

VARIABLE func1_out_upper_range_value
{
	LABEL		"Travel range high";
	HELP		[func_out_scale_upper_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	100.0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_out_lower_range_value
{
	LABEL		"Travel range low";
	HELP		[func_out_scale_lower_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func1_out_unit
{
	LABEL		[func_out_scale_unit];
	HELP		[func_out_scale_unit_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	1342;
		{ 1342,  [Percent],	[Percent_help]	}
/*		{ 1005,  [degrees],	[degrees_help]	}
		{ 1012,  [cm],		[cmhelp]	}
		{ 1013,  [mm],		[mm_help]	}
		{ 1019,  [in],		[in_help]	}  */
	}
	HANDLING	READ & WRITE;
}

func1_out_decimal_point						LIKE VARIABLE	func1_pv_decimal_point
{
}


/***********************************************************************/
/*    Unit relations                                                   	    */
/***********************************************************************/

/* Physical Block */
/* no unit relations */

/* Transducer Block */
/* no unit relations */


/* Function Block Analog Output */
UNIT AO_PV_SCALE_UNIT
{
	func1_pv_unit:

	func1_pv_upper_range_value,
	func1_pv_lower_range_value,
	func1_readback_value,
	func1_setpoint_value,
	func1_rcas_in_value,
	func1_rcas_out_value,  
	func1_fsafe_value,
	func1_simulate_value,
	diff_alarm_distance,
}

//UNIT AI1_OUT_SCALE_UNIT
UNIT AO_OUT_SCALE_UNIT
{
	func1_out_unit:

	func1_out_value,
	func1_out_upper_range_value,
	func1_out_lower_range_value,
}
 /* Function Block2  Analog Input */
//UNIT AI2_OUT_SCALE_UNIT
UNIT AI1_OUT_SCALE_UNIT
{
	func2_out_unit:

	func2_out_value,
	func2_out_upper_range_value,
	func2_out_lower_range_value,
/*	func2_alarm_hys,   */
	func2_hi_hi_lim,
	func2_hi_lim,
	func2_lo_lo_lim,
	func2_lo_lim,
	func2_simulate_value,
	trans2_meas_value
}
// UNIT AI3_OUT_SCALE_UNIT
 UNIT AI2_OUT_SCALE_UNIT
{
	func3_out_unit:

	func3_out_value,
	func3_out_upper_range_value,
	func3_out_lower_range_value,
	func3_alarm_hys,
	func3_hi_hi_lim,
	func3_hi_lim,
	func3_lo_lo_lim,
	func3_lo_lim,
	func3_simulate_value,
	trans3_primary_value
}   
/***********************************************************************/
/*    Refresh relations                                                   	    */
/***********************************************************************/

/* Physical Block */
/* no refresh relations */

 /* Transducer Block */
REFRESH target_mode_trans
{
	trans1_target_mode:

/*			trans1_rated_travel_value,*/ 	//jonas
			trans1_setp_cutoff_dec,
			trans1_setp_cutoff_inc,
			trans1_valve_ser_num,
			trans1_actuator_action,
			trans1_total_valve_travel_limit,
			trans1_actuator_ser_num,
			trans1_travel_limit_lower_value,
			trans1_travel_limit_upper_value,
			trans1_valve_man,
			trans1_actuator_man,
			trans1_valve_type,
			trans1_lin_type,
			trans1_tab_actual_number,
			trans1_tab_x_value_0,
			trans1_tab_y_value_0,
			trans1_tab_x_value_1,
			trans1_tab_y_value_1,
			trans1_tab_x_value_2,
			trans1_tab_y_value_2
			trans1_tab_x_value_3,
			trans1_tab_y_value_3,
			trans1_tab_x_value_4,
			trans1_tab_y_value_4
			trans1_tab_x_value_5,
			trans1_tab_y_value_5,
			trans1_tab_x_value_6,
			trans1_tab_y_value_6,
			trans1_tab_x_value_7,
			trans1_tab_y_value_7,
			trans1_tab_x_value_8,
			trans1_tab_y_value_8 
			trans1_tab_x_value_9,
			trans1_tab_y_value_9,
			trans1_tab_x_value_10,
			trans1_tab_y_value_10,
			trans1_tab_x_value_11,
			trans1_tab_y_value_11,
			trans1_tab_x_value_12,
			trans1_tab_y_value_12,
			trans1_tab_x_value_13,
			trans1_tab_y_value_13,
			trans1_tab_x_value_14,
			trans1_tab_y_value_14,
			trans1_tab_x_value_15,
			trans1_tab_y_value_15,
			trans1_tab_x_value_16,
			trans1_tab_y_value_16
 			trans1_tab_x_value_17,
			trans1_tab_y_value_17,
			trans1_tab_x_value_18,
			trans1_tab_y_value_18,
			trans1_tab_x_value_19,
			trans1_tab_y_value_19,
			trans1_tab_x_value_20,
			trans1_tab_y_value_20,
	    		trans1_tab_x_value_21,
			trans1_tab_y_value_21,
			trans1_tab_x_value_22,
			trans1_tab_y_value_22,
			trans1_tab_x_value_23,
			trans1_tab_y_value_23,
			trans1_tab_x_value_24,
			trans1_tab_y_value_24,
			trans1_tab_x_value_25,
			trans1_tab_y_value_25,
			trans1_tab_x_value_26,
			trans1_tab_y_value_26,
			trans1_tab_x_value_27,
			trans1_tab_y_value_27,
			trans1_tab_x_value_28,
			trans1_tab_y_value_28,
			trans1_tab_x_value_29,
			trans1_tab_y_value_29,
			trans1_tab_x_value_30,
			trans1_tab_y_value_30,
	    		trans1_tab_x_value_31,
			trans1_tab_y_value_31,
			trans1_tab_x_value_32,
			trans1_tab_y_value_32,	
			trans1_deadband,
			trans1_travel_rate_dec,
			trans1_travel_rate_inc,
			trans1_device_calib_date,
			trans1_device_config_date,
			trans1_valve_maintenance_date,
			trans1_servo_gain_1,
			trans1_servo_rate_1,
			trans1_servo_reset_1,
			setpoint_mode_code,
			travel_control_high,
			travel_control_low,
			lever_length,
    			language_code,
			display_code,
			dev_alarm_stat_code,
			dev_alarm_distance,
			dev_alarm_time,
			dev_en_output,
			dev_valve_action,
			limit2_alarm_stat_code,
			limit2_position_min,
			limit2_position_max,
			limit2_hysteresis,
			limit2_en_output,
			limit2_valve_action,
			limit1_alarm_stat_code,
			limit1_position_min,
			limit1_position_max,
			limit1_hysteresis,
			limit1_en_output,
			limit1_valve_action,
			aux_alarm_stat_code,
			aux_min_value,
			aux_max_value,
			aux_hysteresis,
			aux_en_output,
			aux_valve_action,
			temp_alarm_stat_code,
			temp_min,
			temp_max,
			temp_hysteresis,
			temp_en_output,
			temp_valve_action,
			diff_alarm_stat_code,
			diff_alarm_distance,
			diff_en_output,
			diff_valve_action,
			actuator_size,
			actuator_function,
			failsafe_alarm_en_out
}
REFRESH ao_target
{
	func1_target_mode:

  			func1_batch_id, 
			func1_batch_unit, 
			func1_batch_operation, 
			func1_batch_phase,
			func1_fsafe_type,
			func1_fsafe_time,
			func1_fsafe_value,
			func1_increase_close,
			func1_pv_lower_range_value,
			func1_pv_upper_range_value,
			func1_pv_unit,
			func1_out_lower_range_value,
			func1_out_upper_range_value,
			func1_out_unit
}
REFRESH func2_unit_change
{
	func2_out_unit:

	func2_alarm_hys
}
REFRESH func3_unit_change
{
	func3_out_unit:

	func3_out_value,
	func3_out_upper_range_value,
	func3_out_lower_range_value,
	func3_alarm_hys,
	func3_hi_hi_lim,
	func3_hi_lim,
	func3_lo_lo_lim,
	func3_lo_lim,
	func3_simulate_value,
	trans3_primary_value
}   


 /***********************************************************************/
/*    AI Function Block                                                   */
/***********************************************************************/
//#include "SIPASTAI2_300.inc"

BLOCK function_block_2
{
	TYPE	FUNCTION;
	NUMBER	2;
}

VARIABLE func2_blk_reserve
{
	LABEL		[blk_reserved];
	HELP		[blk_reserved_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func2_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	2,	[blk_block_object_FUNCTION]		}
	}
	HANDLING	READ;
}

VARIABLE func2_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[func_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	1,	[func_blk_parent_class_INPUT]	}
	}
	HANDLING	READ;
}

VARIABLE func2_blk_class
{
	LABEL		[blk_class];
	HELP		[func_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	1,	[func_blk_class_AI]			}
	}	
	HANDLING	READ;
}

func2_blk_dd_reference						LIKE VARIABLE	phys_blk_dd_reference
{											
}											
											
func2_blk_dd_rev						LIKE VARIABLE	phys_blk_dd_rev
{											
}											
											
func2_blk_profile						LIKE VARIABLE	phys_blk_profile
{											
}											
											
func2_blk_profile_rev						LIKE VARIABLE	phys_blk_profile_rev
{											
}											
											
func2_blk_execution_time					LIKE VARIABLE	phys_blk_execution_time
{											
}											
											
func2_blk_num_parameters					LIKE VARIABLE	phys_blk_num_parameters
{											
}											
											
func2_blk_index_view_1						LIKE VARIABLE	phys_blk_index_view_1
{											
}

func2_blk_num_view_lists					LIKE VARIABLE	phys_blk_num_view_lists
{											
}											
											
func2_st_rev								LIKE VARIABLE	phys_st_rev
{											
} 											
											
func2_tag_desc								LIKE VARIABLE	phys_tag_desc
{											
}											
											
func2_strategy								LIKE VARIABLE	phys_strategy
{											
}											
											
func2_alert_key								LIKE VARIABLE	phys_alert_key
{											
}

func2_target_mode							LIKE VARIABLE	phys_target_mode
{
	REDEFINE TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
}

func2_actual_mode							LIKE VARIABLE	phys_actual_mode
{
	REDEFINE TYPE		ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
}

func2_permitted_mode						LIKE VARIABLE	phys_permitted_mode
{
	REDEFINE TYPE		BIT_ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
}

func2_normal_mode							LIKE VARIABLE	phys_normal_mode
{
	REDEFINE TYPE		ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
}

func2_current_state_alarm_sum				LIKE VARIABLE	phys_current_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

func2_unacknowledged_state_alarm_sum		LIKE VARIABLE	phys_unacknowledged_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

func2_unreported_state_alarm_sum			LIKE VARIABLE	phys_unreported_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

func2_disabled_state_alarm_sum				LIKE VARIABLE	phys_disabled_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

VARIABLE func2_batch_id
{
	LABEL		[func_batch_id];		
	HELP		[func_batch_id_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func2_batch_unit
{
	LABEL		[func_batch_unit];		
	HELP		[func_batch_unit_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func2_batch_operation
{
	LABEL		[func_batch_operation];		
	HELP		[func_batch_operation_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func2_batch_phase
{
	LABEL		[func_batch_phase];		
	HELP		[func_batch_phase_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}
 /*****************************************************************************/
 /*       AI FB Temp										*/
 /*****************************************************************************/

VARIABLE func2_out_value
{
	LABEL		[func_out_value];
	HELP		[func_ai_out_value_help];
	CLASS		OUTPUT & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
		DISPLAY_FORMAT ".2f" ;
	}
	HANDLING
	IF	(	func2_target_mode ==  BLOCK_MODE_MAN)
   		{
   		  		READ & WRITE;
   		}
   	 ELSE 
   	 	{
   				READ;
   		}
	
}
VARIABLE func2_out_status_quality
{
	LABEL		[status_quality];
	HELP		[func_out_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit
	}
	HANDLING
	IF	(	func2_target_mode ==  BLOCK_MODE_MAN)
   		{
   		  		READ & WRITE;
   		}
   	 ELSE 
   	 	{
   				READ;
   		}
	
}
func2_out_status_limit					LIKE VARIABLE	func2_out_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_LIMIT (func2_out_status_quality)
	}
}

VARIABLE func2_pv_upper_range_value
{
	LABEL		[func_pv_scale_upper_value];
	HELP		[func_pv_scale_upper_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT;
	HANDLING	READ & WRITE;
}

VARIABLE func2_pv_lower_range_value
{
	LABEL		[func_pv_scale_lower_value];
	HELP		[func_pv_scale_lower_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT;
	HANDLING	READ & WRITE;
}



VARIABLE func2_out_upper_range_value
{
	LABEL		[func_out_scale_upper_value];
	HELP		[func_out_scale_upper_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	100.0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func2_out_lower_range_value
{
	LABEL		[func_out_scale_lower_value];
	HELP		[func_out_scale_lower_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func2_out_unit
{
	LABEL		[func_out_scale_unit];
	HELP		[func_out_scale_unit_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	1001;
/* Temperature */
		{ 1000,	[unit_1000],	[unit_1000_help]	},	\
		{ 1001,	[unit_1001],	[unit_1001_help]	},	\
		{ 1002,	[unit_1002],	[unit_1002_help]	}
	}
	HANDLING	READ & WRITE;
}

func2_out_decimal_point				LIKE VARIABLE	func1_pv_decimal_point
{
    	REDEFINE HANDLING
	 READ & WRITE;
}

VARIABLE func2_channel
{
	LABEL		[func_channel];
	HELP		[func_channel_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
   //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	func2_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func2_target_mode == BLOCK_MODE_MAN)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
}

VARIABLE func2_pv_ftime
{
	LABEL		[func_pv_ftime];
	HELP		[func_pv_ftime_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	1.0;
	}
	CONSTANT_UNIT	[sec];
	HANDLING	READ & WRITE;
}

VARIABLE func2_alarm_hys
{
	LABEL		"Temp Limit Hysteresis";//[limit_hysteresis];
	HELP		[limit_hysteresis_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	5.0;	// jonas
		MIN_VALUE		0.0;	// jonas
//		MAX_VALUE		36.0;	// jonas		//hla 14.06.2007
		MAX_VALUE		20.0;	// jonas
	}
	HANDLING	READ & WRITE;
}

VARIABLE func2_hi_hi_lim
{
	LABEL		"Temp Limit Hi-Hi";// [limit_hi_hi];
	HELP		[limit_hi_hi_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	100.0;// jonas
		MIN_VALUE		-40.0;// jonas
		MAX_VALUE		120.0;
//		MAX_VALUE		393.1;// jonas	//hla	14.06.2007
	}
	HANDLING	READ & WRITE;
}
VARIABLE func2_hi_lim
{
	LABEL		"Temp Limit Hi";//[limit_hi];
	HELP		[limit_hi_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	100.0; // jonas
		MIN_VALUE		-40.0;// jonas
		MAX_VALUE		120.0;
//		MAX_VALUE		393.1;// jonas	//hla	14.06.2007
	}
	HANDLING	READ & WRITE;
}

VARIABLE func2_lo_lim
{
	LABEL		"Temp Limit Lo";//[limit_lo];
	HELP		[limit_lo_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;// jonas
		MIN_VALUE		-40.0;// jonas
		MAX_VALUE		120.0;
//		MAX_VALUE		393.1;// jonas	//hla	14.06.2007
	}
	HANDLING	READ & WRITE;
}

VARIABLE func2_lo_lo_lim
{
	LABEL		"Temp Limit Lo-Lo";//[limit_lo_lo];
	HELP		[limit_lo_lo_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE    0.0; // jonas
		MIN_VALUE		-40.0;// jonas
		MAX_VALUE		120.0;
//		MAX_VALUE		393.1;// jonas	//hla	14.06.2007
	}
	HANDLING	READ & WRITE;
}

VARIABLE func2_hi_hi_alm_unacknowledged
{
	LABEL		[limit_alarm_unacknowledged];
	HELP		[limit_alarm_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func2_hi_hi_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_hi_hi_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[limit_state_NO_ALARM]	},
		{	1,	[limit_state_HI_HI]		}
	}
	HANDLING	READ;
}

VARIABLE func2_hi_hi_alm_time_stamp 	
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE func2_hi_hi_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_hi_hi_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func2_hi_hi_alm_value
{
	LABEL		[limit_alarm_value];
	HELP		[limit_hi_hi_alarm_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}	

VARIABLE func2_hi_alm_unacknowledged
{
	LABEL		[limit_warn_unacknowledged];
	HELP		[limit_warn_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func2_hi_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_hi_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[limit_state_NO_WARNING]	},
		{	1,	[limit_state_HI]			}
	}
	HANDLING	READ;
}

VARIABLE func2_hi_alm_time_stamp 	
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE func2_hi_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_hi_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func2_hi_alm_value
{
	LABEL		[limit_warn_value];
	HELP		[limit_hi_warn_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func2_lo_alm_unacknowledged
{
	LABEL		[limit_warn_unacknowledged];
	HELP		[limit_warn_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func2_lo_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_lo_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[limit_state_NO_WARNING]	},
		{	1,	[limit_state_LO]			}
	}
	HANDLING	READ;
}

VARIABLE func2_lo_alm_time_stamp 	
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE func2_lo_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_lo_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func2_lo_alm_value
{
	LABEL		[limit_warn_value];
	HELP		[limit_lo_warn_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func2_lo_lo_alm_unacknowledged
{
	LABEL		[limit_alarm_unacknowledged];
	HELP		[limit_alarm_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);   
	HANDLING	READ;
}

VARIABLE func2_lo_lo_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_lo_lo_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[limit_state_NO_ALARM]		},
		{	1,	[limit_state_LO_LO]			}
	}
	HANDLING	READ;
}

VARIABLE func2_lo_lo_alm_time_stamp 	
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE func2_lo_lo_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_lo_lo_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func2_lo_lo_alm_value
{
	LABEL		[limit_alarm_value];
	HELP		[limit_lo_lo_alarm_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}


VARIABLE func2_simulate_value
{
	LABEL		[func_simulate_value];
	HELP		[func_ai_simulate_value_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
  //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	func2_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func2_target_mode == BLOCK_MODE_MAN)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
	
}
VARIABLE func2_simulate_status_quality
{
	LABEL		[status_quality];		
	HELP		[func_simulate_status_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit
	}
  //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	func2_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func2_target_mode == BLOCK_MODE_MAN)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
	
}

func2_simulate_status_limit					LIKE VARIABLE	func2_simulate_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_INPUT_LIMIT (func2_simulate_status_quality)
	}
}


VARIABLE func2_simulation_enabled
{
	LABEL		[func_simulation_enabled];
	HELP		[func_simulation_enabled_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE 0;
		{	0,	[disabled]		},
		{	1,	[enabled]		}
	}
  //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	func2_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func2_target_mode == BLOCK_MODE_MAN)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
	
}
/***********************************************************************/
/*    AI Function Block                                                   */
/***********************************************************************/
//#include "SIPASTAI3_300.inc"

BLOCK function_block_3
{
	TYPE	FUNCTION;
	NUMBER	3;
}

VARIABLE func3_blk_reserve
{
	LABEL		[blk_reserved];
	HELP		[blk_reserved_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func3_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	2,	[blk_block_object_FUNCTION]		}
	}
	HANDLING	READ;
}

VARIABLE func3_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[func_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	1,	[func_blk_parent_class_INPUT]	}
	}
	HANDLING	READ;
}

VARIABLE func3_blk_class
{
	LABEL		[blk_class];
	HELP		[func_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	1,	[func_blk_class_AI]			}
	}	
	HANDLING	READ;
}

func3_blk_dd_reference						LIKE VARIABLE	phys_blk_dd_reference
{											
}											
											
func3_blk_dd_rev						LIKE VARIABLE	phys_blk_dd_rev
{											
}											
											
func3_blk_profile						LIKE VARIABLE	phys_blk_profile
{											
}											
											
func3_blk_profile_rev						LIKE VARIABLE	phys_blk_profile_rev
{											
}											
											
func3_blk_execution_time					LIKE VARIABLE	phys_blk_execution_time
{											
}											
											
func3_blk_num_parameters					LIKE VARIABLE	phys_blk_num_parameters
{											
}											
											
func3_blk_index_view_1						LIKE VARIABLE	phys_blk_index_view_1
{											
}

func3_blk_num_view_lists					LIKE VARIABLE	phys_blk_num_view_lists
{											
}											
											
func3_st_rev								LIKE VARIABLE	phys_st_rev
{											
} 											
											
func3_tag_desc								LIKE VARIABLE	phys_tag_desc
{											
}											
											
func3_strategy								LIKE VARIABLE	phys_strategy
{											
}											
											
func3_alert_key								LIKE VARIABLE	phys_alert_key
{											
}

func3_target_mode							LIKE VARIABLE	phys_target_mode
{
	REDEFINE TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
}

func3_actual_mode							LIKE VARIABLE	phys_actual_mode
{
	REDEFINE TYPE		ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
}

func3_permitted_mode						LIKE VARIABLE	phys_permitted_mode
{
	REDEFINE TYPE		BIT_ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
}

func3_normal_mode							LIKE VARIABLE	phys_normal_mode
{
	REDEFINE TYPE		ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
}

func3_current_state_alarm_sum				LIKE VARIABLE	phys_current_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

func3_unacknowledged_state_alarm_sum		LIKE VARIABLE	phys_unacknowledged_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

func3_unreported_state_alarm_sum			LIKE VARIABLE	phys_unreported_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

func3_disabled_state_alarm_sum				LIKE VARIABLE	phys_disabled_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]		},
		{	0x0400,	[limit_state_HI]		},
		{	0x0800,	[limit_state_LO_LO]		},
		{	0x1000,	[limit_state_LO]		},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

VARIABLE func3_batch_id
{
	LABEL		[func_batch_id];		
	HELP		[func_batch_id_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func3_batch_unit
{
	LABEL		[func_batch_unit];		
	HELP		[func_batch_unit_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func3_batch_operation
{
	LABEL		[func_batch_operation];		
	HELP		[func_batch_operation_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func3_batch_phase
{
	LABEL		[func_batch_phase];		
	HELP		[func_batch_phase_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}
 /*****************************************************************************/
 /*       AI FB Aux										*/
 /*****************************************************************************/

VARIABLE func3_out_value
{
	LABEL		[func_out_value];
	HELP		[func_ai_out_value_help];
	CLASS		OUTPUT & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
		DISPLAY_FORMAT ".2f" ;
	}
	HANDLING	
	IF	(	func3_target_mode ==  BLOCK_MODE_MAN)
   		{
   		  		READ & WRITE;
   		}
   	 ELSE 
   	 	{
   				READ;
   		}

}

VARIABLE func3_out_status_quality
{
	LABEL		[status_quality];
	HELP		[func_out_status_help];
	CLASS		OUTPUT & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit
	}
	HANDLING
	IF	(	func3_target_mode ==  BLOCK_MODE_MAN)
   		{
   		  		READ & WRITE;
   		}
   	 ELSE 
   	 	{
   				READ;
   		}
	
}
func3_out_status_limit					LIKE VARIABLE	func3_out_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_LIMIT (func3_out_status_quality)
	}
}

VARIABLE func3_pv_upper_range_value
{
	LABEL		[func_pv_scale_upper_value];
	HELP		[func_pv_scale_upper_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT;
	HANDLING	READ & WRITE;
}

VARIABLE func3_pv_lower_range_value
{
	LABEL		[func_pv_scale_lower_value];
	HELP		[func_pv_scale_lower_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT;
	HANDLING	READ & WRITE;
}



VARIABLE func3_out_upper_range_value
{
	LABEL		[func_out_scale_upper_value];
	HELP		[func_out_scale_upper_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	100.0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func3_out_lower_range_value
{
	LABEL		[func_out_scale_lower_value];
	HELP		[func_out_scale_lower_value_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE func3_out_unit
{
	LABEL		[func_out_scale_unit];
	HELP		[func_out_scale_unit_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	1342;// jonas
/* Auxillary */
		{ 1211,	[unit_1211],	[unit_1211_help]	},	\
		{ 1342,	[unit_1342],	[unit_1342_help]	}
	}
	HANDLING	READ & WRITE;
}

func3_out_decimal_point				LIKE VARIABLE	func1_pv_decimal_point
{
}

VARIABLE func3_channel
{
	LABEL		[func_channel];
	HELP		[func_channel_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
   //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	func3_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func3_target_mode == BLOCK_MODE_MAN)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
}

VARIABLE func3_pv_ftime
{
	LABEL		[func_pv_ftime];
	HELP		[func_pv_ftime_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	1.0;
	}
	CONSTANT_UNIT	[sec];
	HANDLING	READ & WRITE;
}

VARIABLE func3_alarm_hys
{
	LABEL		"Aux Limit Hysteresis";//[limit_hysteresis];
	HELP		[limit_hysteresis_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	2.0;	// jonas
		MIN_VALUE		0.0;	// jonas
		MAX_VALUE		20.0;	// jonas
	}
	HANDLING	READ & WRITE;
}

VARIABLE func3_hi_hi_lim
{
	LABEL		"Aux Limit Hi-Hi";//[limit_hi_hi];
	HELP		[limit_hi_hi_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	100.0;// jonas
		MIN_VALUE		0.0;// jonas
		MAX_VALUE		120.0;// jonas
	}
	HANDLING	READ & WRITE;
}

VARIABLE func3_hi_lim
{
	LABEL		"Aux Limit Hi";//[limit_hi];
	HELP		[limit_hi_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	100.0; // jonas
		MIN_VALUE		0.0;// jonas
		MAX_VALUE		120.0;// jonas
	}
	HANDLING	READ & WRITE;
}

VARIABLE func3_lo_lim
{
	LABEL		"Aux Limit Lo";//[limit_lo];
	HELP		[limit_lo_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0; // jonas
		MIN_VALUE		-20.0;// jonas
		MAX_VALUE		100.0;// jonas
	}
	HANDLING	READ & WRITE;
}

VARIABLE func3_lo_lo_lim
{
	LABEL		"Aux Limit Lo-Lo";//[limit_lo_lo];
	HELP		[limit_lo_lo_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE    0.0; // jonas
		MIN_VALUE		-20.0;// jonas
		MAX_VALUE		100.0;// jonas
	}
	HANDLING	READ & WRITE;
}

VARIABLE func3_hi_hi_alm_unacknowledged
{
	LABEL		[limit_alarm_unacknowledged];
	HELP		[limit_alarm_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func3_hi_hi_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_hi_hi_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[limit_state_NO_ALARM]	},
		{	1,	[limit_state_HI_HI]		}
	}
	HANDLING	READ;
}

VARIABLE func3_hi_hi_alm_time_stamp 	
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE func3_hi_hi_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_hi_hi_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func3_hi_hi_alm_value
{
	LABEL		[limit_alarm_value];
	HELP		[limit_hi_hi_alarm_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}	

VARIABLE func3_hi_alm_unacknowledged
{
	LABEL		[limit_warn_unacknowledged];
	HELP		[limit_warn_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func3_hi_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_hi_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[limit_state_NO_WARNING]	},
		{	1,	[limit_state_HI]			}
	}
	HANDLING	READ;
}

VARIABLE func3_hi_alm_time_stamp 	
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE func3_hi_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_hi_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func3_hi_alm_value
{
	LABEL		[limit_warn_value];
	HELP		[limit_hi_warn_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func3_lo_alm_unacknowledged
{
	LABEL		[limit_warn_unacknowledged];
	HELP		[limit_warn_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func3_lo_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_lo_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[limit_state_NO_WARNING]	},
		{	1,	[limit_state_LO]			}
	}
	HANDLING	READ;
}

VARIABLE func3_lo_alm_time_stamp 	
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE func3_lo_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_lo_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func3_lo_alm_value
{
	LABEL		[limit_warn_value];
	HELP		[limit_lo_warn_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func3_lo_lo_alm_unacknowledged
{
	LABEL		[limit_alarm_unacknowledged];
	HELP		[limit_alarm_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);   
	HANDLING	READ;
}

VARIABLE func3_lo_lo_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_lo_lo_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[limit_state_NO_ALARM]		},
		{	1,	[limit_state_LO_LO]			}
	}
	HANDLING	READ;
}

VARIABLE func3_lo_lo_alm_time_stamp 	
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE func3_lo_lo_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_lo_lo_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func3_lo_lo_alm_value
{
	LABEL		[limit_alarm_value];
	HELP		[limit_lo_lo_alarm_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE func3_AI_out_status_quality
{
	LABEL		[status_quality];
	HELP		[func_out_status_help];
	CLASS		OUTPUT & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		IF (func3_AI_target_mode == BLOCK_MODE_MAN)
		{
			STATUS_INPUT_NO_RCAS
		}
		ELSE {
			STATUS_OUTPUT_NO_RCAS
		}
	}
	POST_EDIT_ACTIONS
	{
		IF (func3_AI_target_mode == BLOCK_MODE_MAN)
		{
			method_func3_set_status_limit
		}
	}
	HANDLING
		IF (func3_AI_target_mode == BLOCK_MODE_MAN)
		{
			READ & WRITE;
		}
		ELSE {
			READ;
		}
}

VARIABLE func3_AI_target_mode
{
	LABEL		[target_mode];		
	HELP		[target_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08;
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ & WRITE;
}

//func3_simulate_status	LIKE VARIABLE	func3_out_status
func3_simulate_status	LIKE VARIABLE	func3_AI_out_status_quality
{
	REDEFINE LABEL		[func_simulate_status];
	REDEFINE HELP		[func_simulate_status_help];
	REDEFINE HANDLING
		READ & WRITE;

}

VARIABLE func3_simulate_value
{
	LABEL		[func_simulate_value];
	HELP		[func_ai_simulate_value_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
  //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	func3_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func3_target_mode == BLOCK_MODE_MAN)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
	
}
VARIABLE func3_simulate_status_quality
{
	LABEL		[status_quality];		
	HELP		[func_simulate_status_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit
	}
  //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	func3_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func3_target_mode == BLOCK_MODE_MAN)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
	
}

func3_simulate_status_limit					LIKE VARIABLE	func3_simulate_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_INPUT_LIMIT (func3_simulate_status_quality)
	}
}


VARIABLE func3_simulation_enabled
{
	LABEL		[func_simulation_enabled];
	HELP		[func_simulation_enabled_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE 0;
		{	0,	[disabled]		},
		{	1,	[enabled]		}
	}
  //	HANDLING	READ & WRITE;
    	HANDLING
	IF	(	func3_target_mode == BLOCK_MODE_OUT_OF_SERVICE || func3_target_mode == BLOCK_MODE_MAN)
		{
				READ & WRITE;
		}
	 ELSE
		{
				READ;
		}
	
}

VARIABLE func3_AI_simulate_status_quality
{
	LABEL		[status_quality];
	HELP		[func_simulate_status_help];
	CLASS		CONTAINED & SERVICE;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_func3_set_status_limit
	}
	HANDLING	READ & WRITE;
}

func3_AI_out_status_limit						LIKE VARIABLE	func3_AI_out_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		{ 0x00,	[status_limit_OK]				},
		{ 0x01,	[status_limit_UNDERFLOW]		},
		{ 0x02,	[status_limit_OVERFLOW]			},
		{ 0x03,	[status_limit_VALUE_CONSTANT]	}
	}
}
func3_AI_simulate_status_limit					LIKE VARIABLE	func3_AI_simulate_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		{ 0x00,	[status_limit_OK]				},
		{ 0x01,	[status_limit_UNDERFLOW]		},
		{ 0x02,	[status_limit_OVERFLOW]			},
		{ 0x03,	[status_limit_VALUE_CONSTANT]	}
	}
}


/*******************************************************************************/
/*****	Methods		************************************************************/
/*******************************************************************************/

METHOD method_func3_set_status_limit
{
	CLASS		INPUT;
	DEFINITION
	{
		int	quality;
		int block_mode;

		quality = ivar_value(func3_AI_simulate_status_quality);
		if ((quality == 0x20) || (quality == 0x30))
			iassign(func3_AI_simulate_status_limit, 0);

		block_mode	= ivar_value(func3_AI_target_mode);
		quality		= ivar_value(func3_AI_out_status_quality);
		if ((block_mode == BLOCK_MODE_MAN) && ((quality == 0x20) || (quality == 0x30)))
			iassign(func3_AI_out_status_limit, 0);
	}
}


/********************************************************************/
/*		Refresh relations			 */
/********************************************************************/


/*******************************************************************************/
/*****	MENU Bar  **************************************************************/
/*******************************************************************************/

MENU Menu_Main_Specialist
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_S_Device,
		Menu_View,
		Menu_S_Options,
		Menu_Help
	}
}

MENU Menu_Main_Maintenance
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_M_Device,
		Menu_View,
		Menu_Options,
		Menu_Help
	}
}


/*---------------------------------------------------------------------*/
/*    Menu: Device				*/
/*---------------------------------------------------------------------*/

MENU Menu_S_Device
{
	LABEL		[menu_Device];
	ITEMS
	{
		std_NodeAddress,
		SEPARATOR,
		std_LoadinDevice,										
		std_LoadinPC,
		SEPARATOR,
		OnlineDialog_operation_1,
		OnlineDialog_operation_2,
		OnlineDialog_operation_3,
		mode_method,
		OnlineDialog_reset,
		SEPARATOR,
		OnlineDialog_self_calibration,
		OnlineDialog_write_locking
	}
}

MENU Menu_M_Device
{
	LABEL		[menu_Device];
	ITEMS
	{
		std_LoadinDevice,										
		std_LoadinPC											
	}
}

METHOD std_NodeAddress
{
	LABEL		[menu_Device_NodeAddress];
	DEFINITION
	{
	}
}

METHOD std_LoadinDevice
{
	LABEL		[menu_Device_LoadinDevice];
	DEFINITION
	{
	}
}

METHOD std_LoadinPC
{
	LABEL		[menu_Device_LoadinPC];
	DEFINITION
	{
	}
}


/*---------------------------------------------------------------------*/
/*    Menu: View													   */
/*---------------------------------------------------------------------*/

MENU Menu_View
{
	LABEL		[menu_View];
	ITEMS
	{
		OnlineWindow_display,
		OnlineWindow_yt,
		OnlineWindow_diagnosis,
		OnlineWindow_S_alarm,
		OnlineWindow_S_alarm_2,
		OnlineWindow_S_alarm_3,
		SEPARATOR,
		std_Funktionsleiste,
		std_Statuszeile,
		SEPARATOR,
		std_Update
	}
}

METHOD std_Funktionsleiste
{
	LABEL		[menu_View_Toolbar];
	DEFINITION
	{
	}
}

METHOD std_Statuszeile
{
	LABEL		[menu_View_Statusbar];
	DEFINITION
	{
	}
}

METHOD std_Update
{
	LABEL		[menu_View_Update];
	DEFINITION
	{
	}
}

/*---------------------------------------------------------------------*/
/*    Menu: Options													   */
/*---------------------------------------------------------------------*/

MENU Menu_S_Options
{
	LABEL		[menu_Options];
	ITEMS
	{
		std_Einstellungen,
		std_Untereintraege
#if 0
		SEPARATOR,
		OfflineDialog_CommErrorHandling
#endif
	}
}

/*******************************************************************************/
/*****	Online-Windows  **************************************************/
/*******************************************************************************/

MENU OnlineWindow_display
{
	LABEL		[menu_dialog_display];
	ITEMS
	{
		Page_display_measure,
		Page_display_out,
		Page_display_out2,
		Page_display_out3,
		Page_display_statistic	
	}
}

MENU Page_display_measure
{
	LABEL		[menu_dialog_display_measure];
	ITEMS
	{
		BarVal_display_readback,
		BarVal_display_setpoint,
		Group_display_readback,
		Group_display_setpoint,
		func1_position_discrete_value,
		func1_setpoint_deviation,
		func1_check_back,
		BarVal_out_display,
		BarVal_pv_display
	}
}

MENU BarVal_display_readback
{
	LABEL		[func_ao_readback_value];
	ITEMS
	{
		func1_readback_value,
		func1_pv_lower_range_value		(READ_ONLY),
		func1_pv_upper_range_value		(READ_ONLY)
	}
}

MENU BarVal_display_setpoint
{
	LABEL		[func_ao_setpoint_value];
	ITEMS
	{
		func1_setpoint_value			(READ_ONLY),
		func1_pv_lower_range_value		(READ_ONLY),
		func1_pv_upper_range_value		(READ_ONLY)
	}
}

MENU BarVal_out_display
{
	LABEL		[func_out_value];
	ITEMS
	{
		func2_out_value				(READ_ONLY),
		SEPARATOR,
		func2_out_status_quality		(READ_ONLY),
		func2_out_status_limit			(READ_ONLY),
		SEPARATOR,
		func2_out_lower_range_value (READ_ONLY),
		func2_out_upper_range_value	(READ_ONLY)
	}
}


MENU BarVal_pv_display
{
	LABEL		"Temp Range values";
	ITEMS
	{
		func2_pv_lower_range_value (READ_ONLY),
		func2_pv_upper_range_value (READ_ONLY)
	}
}

MENU Group_display_readback
{
	LABEL		[func_ao_readback_value];
	ITEMS
	{
		func1_readback_value,
		SEPARATOR,	
		func1_readback_status_quality,
		func1_readback_status_limit
	}
}


MENU Group_display_setpoint
{
	LABEL		[func_ao_setpoint_value];
	ITEMS
	{
		func1_setpoint_value	(READ_ONLY),
		SEPARATOR,	
		func1_setpoint_status_quality		(READ_ONLY),
		func1_setpoint_status_limit		(READ_ONLY)
	}
}

MENU Page_display_out
{
	LABEL		[menu_dialog_display_output];
	ITEMS
	{
		BarVal_display_out,
		Group_display_out,
		func1_check_back
	}
}
MENU Page_display_out2
{
	LABEL		"Temperature";
	ITEMS
	{
		BarVal_display_out_2,
		Group_display_out_2
	}
}
MENU Page_display_out3
{
	LABEL		"Aux";
	ITEMS
	{
		BarVal_display_out_3,
		Group_display_out_3
	}
}
MENU BarVal_display_out_2
{
	LABEL		[func_out_value];
	ITEMS
	{
		func2_out_value				(READ_ONLY),
		func2_out_lower_range_value		(READ_ONLY),
		func2_out_upper_range_value		(READ_ONLY)
	}
}
MENU BarVal_display_out_3
{
	LABEL		[func_out_value];
	ITEMS
	{
		func3_out_value				(READ_ONLY),
		func3_out_lower_range_value		(READ_ONLY),
		func3_out_upper_range_value		(READ_ONLY)
	}
}
MENU BarVal_display_out
{
	LABEL		[func_out_value];
	ITEMS
	{
		func1_out_value				(READ_ONLY),
		func1_out_lower_range_value		(READ_ONLY),
		func1_out_upper_range_value		(READ_ONLY)
	}
}

MENU Group_display_out
{
	LABEL		[func_out_value];
	ITEMS
	{
		func1_out_value				(READ_ONLY),
		SEPARATOR,
		func1_out_status_quality		(READ_ONLY),
		func1_out_status_limit			(READ_ONLY)
	}
}
MENU Group_display_out_2
{
	LABEL		[func_out_value];
	ITEMS
	{
		func2_out_value				(READ_ONLY),
		SEPARATOR,
		func2_out_status_quality		(READ_ONLY),
		func2_out_status_limit			(READ_ONLY)
	}
}
MENU Group_display_out_3
{
	LABEL		[func_out_value];
	ITEMS
	{
		func3_out_value				(READ_ONLY),
		SEPARATOR,
		func3_out_status_quality		(READ_ONLY),
		func3_out_status_limit			(READ_ONLY)
	}
}

MENU Page_display_statistic
{
	LABEL		[menu_dialog_display_statistic];
	ITEMS
	{
		trans1_total_valve_travel,
		trans1_total_valve_travel_limit	(READ_ONLY),
		acc_travel,
		n_cycles, 
		acc_dev
	}
}


MENU OnlineWindow_diagnosis
{
	LABEL		[menu_dialog_diagnosis];
	ITEMS
	{
		Page_diagnosis_general,
		Page_diagnosis_profile
	}
}

MENU Page_diagnosis_general
{
	LABEL		[menu_dialog_general];
	ITEMS
	{
		phys_tag_desc			(READ_ONLY),
		phys_device_man_id,
		phys_device_id,
		phys_device_ser_num,
		phys_software_rev,
		phys_hardware_rev,
		phys_install_date		(READ_ONLY),
		phys_diagnosis
	}
}

MENU Page_diagnosis_profile
{
	LABEL		[blk_profile];
	ITEMS
	{
		phys_blk_profile,
		phys_blk_profile_rev
	}
}
MENU OnlineWindow_S_alarm
{
	LABEL		[menu_dialog_alarm];
	ITEMS
	{
		Page_alarm_sum
	}
}
MENU OnlineWindow_S_alarm_2
{
	LABEL		"Temp alarm";
	ITEMS
	{
		Page_alarm_sum_2,										/* menu */
		Page_hi_hi_alm_2,										/* menu */
		Page_hi_alm_2,										/* menu */
		Page_lo_alm_2,										/* menu */
		Page_lo_lo_alm_2										/* menu */
	}
}
MENU OnlineWindow_S_alarm_3
{
	LABEL		"Aux alarm";
	ITEMS
	{
		Page_alarm_sum_3,										/* menu */
		Page_hi_hi_alm_3,										/* menu */
		Page_hi_alm_3,										/* menu */
		Page_lo_alm_3,										/* menu */
		Page_lo_lo_alm_3										/* menu */
	}
}

MENU Page_alarm_sum
{
	LABEL		[menu_dialog_alarm_sum];
	ITEMS
	{
	    func1_current_state_alarm_sum,
		func1_unacknowledged_state_alarm_sum,
		func1_unreported_state_alarm_sum,
		func1_disabled_state_alarm_sum
	}
}

MENU Page_hi_hi_alm
{
	LABEL		[limit_hi_hi];
	ITEMS
	{
		func1_hi_hi_alm_unacknowledged,
		func1_hi_hi_alm_state,
		/* func2_hi_hi_alm_time_stamp,		*/						/* variable nicht in Version 1.0 */
		func1_hi_hi_alm_subcode,
		func1_hi_hi_lim				(READ_ONLY),
		func1_hi_hi_alm_value
	}
}
VARIABLE func1_hi_hi_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_hi_hi_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[limit_state_NO_ALARM]	},
		{	1,	[limit_state_HI_HI]		}
	}
	HANDLING	READ;
}

VARIABLE func1_hi_hi_alm_unacknowledged
{
	LABEL		[limit_alarm_unacknowledged];
	HELP		[limit_alarm_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}
VARIABLE func1_hi_hi_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_hi_hi_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}
VARIABLE func1_hi_hi_lim
{
	LABEL		[limit_hi_hi];
	HELP		[limit_hi_hi_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
//		DEFAULT_VALUE DEFAULT_VALUE_func1_hi_hi_lim ;
//		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI
	}
	HANDLING	READ & WRITE;
}
VARIABLE func1_hi_hi_alm_value
{
	LABEL		[limit_alarm_value];
	HELP		[limit_hi_hi_alarm_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}
// --- macros ---------------------------------------------------



MENU Page_hi_alm
{
	LABEL		[limit_hi];
	ITEMS
	{
		func1_hi_alm_unacknowledged,
		func1_hi_alm_state,
		/* func2_hi_alm_time_stamp,		*/							/* variable nicht in Version 1.0 */
		func1_hi_alm_subcode,
		func1_hi_lim				(READ_ONLY),
		func1_hi_alm_value
	}
}
VARIABLE func1_hi_alm_unacknowledged
{
	LABEL		[limit_warn_unacknowledged];
	HELP		[limit_warn_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}
VARIABLE func1_hi_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_hi_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[limit_state_NO_WARNING]	},
		{	1,	[limit_state_HI]			}
	}
	HANDLING	READ;
}
VARIABLE func1_hi_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_hi_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}
VARIABLE func1_hi_lim
{
	LABEL		[limit_hi];
	HELP		[limit_hi_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
//		DEFAULT_VALUE DEFAULT_VALUE_func1_hi_lim ;
//		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI
	}
	HANDLING	READ & WRITE;
}
VARIABLE func1_hi_alm_value
{
	LABEL		[limit_warn_value];
	HELP		[limit_hi_warn_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}
 

MENU Page_lo_alm
{
	LABEL		[limit_lo];
	ITEMS
	{
		func1_lo_alm_unacknowledged,
		func1_lo_alm_state,
		/* func2_lo_alm_time_stamp,		*/							/* variable nicht in Version 1.0 */
		func1_lo_alm_subcode,
		func1_lo_lim				(READ_ONLY),
		func1_lo_alm_value
	}
}
VARIABLE func1_lo_alm_unacknowledged
{
	LABEL		[limit_warn_unacknowledged];
	HELP		[limit_warn_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}
VARIABLE func1_lo_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_lo_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[limit_state_NO_WARNING]	},
		{	1,	[limit_state_LO]			}
	}
	HANDLING	READ;
}
VARIABLE func1_lo_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_lo_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}
VARIABLE func1_lo_lim
{
	LABEL		[limit_lo];
	HELP		[limit_lo_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
//		DEFAULT_VALUE DEFAULT_VALUE_func1_lo_lo_lim ;
//		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI
	}
	HANDLING	READ & WRITE;
}
VARIABLE func1_lo_alm_value
{
	LABEL		[limit_warn_value];
	HELP		[limit_lo_warn_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}
 
MENU Page_lo_lo_alm
{
	LABEL		[limit_lo_lo];
	ITEMS
	{
		func1_lo_lo_alm_unacknowledged,
		func1_lo_lo_alm_state,
		/* func2_lo_lo_alm_time_stamp,		*/						/* variable nicht in Version 1.0 */
		func1_lo_lo_alm_subcode,
		func1_lo_lo_lim				(READ_ONLY),
		func1_lo_lo_alm_value
	}
}
VARIABLE func1_lo_lo_alm_unacknowledged
{
	LABEL		[limit_alarm_unacknowledged];
	HELP		[limit_alarm_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE func1_lo_lo_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_lo_lo_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[limit_state_NO_ALARM]		},
		{	1,	[limit_state_LO_LO]			}
	}
	HANDLING	READ;
}
VARIABLE func1_lo_lo_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_lo_lo_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE func1_lo_lo_alm_value
{
	LABEL		[limit_alarm_value];
	HELP		[limit_lo_lo_alarm_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

MENU Page_alarm_sum_2
{
	LABEL		[menu_dialog_alarm_sum];
	ITEMS
	{
	    func2_current_state_alarm_sum,
		func2_unacknowledged_state_alarm_sum,
		func2_unreported_state_alarm_sum,
		func2_disabled_state_alarm_sum
	}
}
VARIABLE func1_lo_lo_lim
{
	LABEL		[limit_lo_lo];
	HELP		[limit_lo_lo_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
//		DEFAULT_VALUE DEFAULT_VALUE_func1_lo_lim ;
//		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI
	}
	HANDLING	READ & WRITE;
}

MENU Page_hi_hi_alm_2
{
	LABEL		[limit_hi_hi];
	ITEMS
	{
		func2_hi_hi_alm_unacknowledged,
		func2_hi_hi_alm_state,
		/* func2_hi_hi_alm_time_stamp,		*/						/* variable nicht in Version 1.0 */
		func2_hi_hi_alm_subcode,
		func2_hi_hi_lim				(READ_ONLY),
		func2_hi_hi_alm_value
	}
}

MENU Page_hi_alm_2
{
	LABEL		[limit_hi];
	ITEMS
	{
		func2_hi_alm_unacknowledged,
		func2_hi_alm_state,
		/* func2_hi_alm_time_stamp,		*/							/* variable nicht in Version 1.0 */
		func2_hi_alm_subcode,
		func2_hi_lim				(READ_ONLY),
		func2_hi_alm_value
	}
}

MENU Page_lo_alm_2
{
	LABEL		[limit_lo];
	ITEMS
	{
		func2_lo_alm_unacknowledged,
		func2_lo_alm_state,
		/* func2_lo_alm_time_stamp,		*/							/* variable nicht in Version 1.0 */
		func2_lo_alm_subcode,
		func2_lo_lim				(READ_ONLY),
		func2_lo_alm_value
	}
}

MENU Page_lo_lo_alm_2
{
	LABEL		[limit_lo_lo];
	ITEMS
	{
		func2_lo_lo_alm_unacknowledged,
		func2_lo_lo_alm_state,
		/* func2_lo_lo_alm_time_stamp,		*/						/* variable nicht in Version 1.0 */
		func2_lo_lo_alm_subcode,
		func2_lo_lo_lim				(READ_ONLY),
		func2_lo_lo_alm_value
	}
}
MENU Page_alarm_sum_3
{
	LABEL		[menu_dialog_alarm_sum];
	ITEMS
	{
	    func3_current_state_alarm_sum,
		func3_unacknowledged_state_alarm_sum,
		func3_unreported_state_alarm_sum,
		func3_disabled_state_alarm_sum
	}
}

MENU Page_hi_hi_alm_3
{
	LABEL		[limit_hi_hi];
	ITEMS
	{
		func3_hi_hi_alm_unacknowledged,
		func3_hi_hi_alm_state,
		/* func2_hi_hi_alm_time_stamp,		*/						/* variable nicht in Version 1.0 */
		func3_hi_hi_alm_subcode,
		func3_hi_hi_lim				(READ_ONLY),
		func3_hi_hi_alm_value
	}
}

MENU Page_hi_alm_3
{
	LABEL		[limit_hi];
	ITEMS
	{
		func3_hi_alm_unacknowledged,
		func3_hi_alm_state,
		/* func2_hi_alm_time_stamp,		*/							/* variable nicht in Version 1.0 */
		func3_hi_alm_subcode,
		func3_hi_lim				(READ_ONLY),
		func3_hi_alm_value
	}
}

MENU Page_lo_alm_3
{
	LABEL		[limit_lo];
	ITEMS
	{
		func3_lo_alm_unacknowledged,
		func3_lo_alm_state,
		/* func2_lo_alm_time_stamp,		*/							/* variable nicht in Version 1.0 */
		func3_lo_alm_subcode,
		func3_lo_lim				(READ_ONLY),
		func3_lo_alm_value
	}
}

MENU Page_lo_lo_alm_3
{
	LABEL		[limit_lo_lo];
	ITEMS
	{
		func3_lo_lo_alm_unacknowledged,
		func3_lo_lo_alm_state,
		/* func2_lo_lo_alm_time_stamp,		*/						/* variable nicht in Version 1.0 */
		func3_lo_lo_alm_subcode,
		func3_lo_lo_lim				(READ_ONLY),
		func3_lo_lo_alm_value
	}
}


MENU Page_diagnosis_func_block
{
	LABEL		[blk_block_object_FUNCTION];
	ITEMS
	{
		func1_blk_object,
		func1_blk_parent_class,
		func1_blk_class,
		func1_blk_dd_reference,
		func1_blk_dd_rev,
		func1_blk_profile,
		func1_blk_profile_rev,
		func1_st_rev,
		func1_actual_mode
	}
}



/*******************************************************************************/
/*****	Online-Dialogs  ****************************************************/
/*******************************************************************************/

MENU OnlineDialog_operation_1
{
	LABEL		[menu_dialog_operation];
	ITEMS
	{
		Page_operation_AUTO,
		Page_operation_RCAS,
		Page_operation_MAN,
		Page_simulation
	}
}
MENU OnlineDialog_operation_2
{
	LABEL		"Temp operation";
	ITEMS
	{
		Page_operation_AUTO_2,
		Page_operation_MAN_2,
		Page_simulation_2
	}
}
MENU OnlineDialog_operation_3
{
	LABEL		"Aux Operation";
	ITEMS
	{
		Page_operation_AUTO_3,
		Page_operation_MAN_3,
		Page_simulation_3
	}
}

MENU Group_setpoint
{
	LABEL		[func_ao_setpoint_value];
	ITEMS
	{
		func1_setpoint_value,
		SEPARATOR,
		func1_setpoint_status_quality,
		func1_setpoint_status_limit
	}
}

MENU Group_out
{
	LABEL		[menu_output];
	ITEMS
	{
		func1_out_value,
		SEPARATOR,
		func1_out_status_quality,
		func1_out_status_limit
	}
}
MENU Group_out_2
{
	LABEL		[menu_output];
	ITEMS
	{
		func2_out_value,
		SEPARATOR,
		func2_out_status_quality,
		func2_out_status_limit
	}
}
MENU Group_out_3
{
	LABEL		[menu_output];
	ITEMS
	{
		func3_out_value,
		SEPARATOR,
		func3_out_status_quality,
		func3_out_status_limit
	}
}

MENU Group_readback
{
	LABEL		[func_ao_readback_value];
	ITEMS
	{
		func1_readback_value,
		SEPARATOR,
		func1_readback_status_quality,
		func1_readback_status_limit
	}
}

MENU Group_rcas_in
{
	LABEL		[func_rcas_in_value];
	ITEMS
	{
	  	func1_rcas_in_value,
		SEPARATOR,
		func1_rcas_in_status_quality,
		func1_rcas_in_status_limit
	}
}
MENU Group_rcas_out
{
	LABEL		[func_rcas_out_value];
	ITEMS
	{
		func1_rcas_out_value,
		SEPARATOR,
		func1_rcas_out_status_quality,
		func1_rcas_out_status_limit
	}
}

MENU Page_operation_AUTO
{
	LABEL		[mode_AUTO];
	ITEMS
	{
		func1_target_mode,
		func1_actual_mode,
		Group_setpoint,
		Group_readback,
		func1_setpoint_deviation,
		func1_check_back,
		method_set
	}
}
MENU Page_operation_AUTO_2
{
	LABEL		[mode_AUTO];
	ITEMS
	{
		func2_target_mode,
		func2_actual_mode,
//		trans2_bias,
		Group_out_2,
		method_set
	}
}
MENU Page_operation_AUTO_3
{
	LABEL		[mode_AUTO];
	ITEMS
	{
		func3_target_mode,
		func3_actual_mode,
		Group_out_3,
		method_set
	}
}

MENU Page_operation_RCAS
{
	LABEL		[mode_RCAS];
	ITEMS
	{
		func1_target_mode,
		func1_actual_mode,
		Group_rcas_in,
		Group_rcas_out,
		Group_readback,
		func1_setpoint_deviation,
		func1_check_back,
		method_set
	}
}

MENU Page_operation_MAN
{
	LABEL		[mode_MAN];
	ITEMS
	{
		func1_target_mode,
		func1_actual_mode,
		Group_out,
		Group_readback,
		func1_setpoint_deviation,
		func1_check_back,
		method_set
	}
}
MENU Page_operation_MAN_2
{
	LABEL		[mode_MAN];
	ITEMS
	{
		func2_target_mode,
		func2_actual_mode,
		Group_out_2,
		method_set
	}
}
MENU Page_operation_MAN_3
{
	LABEL		[mode_MAN];
	ITEMS
	{
		func3_target_mode,
		func3_actual_mode,
		Group_out_3,
		method_set
	}
}

MENU Page_simulation
{
	LABEL		[menu_dialog_simulation];
	ITEMS
	{
		func1_simulation_enabled,
		Group_simulation,
		func1_setpoint_deviation,
		func1_check_back,
		method_set
	}
}
MENU Page_simulation_2
{
	LABEL		[menu_dialog_simulation];
	ITEMS
	{
		func2_simulation_enabled,
		Group_simulation_2,
		method_set
	}
}
MENU Page_simulation_3
{
	LABEL		[menu_dialog_simulation];
	ITEMS
	{
		func3_simulation_enabled,
		Group_simulation_3,
		method_set
	}
}

 

MENU Group_simulation
{
	LABEL		[menu_dialog_simulation];
	ITEMS
	{
		func1_simulate_value,
		SEPARATOR,
		func1_simulate_status_quality,
		func1_simulate_status_limit
	}
}
MENU Group_simulation_2
{
	LABEL		[menu_dialog_simulation];
	ITEMS
	{
		func2_simulate_value,
		SEPARATOR,
		func2_simulate_status_quality,
		func2_simulate_status_limit
	}
}
MENU Group_simulation_3
{
	LABEL		[menu_dialog_simulation];
	ITEMS
	{
		func3_simulate_value,
		SEPARATOR,
		func3_simulate_status_quality,
		func3_simulate_status_limit
	}
}

MENU OnlineDialog_reset
{
	LABEL		[master_reset];
	HELP		[master_reset_help];
	ITEMS
	{
		Page_factory_reset,
		Page_reset_message
	}
}

MENU Page_factory_reset
{
	LABEL		[phys_factory_reset];
	HELP		[phys_factory_reset_help];
	ITEMS
	{
		phys_factory_reset,
		phys_diagnosis,
		method_set
	}
}

MENU Page_reset_message
{
	LABEL		[trans_act_self_calibration_cmd_RESET];
	HELP		[trans_act_self_calibration_cmd_RESET_help];
	ITEMS
	{
//		rename_value.TRANS_SELF_CAL_RESET,		//fbi
		func1_check_back,
		phys_diagnosis,
		method_reset_checkback
	}
}

MENU OnlineDialog_self_calibration
{
	LABEL		[trans_act_self_calibration_cmd];
	HELP		[trans_act_self_calibration_cmd_help];
	ITEMS
	{
		trans1_valve_type,
		actuator_function,
		func1_check_back,
		phys_diagnosis,
		trav_calib_methode,
		calib_methode,
		trans1_self_calibration_status
	}
}

MENU OnlineDialog_write_locking
{
	LABEL		[phys_write_locking];
	HELP		[phys_write_locking_help];
	ITEMS
	{
		phys_write_locking,
		method_set
	}
}

/*******************************************************************************/
/*****	Table: Specialist  *****************************************************/
/*******************************************************************************/

MENU Table_Main_Specialist
{
	LABEL	DEVICE_TYPE;
	ITEMS
	{
		Tab_s_ident,
		Tab_s_input,
		Tab_s_charact,
		Tab_s_interface,
		alarms,
		setup,
		Tab_s_temp_input_measwindow,
		Tab_s_aux_input_measwindow
	}
}

MENU Tab_s_ident
{
	LABEL		[menu_ident];

	ITEMS
	{
		Tab_s_ident_opunit,
		Tab_s_ident_device,
		Tab_s_ident_batch_info
	}
}

MENU Tab_s_ident_opunit
{
	LABEL		[menu_ident_opunit];
	ITEMS
	{
		phys_tag_desc,
		phys_descriptor,	
		phys_message	
	}
}

MENU Tab_s_ident_device
{
	LABEL		[menu_ident_device];
	ITEMS
	{
		phys_st_rev,
		Tab_s_ident_device_positioner,
		Tab_s_ident_device_actuator,
		Tab_s_ident_device_valve,
		Tab_s_ident_device_options
	}
}

MENU Tab_s_ident_device_positioner
{
	LABEL		[menu_ident_device_positioner];
	ITEMS
	{
		phys_device_man_id,
		phys_device_id,
//		phys_product_code,
		phys_device_ser_num,
		phys_software_rev,
		phys_hardware_rev,
		phys_install_date,
		phys_blk_profile_rev,
//		phys_hw_write_protection,
		phys_ident_number//,
//		Tab_st_rev
	}
}

MENU Tab_s_ident_device_actuator
{
	LABEL		[menu_ident_device_actuator];
	ITEMS
	{
		trans1_actuator_man,	
		trans1_actuator_type,
		actuator_size,	
		actuator_function,	
		trans1_actuator_ser_num	
	}
}

MENU Tab_s_ident_device_valve
{
	LABEL		[menu_ident_device_valve];
	ITEMS
	{
		trans1_valve_man,
		trans1_valve_type,
//		trans1_transm_angle,
//		trans1_transm_length,
		trans1_valve_ser_num	
	}
}

MENU Tab_s_ident_device_options
{
	LABEL		[menu_ident_device_addition];
	ITEMS
	{
		trans1_additional_gear_ser_number,
		trans1_additional_gear_id,
		trans1_additional_gear_install_date	
	
	}
}


MENU Tab_s_ident_batch_info
{
	LABEL		[menu_ident_batch_info];
	ITEMS
	{
			func1_batch_id,
			func1_batch_unit,
			func1_batch_operation,
			func1_batch_phase
	}
}

MENU Tab_s_input
{
	LABEL		[menu_input];
	ITEMS
	{
		trans1_st_rev,
 /*		trans1_rated_travel_value, */
		lever_length,			// jonas
		trans1_total_valve_travel,
		trans1_total_valve_travel_limit,
		Tab_s_input_input,
		Tab_s_input_workrange,
		Tab_s_input_alarm,
		Tab_s_input_table
 	}
}

MENU Tab_s_input_input
{
	LABEL		[menu_input_input];
	ITEMS
	{
		func1_increase_close,	
/*		func1_pv_lower_range_value,	
		func1_pv_upper_range_value,  */	
		func1_pv_unit,
		func1_pv_decimal_point
	}
}

MENU Tab_s_input_workrange
{
	LABEL		[menu_input_workrange];
	ITEMS
	{
		func1_out_lower_range_value,	
		func1_out_upper_range_value,	
		func1_out_unit,
		set_val
	}
}

MENU Tab_s_input_table
{
	LABEL		[menu_input_table];
	ITEMS
	{
		trans1_lin_type,
		trans1_tab_actual_number,
		trans1_tab_x_value_0	,
		trans1_tab_y_value_0,
		trans1_tab_x_value_1	,
		trans1_tab_y_value_1,
		trans1_tab_x_value_2	,
		trans1_tab_y_value_2,
		trans1_tab_x_value_3    ,
		trans1_tab_y_value_3,
		trans1_tab_x_value_4	,
		trans1_tab_y_value_4,
		trans1_tab_x_value_5	,
		trans1_tab_y_value_5,
		trans1_tab_x_value_6    ,
		trans1_tab_y_value_6,
		trans1_tab_x_value_7	,
		trans1_tab_y_value_7,
		trans1_tab_x_value_8    ,
		trans1_tab_y_value_8,
		trans1_tab_x_value_9    ,
		trans1_tab_y_value_9,
		trans1_tab_x_value_10	,
		trans1_tab_y_value_10,
		trans1_tab_x_value_11	,
		trans1_tab_y_value_11,
		trans1_tab_x_value_12	,
		trans1_tab_y_value_12,
		trans1_tab_x_value_13   ,
		trans1_tab_y_value_13,
		trans1_tab_x_value_14   ,
		trans1_tab_y_value_14,
		trans1_tab_x_value_15	,
		trans1_tab_y_value_15,
		trans1_tab_x_value_16   ,
		trans1_tab_y_value_16,
		trans1_tab_x_value_17   ,
		trans1_tab_y_value_17,
		trans1_tab_x_value_18	,
		trans1_tab_y_value_18,
		trans1_tab_x_value_19	,
		trans1_tab_y_value_19,
		trans1_tab_x_value_20	,
		trans1_tab_y_value_20 ,
		trans1_tab_x_value_21	,
		trans1_tab_y_value_21,
		trans1_tab_x_value_22	,
		trans1_tab_y_value_22,
		trans1_tab_x_value_23   ,
		trans1_tab_y_value_23,
		trans1_tab_x_value_24   ,
		trans1_tab_y_value_24,
		trans1_tab_x_value_25	,
		trans1_tab_y_value_25,
		trans1_tab_x_value_26   ,
		trans1_tab_y_value_26,
		trans1_tab_x_value_27   ,
		trans1_tab_y_value_27,
		trans1_tab_x_value_28	,
		trans1_tab_y_value_28,
		trans1_tab_x_value_29	,
		trans1_tab_y_value_29,
		trans1_tab_x_value_30	,
		trans1_tab_y_value_30,
		trans1_tab_x_value_31	,
		trans1_tab_y_value_31,
		trans1_tab_x_value_32	,
		trans1_tab_y_value_32
	}
}

MENU Tab_s_charact
{
	LABEL		"Tuning";
	ITEMS
	{
		trans1_deadband,
		Tab_s_charact_traveltime,
		Tab_s_charact_powerloss,
		expert_menu
	}
}


MENU Tab_s_interface
{
	LABEL		[menu_interface];
	ITEMS
	{
//		Tab_s_interface_simulate,		fbi
		Tab_s_interface_maintenance
	}
}
/*
MENU Tab_s_interface_simulate
{
	LABEL		[menu_interface_simulate];
	ITEMS
	{
		func1_simulation_enabled	(READ_ONLY),
		func1_simulate_value		(READ_ONLY),
		func1_simulate_status_quality	(READ_ONLY)
	}
}
//fbi 11.06.2007
*/

MENU    set_val
{ 
	LABEL   "Travel Control";
	ITEMS 
	{
		travel_control_low,
		travel_control_high,
		trans1_travel_limit_lower_value,
		trans1_travel_limit_upper_value,
		trans1_setp_cutoff_dec,
		trans1_setp_cutoff_inc		  
	} 
}

MENU Tab_s_charact_powerloss
{
	LABEL		"Fail Safe";
	ITEMS
	{
		trans1_actuator_action,	
		func1_fsafe_type,
		func1_fsafe_time,
		func1_fsafe_value,
		failsafe_alarm_en_out
	}
}

MENU Tab_s_charact_traveltime
{
	LABEL		[menu_charact_traveltime];
	ITEMS
	{
		trans1_act_stroke_time_dec,	
		trans1_act_stroke_time_inc,	
		trans1_travel_rate_dec,
		trans1_travel_rate_inc
	}
}

MENU    setup
{ 
	LABEL   "Setup D3";
	ITEMS 
	{
		 
		protection, 
		appearance
		

	}
}


MENU    PID_param 
{
	LABEL   "PID Parameters"; 
	ITEMS
	{ 
		trans1_servo_gain_1, 
		trans1_servo_reset_1,
		trans1_servo_rate_1	  	    
	} 
}


		
 /* --------------ALARM MENUES----------------------------------------*/
 MENU    alarms
{ 
	LABEL   "Alarm config";
	ITEMS 
	{
		dev_off,   
/*		limit_1_on, 
		limit_2_off, */
		pot_aux  
/*		aux_off, 
		temp_alarm  */
	}
}
/* Jonas
MENU 			temp_alarm 
 {
	LABEL   "Temperature alarm"; 
	ITEMS
	{ 
		temp_alarm_stat_code			(DISPLAY_VALUE), 
//		temp_min				(DISPLAY_VALUE),  
//		temp_max 				(DISPLAY_VALUE),
//		temp_hysteresis				(DISPLAY_VALUE),
		temp_en_output			(DISPLAY_VALUE), 
		temp_valve_action			(DISPLAY_VALUE)	 
	}
}
*/
MENU 			pot_aux 
 {			  
	LABEL   "Difference Alarm"; 
	ITEMS
	{ 
		diff_alarm_stat_code		(DISPLAY_VALUE), 
		diff_alarm_distance		(DISPLAY_VALUE),
		diff_en_output  		(DISPLAY_VALUE),  
		diff_valve_action		(DISPLAY_VALUE)	 
	}
}


	                  	                
MENU    appearance
{ 
	LABEL   "Config Local Display";
	ITEMS 
	{
	    	language_code, 
	    	display_code
	} 
}


MENU    expert_menu 
{
	LABEL   "Expert Menu"; 
	ITEMS
	{ 
		PID_param	    
	} 
}
MENU    toglemenu 
{
	LABEL   "Toggle test"; 
	ITEMS
	{ 
		toggle_time,
		toggle_amplitude,
		toggle_period,
		toggle_enable
	} 
}

MENU 			dev_off
{ 
	LABEL   "Deviation Alarm";
	ITEMS 
	{
		dev_alarm_stat_code	   (DISPLAY_VALUE)		,  
		dev_alarm_distance 	   (DISPLAY_VALUE)		, 
		dev_alarm_time		    (DISPLAY_VALUE)		,
		dev_en_output		    (DISPLAY_VALUE)		,  
		dev_valve_action	    (DISPLAY_VALUE)		   	
	} 
}

      
MENU 			Tab_s_input_alarm 
{
	LABEL   "Limit Alarm"; 
	ITEMS
	{ 
		limit1_alarm_stat_code  (DISPLAY_VALUE),
		limit2_position_min			(DISPLAY_VALUE),
		limit1_position_min		(DISPLAY_VALUE)    ,
		limit1_position_max		(DISPLAY_VALUE)    ,
		limit2_position_max			(DISPLAY_VALUE), // jonas
		limit1_hysteresis		(DISPLAY_VALUE)   ,
		limit1_en_output		(DISPLAY_VALUE)   ,
		limit1_valve_action		(DISPLAY_VALUE)
	} 
}
MENU 			limit_2_off
{ 
	LABEL   "Limit 2 Alarm";
	ITEMS 
	{
		limit2_alarm_stat_code	(DISPLAY_VALUE),
		limit2_position_min			(DISPLAY_VALUE),
		limit2_position_max			(DISPLAY_VALUE),
		limit2_hysteresis 			(DISPLAY_VALUE),
		limit2_en_output 			(DISPLAY_VALUE),
		limit2_valve_action		(DISPLAY_VALUE)
	}
}
/*
MENU 			aux_off 
{
	LABEL   "Aux alarm"; 
	ITEMS
	{ 
		aux_alarm_stat_code	(DISPLAY_VALUE),
//		aux_min_value 				(DISPLAY_VALUE),
//		aux_max_value				(DISPLAY_VALUE),
//		aux_hysteresis 				(DISPLAY_VALUE),
		aux_en_output			(DISPLAY_VALUE),
		aux_valve_action	(DISPLAY_VALUE)
	} 
}
*/


 MENU    protection 
{
	LABEL   "Enter Passwords"; 
	ITEMS
	{ 
		advanced_m_pw,
		reset_pw,
		write_protect_pw,
		expert_m_pw 
	}
}
 
MENU Tab_s_const
{
	LABEL		[menu_construct];
	ITEMS
	{
		actuator_size
	}
}



MENU Tab_s_interface_maintenance
{
	LABEL		[menu_interface_maintenance];
	ITEMS
	{
		trans1_device_calib_date,
		trans1_device_config_date,
		trans1_valve_maintenance_date
	}
}	    



/*******************************************************************************/
/*****	Table: Maintenance  ****************************************************/
/*******************************************************************************/

MENU Table_Main_Maintenance
{
	LABEL	DEVICE_TYPE;
	ITEMS
	{
		Tab_m_ident
	}
}

MENU Tab_m_ident
{
	LABEL		[menu_ident];

	ITEMS
	{
		Tab_m_ident_opunit,
		Tab_m_ident_device
	}
}

MENU Tab_m_ident_opunit
{
	LABEL		[menu_ident_opunit];
	ITEMS
	{
		phys_tag_desc		(READ_ONLY),
		phys_descriptor,	
		phys_message	
	}
}

MENU Tab_m_ident_device
{
	LABEL		[menu_ident_device];
	ITEMS
	{
		Tab_m_ident_device_positioner,
		Tab_m_ident_device_actuator,
		Tab_m_ident_device_valve
	}
}

MENU Tab_m_ident_device_positioner
{
	LABEL		[menu_ident_device_positioner];
	ITEMS
	{
		phys_device_man_id,
		phys_device_id,
//		phys_product_code,
		phys_device_ser_num,
		phys_software_rev,
		phys_hardware_rev,
		phys_install_date			(READ_ONLY),
		phys_blk_profile_rev,
		phys_ident_number			(READ_ONLY)//,
//		Tab_st_rev
	}
}

MENU Tab_m_ident_device_actuator
{
	LABEL		[menu_ident_device_actuator];
	ITEMS
	{
		trans1_actuator_man			(READ_ONLY),	
		trans1_actuator_type		(READ_ONLY),	
		actuator_size				(READ_ONLY),
		actuator_function			(READ_ONLY),	
		trans1_actuator_ser_num		(READ_ONLY)	
	}
}

MENU Tab_m_ident_device_valve
{
	LABEL		[menu_ident_device_valve];
	ITEMS
	{
		trans1_valve_man			(READ_ONLY),
		trans1_valve_type			(READ_ONLY),
//		trans1_transm_angle			(READ_ONLY),
//		trans1_transm_length		(READ_ONLY),
		trans1_valve_ser_num		(READ_ONLY)	
	}
}



/*******************************************************************************/
/*****	Methods		************************************************************/
/*******************************************************************************/

METHOD method_set
{
	LABEL		[transfer];
	HELP		[transfer_help];
	DEFINITION
	{
	}
}

METHOD method_start_table_transfer
{
	LABEL		"method_start_table_transfer";
	CLASS		INPUT;
	DEFINITION
	{
		int		n;
		int		error;
		float	y_val[33];
		float	x_val[33];
		char	text[];

		error	= 0;
		
		y_val[0]	= fvar_value(trans1_tab_y_value_0);
		y_val[1]	= fvar_value(trans1_tab_y_value_1);
		y_val[2]	= fvar_value(trans1_tab_y_value_2);
		y_val[3]	= fvar_value(trans1_tab_y_value_3);
		y_val[4]	= fvar_value(trans1_tab_y_value_4);
		y_val[5]	= fvar_value(trans1_tab_y_value_5);
		y_val[6]	= fvar_value(trans1_tab_y_value_6);
		y_val[7]	= fvar_value(trans1_tab_y_value_7);
		y_val[8]	= fvar_value(trans1_tab_y_value_8);
		y_val[9]	= fvar_value(trans1_tab_y_value_9);
		y_val[10]	= fvar_value(trans1_tab_y_value_10);
		y_val[11]	= fvar_value(trans1_tab_y_value_11);
		y_val[12]	= fvar_value(trans1_tab_y_value_12);
		y_val[13]	= fvar_value(trans1_tab_y_value_13);
		y_val[14]	= fvar_value(trans1_tab_y_value_14);
		y_val[15]	= fvar_value(trans1_tab_y_value_15);
		y_val[16]	= fvar_value(trans1_tab_y_value_16);
		y_val[17]	= fvar_value(trans1_tab_y_value_17);
		y_val[18]	= fvar_value(trans1_tab_y_value_18);
		y_val[19]	= fvar_value(trans1_tab_y_value_19);
		y_val[20]	= fvar_value(trans1_tab_y_value_20);
		y_val[21]	= fvar_value(trans1_tab_y_value_21);
		y_val[22]	= fvar_value(trans1_tab_y_value_22);
		y_val[23]	= fvar_value(trans1_tab_y_value_23);
		y_val[24]	= fvar_value(trans1_tab_y_value_24);
		y_val[25]	= fvar_value(trans1_tab_y_value_25);
		y_val[26]	= fvar_value(trans1_tab_y_value_26);
		y_val[27]	= fvar_value(trans1_tab_y_value_27);
		y_val[28]	= fvar_value(trans1_tab_y_value_28);
		y_val[29]	= fvar_value(trans1_tab_y_value_29);
		y_val[30]	= fvar_value(trans1_tab_y_value_30);
		y_val[31]	= fvar_value(trans1_tab_y_value_31);
		y_val[32]	= fvar_value(trans1_tab_y_value_32);

		x_val[0]	= fvar_value(trans1_tab_x_value_0);
		x_val[1]	= fvar_value(trans1_tab_x_value_1);
		x_val[2]	= fvar_value(trans1_tab_x_value_2);
		x_val[3]	= fvar_value(trans1_tab_x_value_3);
		x_val[4]	= fvar_value(trans1_tab_x_value_4);
		x_val[5]	= fvar_value(trans1_tab_x_value_5);
		x_val[6]	= fvar_value(trans1_tab_x_value_6);
		x_val[7]	= fvar_value(trans1_tab_x_value_7);
		x_val[8]	= fvar_value(trans1_tab_x_value_8);
		x_val[9]	= fvar_value(trans1_tab_x_value_9);
		x_val[10]	= fvar_value(trans1_tab_x_value_10);
		x_val[11]	= fvar_value(trans1_tab_x_value_11);
		x_val[12]	= fvar_value(trans1_tab_x_value_12);
		x_val[13]	= fvar_value(trans1_tab_x_value_13);
		x_val[14]	= fvar_value(trans1_tab_x_value_14);
		x_val[15]	= fvar_value(trans1_tab_x_value_15);
		x_val[16]	= fvar_value(trans1_tab_x_value_16);
		x_val[17]	= fvar_value(trans1_tab_x_value_17);
		x_val[18]	= fvar_value(trans1_tab_x_value_18);
		x_val[19]	= fvar_value(trans1_tab_x_value_19);
		x_val[20]	= fvar_value(trans1_tab_x_value_20);
		x_val[21]	= fvar_value(trans1_tab_x_value_21);
		x_val[22]	= fvar_value(trans1_tab_x_value_22);
		x_val[23]	= fvar_value(trans1_tab_x_value_23);
		x_val[24]	= fvar_value(trans1_tab_x_value_24);
		x_val[25]	= fvar_value(trans1_tab_x_value_25);
		x_val[26]	= fvar_value(trans1_tab_x_value_26);
		x_val[27]	= fvar_value(trans1_tab_x_value_27);
		x_val[28]	= fvar_value(trans1_tab_x_value_28);
		x_val[29]	= fvar_value(trans1_tab_x_value_29);
		x_val[30]	= fvar_value(trans1_tab_x_value_30);
		x_val[31]	= fvar_value(trans1_tab_x_value_31);
		x_val[32]	= fvar_value(trans1_tab_x_value_32);
				
		for (n = 1; n < trans1_tab_actual_number; n++)
		{
			if (x_val[n] < x_val[n-1])
			{
				error = 1;
				break;
			}
		}

		if (error != 0)
		{
			get_dictionary_string(lin_tab_status_NOT_INC, text);
			PUT_MESSAGE (text);
		}

		for (n = 0; n < trans1_tab_actual_number; n++)
		{
			iassign(trans1_tab_entry, n);
			WriteCommand(write_trans1_tab_entry);
			fassign(trans1_tab_x_gen,x_val[n]); 
			fassign(trans1_tab_y_gen,y_val[n]);
			WriteCommand(write_trans1_tab_x_y);
		}
	}
}


METHOD method_set_tab_entry	(int entry)
{
	LABEL		"method_set_tab_entry";
	CLASS		INPUT;
	DEFINITION
	{
		int num;
		num = entry;
		iassign(trans1_tab_entry, num);
		WriteCommand(write_trans1_tab_entry);
	}
}
METHOD method_read_tab_size  
{
	LABEL		"method_read_tab_size";
	CLASS		INPUT;
	DEFINITION
	{
		ReadCommand(read_trans1_tab_actual_number);
	}
}


METHOD method_set_status_limit
{
	LABEL		"method_set_status_limit";
	CLASS		INPUT;
	DEFINITION
	{
		int	quality;
		int block_mode;			/* !!! temp.: bis Methoden mit Aufrufparametern funktionieren !!! */

		quality = ivar_value(func1_setpoint_status_quality);
		if ((quality == 0x20) || (quality == 0x30))
			iassign(func1_setpoint_status_limit, 0);

		quality = ivar_value(func1_rcas_in_status_quality);
		if ((quality == 0x20) || (quality == 0x30))
			iassign(func1_rcas_in_status_limit, 0);

		quality = ivar_value(func1_simulate_status_quality);
		if ((quality == 0x20) || (quality == 0x30))
			iassign(func1_simulate_status_limit, 0);

		block_mode	= ivar_value(func1_target_mode);
		quality		= ivar_value(func1_out_status_quality);
		if ((block_mode == BLOCK_MODE_MAN) && ((quality == 0x20) || (quality == 0x30)))
			iassign(func1_out_status_limit, 0);
	}
}


METHOD method_reset_checkback
{
	LABEL		[trans_act_self_calibration_cmd_RESET];
	HELP		[trans_act_self_calibration_cmd_RESET_help];
	DEFINITION
	{
	}
}

METHOD    trav_calib_methode
{	
	HELP "Travel calibration"; 
	LABEL   "Travel calibrate";
	ACCESS ONLINE;
	DEFINITION 
	{
//		long ids[2];
		int result;
		int mode_c;
//		int actuator;
//		int direction_code;
//		DELAY(2,"Entering travel calibrate");	
		result = SELECT_FROM_LIST("Loose settings:", "Yes ;No");
		if (result == 0)
		{
			ReadCommand(read_func1_mode);
			mode_c = ivar_value(func1_actual_mode);
			if (mode_c == BLOCK_MODE_AUTO)
			{
				ACKNOWLEDGE("\n Set device \n Out of Service");
				iassign(func1_target_mode, BLOCK_MODE_OUT_OF_SERVICE);
				WriteCommand(write_func1_target_mode);
			}
//			DELAY(2,"Device is Out of Service");
//			ACKNOWLEDGE("Travel Calibration");	// jonas
			iassign(trans1_self_calibration_cmd, 2);
			WriteCommand(write_trans1_self_calibration_cmd);
//		 	PUT_MESSAGE("Wait while \n calibrating");
			DELAY(7,"Travel Calibration");	
			do
			{
				ReadCommand(read_trans1_self_calibration_status);
				mode_c = ivar_value(trans1_self_calibration_status);
			} while(mode_c == 1);
			switch(mode_c)
			{
				case 0 :
		 		     	break;
				case 2:
					DELAY(7,"No movement of the stem\nAborting method due to last error");
					process_abort();
  					break;		
				case 3:
				 	DELAY(7,"Potmeter failure\nAborting method due to last error");
					process_abort();
					break;
				case 4 :
					DELAY(7,"Downstroke too fast\nAborting method due to last error");
					process_abort();
					break;
				case 5 :
					DELAY(7,"Upstroke too fast\nAborting method due to last error");
					process_abort();
					break;
 				process_abort();
			}
			ACKNOWLEDGE("\n Set device \n In Service");
			iassign(func1_target_mode, BLOCK_MODE_AUTO);
			WriteCommand(write_func1_target_mode);
			
		}
	}
}
METHOD    calib_methode
{	
	HELP "Autocalibrates the device"; 
	LABEL   "Autocalibrate";
	ACCESS ONLINE;
	DEFINITION 
	{
//		long ids[2];
		int result;
		int mode_c;
		int dir_cod;
		int actuat;
//		int direction_code;
//		DELAY(2,"Entering Autocalibrate");
		result = SELECT_FROM_LIST("Loose settings:", "Yes ;No");
		if (result == 0)
		{
			ReadCommand(read_func1_mode);
			mode_c = ivar_value(func1_actual_mode);
			if (mode_c == BLOCK_MODE_AUTO)
			{
				ACKNOWLEDGE("\n Set device \n Out of Service");
				iassign(func1_target_mode, BLOCK_MODE_OUT_OF_SERVICE);
				WriteCommand(write_func1_target_mode);
 			}
	 		actuat = SELECT_FROM_LIST("Actuator type:","Rotating;Linear");// jonas
			if (actuat == 1) // jonas
			{
				assign_int(trans1_valve_type,0); // jonas Linear 
				actuat = SELECT_FROM_LIST("Actuator function:", "single acting ;double acting");
				if (actuat == 1) // jonas
					assign_int(actuator_function,0); // jonas
				else
					assign_int(actuator_function,1); // jonas
				WriteCommand(set_actuator_function);
				dir_cod = SELECT_FROM_LIST("Direction:","direct;reverse");
				assign_int(func1_increase_close,dir_cod);
   				WriteCommand(write_func1_increase_close);

				assign_int(lever_length,50);
				ReadCommand(read_lever_length);
				GET_DEV_VAR_VALUE("Lever length (mm):", lever_length);
				WriteCommand(write_lever_length);

			}
			else
			{
				assign_int(trans1_valve_type,1); // jonas Rotating
				actuat = SELECT_FROM_LIST("Actuator function:", "single acting ;double acting");
				if (actuat == 1) // jonas
					assign_int(actuator_function,0); // jonas
				else
					assign_int(actuator_function,1); // jonas
				WriteCommand(set_actuator_function);
 
				dir_cod = SELECT_FROM_LIST("Direction:","Direct;Reverse");
				assign_int(func1_increase_close,dir_cod);
   				WriteCommand(write_func1_increase_close);
			}
			WriteCommand(write_trans1_valve_type);

//			ACKNOWLEDGE("Travel Calibration");	// jonas
			assign_int(trans1_self_calibration_cmd,2);
			WriteCommand(write_trans1_self_calibration_cmd);
			DELAY(7,"Travel Calibration");	
			do
			{
  				ReadCommand(read_trans1_self_calibration_status);
				mode_c = ivar_value(trans1_self_calibration_status);
   			} while(mode_c == 1);
			switch(mode_c)
			{
				case 0 :
//					ACKNOWLEDGE("Leak Testing");	// jonas
   					assign_int(trans1_self_calibration_cmd,4);
					WriteCommand(write_trans1_self_calibration_cmd);
					DELAY(7,"Leak Testing");	
					break;
				case 2:
					DELAY(7,"No movement of the stem\nAborting method due to last error");
					process_abort();
  					break;		
				case 3:
				 	DELAY(7,"Potmeter failure\nAborting method due to last error");
					process_abort();
					break;
				case 4 :
					DELAY(7,"Downstroke too fast\nAborting method due to last error");
					process_abort();
					break;
				case 5 :
					DELAY(7,"Upstroke too fast\nAborting method due to last error");
					process_abort();
					break;
 				process_abort();
			}
			do
			{
  				ReadCommand(read_trans1_self_calibration_status);
				mode_c = ivar_value(trans1_self_calibration_status);
			} while(mode_c == 0x11);
			switch(mode_c)
			{
				case 16 :
//					ACKNOWLEDGE("Pulse Tuning");	// jonas
					assign_int(trans1_self_calibration_cmd,3);
					WriteCommand(write_trans1_self_calibration_cmd);
					DELAY(7,"Pulse Tuning");	
 					break;
				case 18:
//					ACKNOWLEDGE("Pulse Tuning");	// jonas
 					assign_int(trans1_self_calibration_cmd,3);
					WriteCommand(write_trans1_self_calibration_cmd);
					DELAY(7,"Leaking\nCalibration is continued");
 					break;		
  				process_abort();
			}
			do
			{
				ReadCommand(read_trans1_self_calibration_status);
				mode_c = ivar_value(trans1_self_calibration_status);
			} while(mode_c == 0x21);
			DELAY(7,"Step Tuning");	
			do
			{
				ReadCommand(read_trans1_self_calibration_status);
				mode_c = ivar_value(trans1_self_calibration_status);
			} while(mode_c >= 0x22);
			ACKNOWLEDGE("\n Set device \n In Service");
			iassign(func1_target_mode, BLOCK_MODE_AUTO);
			WriteCommand(write_func1_target_mode);							
		}
	}
}

/*******************************************************************************/
/*****	Commands  *******************************************************/
/*******************************************************************************/

MENU upload_variables
{
	LABEL		[menu_load_to_device];
	ITEMS
	{
	/* PHYSICAL BLOCK, STANDARD PARAMETER	*/
		phys_tag_desc,
	/* PHYSICAL BLOCK, ADDITIONAL PARAMETER	*/
		phys_descriptor,
		phys_message,
//		phys_install_date,	jonas
		phys_ident_number,
	/* TRANDSDUCER BLOCK, STANDARD PARAMETER	*/
	/* TRANDSDUCER BLOCK, ADDITIONAL PARAMETER	*/
/*		IF (O_O_SERV)
		{	 */
			IF	(	trans1_valve_type == 0)
			{
/*				trans1_rated_travel_value*/	// jonas
				lever_length			// jonas
			}
			trans1_setp_cutoff_dec,
			trans1_setp_cutoff_inc,
			trans1_valve_ser_num,
			trans1_actuator_action,
			trans1_total_valve_travel_limit,
			trans1_actuator_ser_num,
			trans1_travel_limit_lower_value,
			trans1_travel_limit_upper_value,
			trans1_valve_man,
			trans1_actuator_man,
			trans1_valve_type,
			trans1_lin_type,
			trans1_additional_gear_install_date,
			trans1_tab_actual_number,
			trans1_additional_gear_id,
			trans1_additional_gear_ser_number,
			IF (LIN_TABLE_USER)
			{
				trans1_tab_x_value_0,
				trans1_tab_y_value_0,
				trans1_tab_x_value_1,
				trans1_tab_y_value_1,
				trans1_tab_x_value_2,
				trans1_tab_y_value_2
				IF (LIN_TABLE_3)
				{
					trans1_tab_x_value_3,
					trans1_tab_y_value_3,
	  				trans1_tab_x_value_4,
					trans1_tab_y_value_4
					IF (LIN_TABLE_5)
					{
						trans1_tab_x_value_5,
						trans1_tab_y_value_5,
	 					trans1_tab_x_value_6,
						trans1_tab_y_value_6,
						trans1_tab_x_value_7,
						trans1_tab_y_value_7,
						trans1_tab_x_value_8,
						trans1_tab_y_value_8 
	 					IF (LIN_TABLE_9)
						{
		 					trans1_tab_x_value_9,
							trans1_tab_y_value_9,
							trans1_tab_x_value_10,
							trans1_tab_y_value_10,
							trans1_tab_x_value_11,
							trans1_tab_y_value_11,
							trans1_tab_x_value_12,
							trans1_tab_y_value_12,
							trans1_tab_x_value_13,
							trans1_tab_y_value_13,
							trans1_tab_x_value_14,
							trans1_tab_y_value_14,
							trans1_tab_x_value_15,
							trans1_tab_y_value_15,
							trans1_tab_x_value_16,
							trans1_tab_y_value_16
							IF (LIN_TABLE_17)
							{
								trans1_tab_x_value_17,
								trans1_tab_y_value_17,
								trans1_tab_x_value_18,
								trans1_tab_y_value_18,
								trans1_tab_x_value_19,
								trans1_tab_y_value_19,
								trans1_tab_x_value_20,
								trans1_tab_y_value_20,
						    		trans1_tab_x_value_21,
								trans1_tab_y_value_21,
								trans1_tab_x_value_22,
								trans1_tab_y_value_22,
								trans1_tab_x_value_23,
								trans1_tab_y_value_23,
								trans1_tab_x_value_24,
								trans1_tab_y_value_24,
								trans1_tab_x_value_25,
								trans1_tab_y_value_25,
								trans1_tab_x_value_26,
								trans1_tab_y_value_26,
								trans1_tab_x_value_27,
								trans1_tab_y_value_27,
								trans1_tab_x_value_28,
								trans1_tab_y_value_28,
								trans1_tab_x_value_29,
								trans1_tab_y_value_29,
								trans1_tab_x_value_30,
								trans1_tab_y_value_30,
						    		trans1_tab_x_value_31,
								trans1_tab_y_value_31,
								trans1_tab_x_value_32,
								trans1_tab_y_value_32	
							}
						}
					}
				}
			}
			trans1_deadband,
			trans1_travel_rate_dec,
			trans1_travel_rate_inc,
			trans1_device_calib_date,
			trans1_device_config_date,
			trans1_valve_maintenance_date,
			trans1_servo_gain_1,
			trans1_servo_rate_1,
			trans1_servo_reset_1,
			setpoint_mode_code,
			travel_control_high,
			travel_control_low,
			language_code,
			display_code,
			dev_alarm_stat_code,
			dev_alarm_distance,
			dev_alarm_time,
			dev_en_output,
			dev_valve_action,
			limit2_alarm_stat_code,
			limit2_position_min,
			limit2_position_max,
			limit2_hysteresis,
			limit2_en_output,
			limit2_valve_action,
			limit1_alarm_stat_code,
			limit1_position_min,
			limit1_position_max,
			limit1_hysteresis,
			limit1_en_output,
			limit1_valve_action,
			aux_alarm_stat_code,
			aux_min_value,
			aux_max_value,
			aux_hysteresis,
			aux_en_output,
			aux_valve_action,
			temp_alarm_stat_code,
			temp_min,
			temp_max,
			temp_hysteresis,
			temp_en_output,
			temp_valve_action,
			diff_alarm_stat_code,
			diff_alarm_distance,
			diff_en_output,
			diff_valve_action,
			actuator_size,
			actuator_function,
			failsafe_alarm_en_out,
 /*		}	 */
	/*								*/
	/* FUNCTION BLOCK, STANDARD PARAMETER		*/
	/* FUNCTION BLOCK, ADDITIONAL PARAMETER		*/
/*		IF	(AO_O_O_SERV)
		{	 */
			func1_batch_id, 
			func1_batch_unit, 
			func1_batch_operation, 
			func1_batch_phase,
			func1_fsafe_type,
			func1_fsafe_time,
			func1_fsafe_value,
			func1_increase_close,
			func1_pv_lower_range_value,
			func1_pv_upper_range_value,
			func1_pv_unit,
			func1_out_lower_range_value,
			func1_out_upper_range_value,
			func1_out_unit,
 /*		}	    */
		/* FUNCTION BLOCK, STANDARD PARAMETER		*/
		/* FUNCTION BLOCK, ADDITIONAL PARAMETER		*/
 /*		IF	(TEMP_O_O_SERV)
		{	 */
			func2_pv_lower_range_value,
			func2_pv_upper_range_value,
			func2_out_lower_range_value,
			func2_out_upper_range_value,
			func2_out_unit,
			func2_pv_ftime,
			func2_alarm_hys,
			func2_hi_hi_lim,
			func2_hi_lim,
			func2_lo_lo_lim,
			func2_lo_lim,
/*		}  */
	/* FUNCTION BLOCK, STANDARD PARAMETER		*/
	/* FUNCTION BLOCK, ADDITIONAL PARAMETER		*/
/*		IF	(AUX_O_O_SERV)
		{	*/
			func3_pv_lower_range_value,
			func3_pv_upper_range_value,
			func3_out_lower_range_value,
			func3_out_upper_range_value,
			func3_out_unit,
			func3_pv_ftime,
			func3_alarm_hys,
			func3_hi_hi_lim,
			func3_hi_lim,
			func3_lo_lo_lim,
			func3_lo_lim
/*		}	 */				
	}
}

/*---------------------------------------------------------------------*/
/*    Physical Block				*/
/*---------------------------------------------------------------------*/

COMMAND read_phys_blk
{
	BLOCK physical_block;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_blk_reserve, phys_blk_object, phys_blk_parent_class, phys_blk_class,
			phys_blk_dd_reference, phys_blk_dd_rev, phys_blk_profile, phys_blk_profile_rev,
			phys_blk_execution_time, phys_blk_num_parameters, phys_blk_index_view_1,
			phys_blk_num_view_lists
		}
	}
}

COMMAND read_phys_st_rev
{
	BLOCK physical_block;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_st_rev
		}
	}
}

COMMAND read_phys_tag_desc
{
	BLOCK physical_block;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_tag_desc
		}
	}
}

COMMAND write_phys_tag_desc
{
	BLOCK physical_block;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_strategy
{
	BLOCK physical_block;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_strategy
		}
	}
}

COMMAND write_phys_strategy
{
	BLOCK physical_block;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_alert_key
{
	BLOCK physical_block;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_alert_key
		}
	}
}

COMMAND write_phys_alert_key
{
	BLOCK physical_block;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_target_mode
{
	BLOCK physical_block;
	INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_target_mode
		}
	}
}

COMMAND write_phys_target_mode
{
	BLOCK physical_block;
	INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
		 	phys_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_mode
{
	BLOCK physical_block;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 phys_actual_mode, phys_permitted_mode, phys_normal_mode
		}
	}
}

COMMAND read_phys_alarm
{
	BLOCK physical_block;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_current_state_alarm_sum, phys_unacknowledged_state_alarm_sum,
			phys_unreported_state_alarm_sum, phys_disabled_state_alarm_sum
		}
	}
}

COMMAND read_phys_software_rev
{
	BLOCK physical_block;
	INDEX 8;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_software_rev
		}
	}
}

COMMAND read_phys_hardware_rev
{
	BLOCK physical_block;
	INDEX 9;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_hardware_rev
		}
	}
}

COMMAND read_phys_device_man_id
{
	BLOCK physical_block;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_man_id
		}
	}
}

COMMAND read_phys_device_id
{
	BLOCK physical_block;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_id
		}
	}
}

COMMAND read_phys_device_ser_num
{
	BLOCK physical_block;
	INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_ser_num
		}
	}
}

COMMAND read_phys_diagnosis
{
	BLOCK physical_block;
	INDEX 13;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_diagnosis
		}
	}
}

COMMAND read_phys_diagnosis_mask
{
	BLOCK physical_block;
	INDEX 15;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_diagnosis_mask
		}
	}
}


COMMAND read_phys_write_locking
{
	BLOCK physical_block;
	INDEX 18;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_write_locking
		}
	}
}

COMMAND write_phys_write_locking
{
	BLOCK physical_block;
	INDEX 18;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_write_locking
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_factory_reset
{
	BLOCK physical_block;
	INDEX 19;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_factory_reset
		}
	}
}

COMMAND write_phys_factory_reset
{
	BLOCK physical_block;
	INDEX 19;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_factory_reset
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_descriptor
{
	BLOCK physical_block;
	INDEX 20;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_descriptor
		}
	}
}

COMMAND write_phys_descriptor
{
	BLOCK physical_block;
	INDEX 20;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_descriptor
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_message
{
	BLOCK physical_block;
	INDEX 21;
	OPERATION  READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_message
		}
	}
}

COMMAND write_phys_message
{
	BLOCK physical_block;
	INDEX 21;
	OPERATION  WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_message
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_install_date
{
	BLOCK physical_block;
	INDEX 22;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_install_date
		}
	}
}

COMMAND write_phys_install_date
{
	BLOCK physical_block;
	INDEX 22;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_install_date
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_ident_number
{
	BLOCK physical_block;
	INDEX 24;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_ident_number
		}
	}
}

COMMAND write_phys_ident_number
{
	BLOCK physical_block;
	INDEX 24;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_ident_number
		}
		REPLY
		{
		}
	}
}

 
/*---------------------------------------------------------------------*/
/*    Transducer Block  1 												   */
/*---------------------------------------------------------------------*/

COMMAND read_trans1_blk
{
	BLOCK transducer_block_1;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_blk_reserve, trans1_blk_object, trans1_blk_parent_class, trans1_blk_class,
			trans1_blk_dd_reference, trans1_blk_dd_rev, trans1_blk_profile, trans1_blk_profile_rev,
			trans1_blk_execution_time, trans1_blk_num_parameters, trans1_blk_index_view_1,
			trans1_blk_num_view_lists
		}
	}
}

COMMAND read_trans1_st_rev
{
	BLOCK transducer_block_1;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_st_rev
		}
	}
}

COMMAND read_trans1_tag_desc
{
	BLOCK transducer_block_1;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tag_desc
		}
	}
}

COMMAND write_trans1_tag_desc
{
	BLOCK transducer_block_1;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_strategy
{
	BLOCK transducer_block_1;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_strategy
		}
	}
}

COMMAND write_trans1_strategy
{
	BLOCK transducer_block_1;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_alert_key
{
	BLOCK transducer_block_1;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_alert_key
		}
	}
}

COMMAND write_trans1_alert_key
{
	BLOCK transducer_block_1;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_target_mode
{
	BLOCK transducer_block_1;
	INDEX 5;
	OPERATION  READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_target_mode
		}
	}
}

COMMAND write_trans1_target_mode
{
	BLOCK transducer_block_1;
	INDEX 5;
	OPERATION  WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_mode
{
	BLOCK transducer_block_1;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 trans1_actual_mode, trans1_permitted_mode, trans1_normal_mode
		}
	}
}

COMMAND read_trans1_alarm
{
	BLOCK transducer_block_1;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_current_state_alarm_sum, trans1_unacknowledged_state_alarm_sum,
			trans1_unreported_state_alarm_sum, trans1_disabled_state_alarm_sum
		}
	}
}

COMMAND read_trans1_act_stroke_time_dec
{
	BLOCK transducer_block_1;
	INDEX 9;
	OPERATION READ;
	TRANSACTION						
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_act_stroke_time_dec
		}
	}
}

COMMAND read_trans1_act_stroke_time_inc
{
	BLOCK transducer_block_1;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_act_stroke_time_inc
		}
	}
}

COMMAND read_trans1_tab_entry
{
	BLOCK transducer_block_1;
	INDEX 90;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tab_entry
		}
	}
}

COMMAND write_trans1_tab_entry
{
	BLOCK transducer_block_1;
	INDEX 90;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tab_entry
		}
		REPLY
		{
		}
	}
}
COMMAND read_trans1_tab_value_0
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_0, 
			trans1_tab_y_value_0
		}
	}
}
COMMAND write_trans1_tab_x_y
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_gen, 
			trans1_tab_y_gen
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_x_y
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_gen, 
			trans1_tab_y_gen
		}
	}
}

COMMAND write_trans1_tab_value_0
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_0, 
			trans1_tab_y_value_0
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_1
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_1, 
			trans1_tab_y_value_1
		}
	}
}

COMMAND write_trans1_tab_value_1
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_1, 
			trans1_tab_y_value_1
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_2
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_2, 
			trans1_tab_y_value_2
		}
	}
}

COMMAND write_trans1_tab_value_2
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_2, 
			trans1_tab_y_value_2
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_3
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_3, 
			trans1_tab_y_value_3
		}
	}
}

COMMAND write_trans1_tab_value_3
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_3, 
			trans1_tab_y_value_3
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_4
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_4, 
			trans1_tab_y_value_4
		}
	}
}

COMMAND write_trans1_tab_value_4
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_4, 
			trans1_tab_y_value_4
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_5
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_5, 
			trans1_tab_y_value_5
		}
	}
}

COMMAND write_trans1_tab_value_5
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_5, 
			trans1_tab_y_value_5
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_6
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_6, 
			trans1_tab_y_value_6
		}
	}
}

COMMAND write_trans1_tab_value_6
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_6, 
			trans1_tab_y_value_6
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_7
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_7, 
			trans1_tab_y_value_7
		}
	}
}

COMMAND write_trans1_tab_value_7
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_7, 
			trans1_tab_y_value_7
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_8
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_8, 
			trans1_tab_y_value_8
		}
	}
}

COMMAND write_trans1_tab_value_8
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_8, 
			trans1_tab_y_value_8
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_9
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_9, 
			trans1_tab_y_value_9
		}
	}
}

COMMAND write_trans1_tab_value_9
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_9, 
			trans1_tab_y_value_9
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_10
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_10, 
			trans1_tab_y_value_10
		}
	}
}

COMMAND write_trans1_tab_value_10
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_10, 
			trans1_tab_y_value_10
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_11
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_11, 
			trans1_tab_y_value_11
		}
	}
}

COMMAND write_trans1_tab_value_11
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_11, 
			trans1_tab_y_value_11
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_12
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_12, 
			trans1_tab_y_value_12
		}
	}
}

COMMAND write_trans1_tab_value_12
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_12, 
			trans1_tab_y_value_12
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_13
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_13, 
			trans1_tab_y_value_13
		}
	}
}

COMMAND write_trans1_tab_value_13
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_13, 
			trans1_tab_y_value_13
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_14
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_14, 
			trans1_tab_y_value_14
		}
	}
}

COMMAND write_trans1_tab_value_14
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_14, 
			trans1_tab_y_value_14
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_15
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_15, 
			trans1_tab_y_value_15
		}
	}
}

COMMAND write_trans1_tab_value_15
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_15, 
			trans1_tab_y_value_15
		}
		REPLY
		{
		}
	}
}
COMMAND read_trans1_tab_value_16
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_16, 
			trans1_tab_y_value_16
		}
	}
}

COMMAND write_trans1_tab_value_16
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_16, 
			trans1_tab_y_value_16
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_17
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_17, 
			trans1_tab_y_value_17
		}
	}
}

COMMAND write_trans1_tab_value_17
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_17, 
			trans1_tab_y_value_17
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_18
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_18, 
			trans1_tab_y_value_18
		}
	}
}

COMMAND write_trans1_tab_value_18
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_18, 
			trans1_tab_y_value_18
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_19
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_19, 
			trans1_tab_y_value_19
		}
	}
}

COMMAND write_trans1_tab_value_19
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_19, 
			trans1_tab_y_value_19
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_20
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_20, 
			trans1_tab_y_value_20
		}
	}
}

COMMAND write_trans1_tab_value_20
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_20, 
			trans1_tab_y_value_20
		}
		REPLY
		{
		}
	}
}
COMMAND read_trans1_tab_value_21
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_21, 
			trans1_tab_y_value_21
		}
	}
}

COMMAND write_trans1_tab_value_21
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_21, 
			trans1_tab_y_value_21
		}
		REPLY
		{
		}
	}
}
COMMAND read_trans1_tab_value_22
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_22, 
			trans1_tab_y_value_22
		}
	}
}

COMMAND write_trans1_tab_value_22
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_22, 
			trans1_tab_y_value_22
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_23
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_23, 
			trans1_tab_y_value_23
		}
	}
}

COMMAND write_trans1_tab_value_23
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_23, 
			trans1_tab_y_value_23
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_24
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_24, 
			trans1_tab_y_value_24
		}
	}
}

COMMAND write_trans1_tab_value_24
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_24, 
			trans1_tab_y_value_24
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_25
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_25, 
			trans1_tab_y_value_25
		}
	}
}

COMMAND write_trans1_tab_value_25
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_25, 
			trans1_tab_y_value_25
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_26
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_26, 
			trans1_tab_y_value_26
		}
	}
}

COMMAND write_trans1_tab_value_26
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_26, 
			trans1_tab_y_value_26
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_27
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_27, 
			trans1_tab_y_value_27
		}
	}
}

COMMAND write_trans1_tab_value_27
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_27, 
			trans1_tab_y_value_27
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_28
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_28, 
			trans1_tab_y_value_28
		}
	}
}

COMMAND write_trans1_tab_value_28
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_28, 
			trans1_tab_y_value_28
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_29
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_29, 
			trans1_tab_y_value_29
		}
	}
}

COMMAND write_trans1_tab_value_29
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_29, 
			trans1_tab_y_value_29
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_value_30
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_30, 
			trans1_tab_y_value_30
		}
	}
}

COMMAND write_trans1_tab_value_30
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_30, 
			trans1_tab_y_value_30
		}
		REPLY
		{
		}
	}
}
COMMAND read_trans1_tab_value_31
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_31, 
			trans1_tab_y_value_31
		}
	}
}

COMMAND write_trans1_tab_value_31
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_31, 
			trans1_tab_y_value_31
		}
		REPLY
		{
		}
	}
}
COMMAND read_trans1_tab_value_32
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans1_tab_x_value_32, 
			trans1_tab_y_value_32
		}
	}
}

COMMAND write_trans1_tab_value_32
{
	BLOCK transducer_block_1;
	INDEX 91;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans1_tab_x_value_32, 
			trans1_tab_y_value_32
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_min_number
{
	BLOCK transducer_block_1;
	INDEX 92;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tab_min_number
		}
	}
}

COMMAND read_trans1_tab_max_number
{
	BLOCK transducer_block_1;
	INDEX 100;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tab_max_number
		}
	}
}

COMMAND read_trans1_tab_actual_number
{
	BLOCK transducer_block_1;
	INDEX 101;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tab_actual_number
		}
	}
}
COMMAND write_trans1_tab_actual_number
{
	BLOCK transducer_block_1;
	INDEX 101;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tab_actual_number
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_deadband
{
	BLOCK transducer_block_1;
	INDEX 22;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_deadband
		}
	}
}

COMMAND write_trans1_deadband
{
	BLOCK transducer_block_1;
	INDEX 22;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_deadband
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_device_calib_date
{
	BLOCK transducer_block_1;
	INDEX 23;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_device_calib_date
		}
	}
}

COMMAND write_trans1_device_calib_date
{
	BLOCK transducer_block_1;
	INDEX 23;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_device_calib_date
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_device_config_date
{
	BLOCK transducer_block_1;
	INDEX 24;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_device_config_date
		}
	}
}

COMMAND write_trans1_device_config_date
{
	BLOCK transducer_block_1;
	INDEX 24;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_device_config_date
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_lin_type
{
	BLOCK transducer_block_1;
	INDEX 89;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_lin_type
		}
	}
}

COMMAND write_trans1_lin_type
{
	BLOCK transducer_block_1;
	INDEX 89;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_lin_type
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_rated_travel
{
	BLOCK transducer_block_1;
	INDEX 32;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_rated_travel_value
		}
	}
}

COMMAND write_trans1_rated_travel
{
	BLOCK transducer_block_1;
	INDEX 32;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_rated_travel_value 
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_self_calibration_cmd
{
	BLOCK transducer_block_1;
	INDEX 33;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_self_calibration_cmd	
		}
	}
}

COMMAND write_trans1_self_calibration_cmd
{
	BLOCK transducer_block_1;
	INDEX 33;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_self_calibration_cmd	
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_self_calibration_status
{
	BLOCK transducer_block_1;
	INDEX 34;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_self_calibration_status	
		}
	}
}
COMMAND read_trans1_servo_gain_1
{
	BLOCK transducer_block_1;
	INDEX 35;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_servo_gain_1
		}
	}
}

COMMAND write_trans1_servo_gain_1
{
	BLOCK transducer_block_1;
	INDEX 35;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_servo_gain_1	
		}
		REPLY
		{
		}
	}
}
COMMAND read_trans1_servo_rate_1
{
	BLOCK transducer_block_1;
	INDEX 36;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_servo_rate_1
		}
	}
}

COMMAND write_trans1_servo_rate_1
{
	BLOCK transducer_block_1;
	INDEX 36;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_servo_rate_1	
		}
		REPLY
		{
		}
	}
}
COMMAND read_trans1_servo_reset_1
{
	BLOCK transducer_block_1;
	INDEX 37;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_servo_reset_1
		}
	}
}

COMMAND write_trans1_servo_reset_1
{
	BLOCK transducer_block_1;
	INDEX 37;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_servo_reset_1	
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_setp_cutoff_dec
{
	BLOCK transducer_block_1;
	INDEX 38;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_setp_cutoff_dec
		}
	}
}

COMMAND write_trans1_setp_cutoff_dec
{
	BLOCK transducer_block_1;
	INDEX 38;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_setp_cutoff_dec	
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_setp_cutoff_inc
{
	BLOCK transducer_block_1;
	INDEX 39;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_setp_cutoff_inc
		}
	}
}

COMMAND write_trans1_setp_cutoff_inc
{
	BLOCK transducer_block_1;
	INDEX 39;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_setp_cutoff_inc	
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_total_valve_travel
{
	BLOCK transducer_block_1;
	INDEX 45;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_total_valve_travel
		}
	}
}

COMMAND write_trans1_total_valve_travel
{
	BLOCK transducer_block_1;
	INDEX 45;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_total_valve_travel
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_total_valve_travel_limit
{
	BLOCK transducer_block_1;
	INDEX 46;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_total_valve_travel_limit
		}
	}
}

COMMAND write_trans1_total_valve_travel_limit
{
	BLOCK transducer_block_1;
	INDEX 46;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_total_valve_travel_limit
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_travel_limit_low
{
	BLOCK transducer_block_1;
	INDEX 47;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_travel_limit_lower_value
		}
	}
}

COMMAND write_trans1_travel_limit_low
{
	BLOCK transducer_block_1;
	INDEX 47;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_travel_limit_lower_value
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_travel_limit_upper
{
	BLOCK transducer_block_1;
	INDEX 48;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_travel_limit_upper_value
		}
	}
}

COMMAND write_trans1_travel_limit_upper
{
	BLOCK transducer_block_1;
	INDEX 48;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_travel_limit_upper_value
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_travel_rate_dec
{
	BLOCK transducer_block_1;
	INDEX 49;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_travel_rate_dec
		}
	}
}

COMMAND write_trans1_travel_rate_dec
{
	BLOCK transducer_block_1;
	INDEX 49;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_travel_rate_dec
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_travel_rate_inc
{
	BLOCK transducer_block_1;
	INDEX 50;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_travel_rate_inc
		}
	}
}

COMMAND write_trans1_travel_rate_inc
{
	BLOCK transducer_block_1;
	INDEX 50;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_travel_rate_inc
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_valve_maintenance_date
{
	BLOCK transducer_block_1;
	INDEX 51;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_valve_maintenance_date
		}
	}
}

COMMAND write_trans1_valve_maintenance_date
{
	BLOCK transducer_block_1;
	INDEX 51;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_valve_maintenance_date
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_positioning_value
{
	BLOCK transducer_block_1;
	INDEX 57;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_positioning_value,
			trans1_positioning_status_quality	<0xFC>,
			trans1_positioning_status_limit		<0x03>
		}
	}
}

COMMAND read_trans1_feedback_value
{
	BLOCK transducer_block_1;
	INDEX 58;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_feedback_value,
			trans1_feedback_status_quality	<0xFC>,
			trans1_feedback_status_limit	<0x03>
		}
	}
}

COMMAND read_trans1_valve_man
{
	BLOCK transducer_block_1;
	INDEX 59;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_valve_man
		}
	}
}

COMMAND write_trans1_valve_man
{
	BLOCK transducer_block_1;
	INDEX 59;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_valve_man
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_actuator_man
{
	BLOCK transducer_block_1;
	INDEX 60;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_actuator_man
		}
	}
}

COMMAND write_trans1_actuator_man
{
	BLOCK transducer_block_1;
	INDEX 60;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_actuator_man
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_valve_type
{
	BLOCK transducer_block_1;
	INDEX 61;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_valve_type
		}
	}
}

COMMAND write_trans1_valve_type
{
	BLOCK transducer_block_1;
	INDEX 61;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_valve_type
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_actuator_type
{
	BLOCK transducer_block_1;
	INDEX 62;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_actuator_type
		}
	}
}

COMMAND write_trans1_actuator_type
{
	BLOCK transducer_block_1;
	INDEX 62;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_actuator_type
		}
		REPLY
		{
//			trans1_actuator_type
		}
	}
}

COMMAND read_trans1_actuator_action
{
	BLOCK transducer_block_1;
	INDEX 63;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_actuator_action
		}
	}
}

COMMAND write_trans1_actuator_action
{
	BLOCK transducer_block_1;
	INDEX 63;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_actuator_action
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_valve_ser_num
{
	BLOCK transducer_block_1;
	INDEX 64;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_valve_ser_num
		}
	}
}

COMMAND write_trans1_valve_ser_num
{
	BLOCK transducer_block_1;
	INDEX 64;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_valve_ser_num
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_actuator_ser_num
{
	BLOCK transducer_block_1;
	INDEX 65;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_actuator_ser_num
		}
	}
}

COMMAND write_trans1_actuator_ser_num
{
	BLOCK transducer_block_1;
	INDEX 65;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_actuator_ser_num
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_additional_gear_ser_number
{
	BLOCK transducer_block_1;
	INDEX 66;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_additional_gear_ser_number
		}
	}
}


COMMAND write_trans1_additional_gear_ser_number
{
	BLOCK transducer_block_1;
	INDEX 66;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_additional_gear_ser_number
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_additional_gear_man
{
	BLOCK transducer_block_1;
	INDEX 67;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_additional_gear_man
		}
	}
}


COMMAND write_trans1_additional_gear_man
{
	BLOCK transducer_block_1;
	INDEX 67;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_additional_gear_man
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_additional_gear_id
{
	BLOCK transducer_block_1;
	INDEX 68;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_additional_gear_id
		}
	}
}


COMMAND write_trans1_additional_gear_id
{
	BLOCK transducer_block_1;
	INDEX 68;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_additional_gear_id
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_additional_gear_install_date
{
	BLOCK transducer_block_1;
	INDEX 69;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_additional_gear_install_date
		}
	}
}


COMMAND write_trans1_additional_gear_install_date
{
	BLOCK transducer_block_1;
	INDEX 69;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_additional_gear_install_date
		}
		REPLY
		{
		}
	}
}
/*
COMMAND read_trans1_view1
{
	BLOCK transducer_block_1;
	INDEX 155;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_view1
		}
	}
}
*/
 /*-------------------------------------------------------------------*/
 /*   Transducer Block 2 - temperature						*/
 /*-------------------------------------------------------------------*/

COMMAND read_trans2_blk
{
	BLOCK transducer_block_2;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_blk_reserve, trans2_blk_object, trans2_blk_parent_class, trans2_blk_class,
			trans2_blk_dd_reference, trans2_blk_dd_rev, trans2_blk_profile, trans2_blk_profile_rev,
			trans2_blk_execution_time, trans2_blk_num_parameters, trans2_blk_index_view_1,
			trans2_blk_num_view_lists
		}
	}
}

COMMAND read_trans2_st_rev
{
	BLOCK transducer_block_2;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_st_rev
		}
	}
}

COMMAND read_trans2_tag_desc
{
	BLOCK transducer_block_2;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_tag_desc
		}
	}
}

COMMAND write_trans2_tag_desc
{
	BLOCK transducer_block_2;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_strategy
{
	BLOCK transducer_block_2;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_strategy
		}
	}
}

COMMAND write_trans2_strategy
{
	BLOCK transducer_block_2;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_alert_key
{
	BLOCK transducer_block_2;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_alert_key
		}
	}
}

COMMAND write_trans2_alert_key
{
	BLOCK transducer_block_2;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_target_mode
{
	BLOCK transducer_block_2;
	INDEX 5;
	OPERATION  READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_target_mode
		}
	}
}

COMMAND write_trans2_target_mode
{
	BLOCK transducer_block_2;
	INDEX 5;
	OPERATION  WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_mode
{
	BLOCK transducer_block_2;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 trans2_actual_mode, trans2_permitted_mode, trans2_normal_mode
		}
	}
}

COMMAND read_trans2_alarm
{
	BLOCK transducer_block_2;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_current_state_alarm_sum, trans2_unacknowledged_state_alarm_sum,
			trans2_unreported_state_alarm_sum, trans2_disabled_state_alarm_sum
		}
	}
}

COMMAND read_trans2_meas_value
{
	BLOCK transducer_block_2;
	INDEX 8;
	OPERATION READ;
	TRANSACTION						
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_meas_value, 
			trans2_meas_value_status_quality	<0xFC>,
			trans2_meas_value_status_limit		<0x03>

		}
	}
}

COMMAND read_trans2_temperture_unit
{
	BLOCK transducer_block_2;
	INDEX 9;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_temperature_unit
		}
	}
}
/*
 COMMAND read_trans2_bias
{
	BLOCK transducer_block_2;
	INDEX 19;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans2_bias
		}
	}
}  
//fbi read war auskommentiert
COMMAND write_trans2_bias
{
	BLOCK transducer_block_2;
	INDEX 19;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans2_bias 
		}
		REPLY
		{
		}
	}
}
*/
COMMAND read_trans2_calib_unit
{
	BLOCK transducer_block_2;
	INDEX 62;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans2_calib_unit 
		}
	}
}


 /*-------------------------------------------------------------------*/
 /*   Transducer Block 3 - auxilary input						*/
 /*-------------------------------------------------------------------*/

COMMAND read_trans3_blk
{
	BLOCK transducer_block_3;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans3_blk_reserve, trans3_blk_object, trans3_blk_parent_class, trans3_blk_class,
			trans3_blk_dd_reference, trans3_blk_dd_rev, trans3_blk_profile, trans3_blk_profile_rev,
			trans3_blk_execution_time, trans3_blk_num_parameters, trans3_blk_index_view_1,
			trans3_blk_num_view_lists
		}
	}
}

COMMAND read_trans3_st_rev
{
	BLOCK transducer_block_3;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans3_st_rev
		}
	}
}

COMMAND read_trans3_tag_desc
{
	BLOCK transducer_block_3;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans3_tag_desc
		}
	}
}

COMMAND write_trans3_tag_desc
{
	BLOCK transducer_block_3;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans3_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans3_strategy
{
	BLOCK transducer_block_3;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans3_strategy
		}
	}
}

COMMAND write_trans3_strategy
{
	BLOCK transducer_block_3;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans3_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans3_alert_key
{
	BLOCK transducer_block_3;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans3_alert_key
		}
	}
}

COMMAND write_trans3_alert_key
{
	BLOCK transducer_block_3;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans3_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans3_target_mode
{
	BLOCK transducer_block_3;
	INDEX 5;
	OPERATION  READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans3_target_mode
		}
	}
}

COMMAND write_trans3_target_mode
{
	BLOCK transducer_block_3;
	INDEX 5;
	OPERATION  WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans3_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans3_mode
{
	BLOCK transducer_block_3;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 trans3_actual_mode, trans3_permitted_mode, trans3_normal_mode
		}
	}
}

COMMAND read_trans3_alarm
{
	BLOCK transducer_block_3;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans3_current_state_alarm_sum, trans3_unacknowledged_state_alarm_sum,
			trans3_unreported_state_alarm_sum, trans3_disabled_state_alarm_sum
		}
	}
}

COMMAND read_trans3_primary_value
{
	BLOCK transducer_block_3;
	INDEX 19;
	OPERATION READ;
	TRANSACTION						
	{
		REQUEST
		{
		}
		REPLY
		{
			trans3_primary_value, 
			trans3_primary_value_status_quality	<0xFC>,
			trans3_primary_value_status_limit		<0x03>

		}
	}
}


COMMAND read_trans3_primary_value_unit
{
	BLOCK transducer_block_3;
	INDEX 22;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans3_primary_value_unit
		}
	}
}
COMMAND write_trans3_primary_value_unit
{
	BLOCK transducer_block_3;
	INDEX 22;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans3_primary_value_unit 

		}
		REPLY
		{
		}
	}
}
/* COMMAND read_cal_hi_point   // jonas 2007.10.19
{
	BLOCK transducer_block_3;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans3_cal_point_hi
		}
	}
} */

COMMAND write_trans3_cal_point_hi
{
	BLOCK transducer_block_3;
	INDEX 11;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans3_cal_point_hi 

		}
		REPLY
		{
		}
	}
}
/* COMMAND read_cal_lo_point   // jonas 2007.10.19
{
	BLOCK transducer_block_3;
	INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans3_cal_point_lo
		}
	}
} */

COMMAND write_trans3_cal_point_lo
{
	BLOCK transducer_block_3;
	INDEX 12;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{ 
			trans3_cal_point_lo 

		}
		REPLY
		{
		}
	}
}

COMMAND read_trans3_cal_unit
{
	BLOCK transducer_block_3;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{ 
		}
		REPLY
		{
			trans3_cal_unit 
		}
	}
}



/*---------------------------------------------------------------------*/
/*    Function Block			           */
/*---------------------------------------------------------------------*/

COMMAND read_func1_blk
{
	BLOCK function_block_1;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_blk_reserve, func1_blk_object, func1_blk_parent_class, func1_blk_class,
			func1_blk_dd_reference, func1_blk_dd_rev, func1_blk_profile, func1_blk_profile_rev,
			func1_blk_execution_time, func1_blk_num_parameters, func1_blk_index_view_1,
			func1_blk_num_view_lists
		}
	}
}

COMMAND read_func1_st_rev
{
	BLOCK function_block_1;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_st_rev   
		}
	}
}

COMMAND read_func1_tag_desc
{
	BLOCK function_block_1;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_tag_desc
		}
	}
}

COMMAND write_func1_tag_desc
 {
	BLOCK function_block_1;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_strategy
{
	BLOCK function_block_1;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_strategy
		}
	}
}

COMMAND write_func1_strategy
{
	BLOCK function_block_1;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_alert_key
{
	BLOCK function_block_1;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_alert_key
		}
	}
}

COMMAND write_func1_alert_key
{
	BLOCK function_block_1;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_target_mode
{
	BLOCK function_block_1;
	INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_target_mode
		}
	}
}

COMMAND write_func1_target_mode
{
	BLOCK function_block_1;
	INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_mode
{
	BLOCK function_block_1;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 func1_actual_mode, func1_permitted_mode, func1_normal_mode
		}
	}
}

COMMAND read_func1_alarm
{
	BLOCK function_block_1;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_current_state_alarm_sum, func1_unacknowledged_state_alarm_sum,
			func1_unreported_state_alarm_sum, func1_disabled_state_alarm_sum
		}
	}
}

COMMAND read_func1_batch_information
{
	BLOCK function_block_1;
	INDEX 8;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_batch_id, func1_batch_unit, func1_batch_operation, func1_batch_phase
		}
	}
}

COMMAND write_func1_batch_information
{
	BLOCK function_block_1;
	INDEX 8;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_batch_id, func1_batch_unit, func1_batch_operation, func1_batch_phase
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_setpoint 
{
	BLOCK function_block_1;
	INDEX 9;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_setpoint_value,
			func1_setpoint_status_quality	<0xFC>,
			func1_setpoint_status_limit		<0x03>
		}
	}
}

COMMAND write_func1_setpoint 
{
	BLOCK function_block_1;
	INDEX 9;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_setpoint_value,
			func1_setpoint_status_quality	<0xFC>,
			func1_setpoint_status_limit	<0x03>
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_pv 
{
	BLOCK function_block_1;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_pv_upper_range_value,
			func1_pv_lower_range_value, 
			func1_pv_unit,
			func1_pv_decimal_point
		}
	}
}

COMMAND write_func1_pv
{
	BLOCK function_block_1;
	INDEX 11;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_pv_upper_range_value,
			func1_pv_lower_range_value, 
			func1_pv_unit,
			func1_pv_decimal_point
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_readback 
{
	BLOCK function_block_1;
	INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_readback_value,
			func1_readback_status_quality		<0xFC>,
			func1_readback_status_limit		<0x03>
		}
	}
}
COMMAND read_func1_rcas_in
{
	BLOCK function_block_1;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_rcas_in_value,
			func1_rcas_in_status_quality		<0xFC>,
			func1_rcas_in_status_limit		<0x03>
		}
	}
}

COMMAND write_func1_rcas_in
{
	BLOCK function_block_1;
	INDEX 14;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_rcas_in_value,
			func1_rcas_in_status_quality		<0xFC>,
			func1_rcas_in_status_limit		<0x03>
		}
		REPLY
		{
		}
	}
}
COMMAND read_func1_in_channel 
{
	BLOCK function_block_1;
	INDEX 21;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_in_channel
		}
	}
}

COMMAND write_func1_in_channel 
{
	BLOCK function_block_1;
	INDEX 21;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_in_channel
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_out_channel 
{
	BLOCK function_block_1;
	INDEX 22;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_out_channel
		}
	}
}

COMMAND write_func1_out_channel 
{
	BLOCK function_block_1;
	INDEX 21;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_out_channel
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_fsafe_time 
{
	BLOCK function_block_1;
	INDEX 23;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_fsafe_time
		}
	}
}

COMMAND write_func1_fsafe_time 
{
	BLOCK function_block_1;
	INDEX 23;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_fsafe_time
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_fsafe_type
{
	BLOCK function_block_1;
	INDEX 24;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_fsafe_type
		}
	}
}

COMMAND write_func1_fsafe_type
{
	BLOCK function_block_1;
	INDEX 24;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_fsafe_type
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_fsafe_value
{
	BLOCK function_block_1;
	INDEX 25;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_fsafe_value
		}
	}
}

COMMAND write_func1_fsafe_value
{
	BLOCK function_block_1;
	INDEX 25;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_fsafe_value
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_rcas_out
{
	BLOCK function_block_1;
	INDEX 27;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_rcas_out_value,
			func1_rcas_out_status_quality	<0xFC>,
			func1_rcas_out_status_limit		<0x03>
		}
	}
}
/*
COMMAND read_func1_hi_hi_alm
{
	BLOCK function_block_1;
	INDEX 30;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_hi_hi_alm_unacknowledged, func1_hi_hi_alm_state,
			func1_hi_hi_alm_time_stamp, func1_hi_hi_alm_subcode,
			func1_hi_hi_alm_value
		}
	}
}
*/
COMMAND read_func1_current_position 
{
	BLOCK function_block_1;
	INDEX 31;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_position_discrete_value,
			func1_position_discrete_status_quality	<0xFC>,
			func1_position_discrete_status_limit	<0x03>
		}
	}
}

COMMAND read_func1_setpoint_deviation 
{
	BLOCK function_block_1;
	INDEX 32;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_setpoint_deviation
		}
	}
}

COMMAND read_func1_check_back 
{
	BLOCK function_block_1;
	INDEX 33;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_check_back
		}
	}
}

COMMAND read_func1_check_back_mask 
{
	BLOCK function_block_1;
	INDEX 34;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_check_back_mask
		}
	}
}

COMMAND read_func1_simulate 
{
	BLOCK function_block_1;
	INDEX 35;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_simulate_status_quality	<0xFC>,
			func1_simulate_status_limit		<0x03>,
			func1_simulate_value, 
			func1_simulation_enabled
		}
	}
}

COMMAND write_func1_simulate 
{
	BLOCK function_block_1;
	INDEX 35;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_simulate_status_quality		<0xFC>,
			func1_simulate_status_limit		<0x03>,
			func1_simulate_value, 
			func1_simulation_enabled
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_increase_close 
{
	BLOCK function_block_1;
	INDEX 36;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_increase_close
		}
	}
}

COMMAND write_func1_increase_close 
{
	BLOCK function_block_1;
	INDEX 36;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_increase_close
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_out 
{
	BLOCK function_block_1;
	INDEX 37;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_out_value,
			func1_out_status_quality	<0xFC>,
			func1_out_status_limit		<0x03>

		}
	}
}

COMMAND write_func1_out 
{
	BLOCK function_block_1;
	INDEX 37;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_out_value,
			func1_out_status_quality	<0xFC>,
			func1_out_status_limit		<0x03>
		}
		REPLY
		{
		}
	}
}

COMMAND read_func1_out_scale 
{
	BLOCK function_block_1;
	INDEX 38;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func1_out_upper_range_value, func1_out_lower_range_value, 
			func1_out_unit, func1_out_decimal_point 
		}
	}
}

COMMAND write_func1_out_scale 
{
	BLOCK function_block_1;
	INDEX 38;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func1_out_upper_range_value, func1_out_lower_range_value, 
			func1_out_unit, func1_out_decimal_point 
		}
		REPLY
		{
		}
	}
}

/****************************************************************************************/
/*           AI FunctionBlock	2														*/
/****************************************************************************************/

VARIABLE func2_blk_highest_rel_offset
{
	LABEL		[blk_highest_rel_offset];
	HELP		[blk_highest_rel_offset_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

COMMAND read_func2_blk
{
	BLOCK function_block_2;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_blk_reserve, func2_blk_object, func2_blk_parent_class, func2_blk_class,
			func2_blk_dd_reference, func2_blk_dd_rev, func2_blk_profile, func2_blk_profile_rev,
			func2_blk_execution_time, func2_blk_highest_rel_offset, func2_blk_index_view_1,
			func2_blk_num_view_lists
		}
	}
}

COMMAND read_func2_st_rev
{
	BLOCK function_block_2;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_st_rev   
		}
	}
}

COMMAND read_func2_tag_desc
{
	BLOCK function_block_2;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_tag_desc
		}
	}
}

COMMAND write_func2_tag_desc
{
	BLOCK function_block_2;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_strategy
{
	BLOCK function_block_2;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_strategy
		}
	}
}

COMMAND write_func2_strategy
{
	BLOCK function_block_2;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_alert_key
{
	BLOCK function_block_2;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_alert_key
		}
	}
}

COMMAND write_func2_alert_key
{
	BLOCK function_block_2;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_target_mode
{
	BLOCK function_block_2;
	INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_target_mode
		}
	}
}

COMMAND write_func2_target_mode
{
	BLOCK function_block_2;
	INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_mode
{
	BLOCK function_block_2;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 func2_actual_mode, func2_permitted_mode, func2_normal_mode
		}
	}
}

COMMAND read_func2_alarm
{
	BLOCK function_block_2;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_current_state_alarm_sum, func2_unacknowledged_state_alarm_sum,
			func2_unreported_state_alarm_sum, func2_disabled_state_alarm_sum
		}
	}
}

COMMAND read_func2_out
{
	BLOCK function_block_2;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_out_value,
			func2_out_status_quality		<0xFC>,
			func2_out_status_limit		<0x03>
		}
	}
}

COMMAND write_func2_out
{
	BLOCK function_block_2;
	INDEX 10;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_out_value,
			func2_out_status_quality		<0xFC>,
			func2_out_status_limit		<0x03>
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_pv
{
	BLOCK function_block_2;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_pv_upper_range_value, 
			func2_pv_lower_range_value 
 		}
	}
}

COMMAND write_func2_pv
{
	BLOCK function_block_2;
	INDEX 11;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_pv_upper_range_value, 
			func2_pv_lower_range_value
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_out_scale
{
	BLOCK function_block_2;
	INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_out_upper_range_value, func2_out_lower_range_value, 
			func2_out_unit, func2_out_decimal_point
		}
	}
}

COMMAND write_func2_out_scale
{
	BLOCK function_block_2;
	INDEX 12;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_out_upper_range_value, func2_out_lower_range_value, 
			func2_out_unit, func2_out_decimal_point
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_channel
{
	BLOCK function_block_2;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_channel
		}
	}
}

COMMAND write_func2_channel
{
	BLOCK function_block_2;
	INDEX 14;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_channel
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_pv_ftime
{
	BLOCK function_block_2;
	INDEX 16;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_pv_ftime
		}
	}
}

COMMAND write_func2_pv_ftime
{
	BLOCK function_block_2;
	INDEX 16;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_pv_ftime
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_alarm_hys
{
	BLOCK function_block_2;
	INDEX 19;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_alarm_hys
		}
	}
}

COMMAND write_func2_alarm_hys
{
	BLOCK function_block_2;
	INDEX 19;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_alarm_hys
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_hi_hi_lim
{
	BLOCK function_block_2;
	INDEX 21;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_hi_hi_lim
		}
	}
}

COMMAND write_func2_hi_hi_lim
{
	BLOCK function_block_2;
	INDEX 21;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_hi_hi_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_hi_lim
{
	BLOCK function_block_2;
	INDEX 23;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_hi_lim
		}
	}
}

COMMAND write_func2_hi_lim
{
	BLOCK function_block_2;
	INDEX 23;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_hi_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_lo_lim
{
	BLOCK function_block_2;
	INDEX 25;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_lo_lim
		}
	}
}

COMMAND write_func2_lo_lim
{
	BLOCK function_block_2;
	INDEX 25;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_lo_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_lo_lo_lim
{
	BLOCK function_block_2;
	INDEX 27;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_lo_lo_lim
		}
	}
}

COMMAND write_func2_lo_lo_lim
{
	BLOCK function_block_2;
	INDEX 27;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_lo_lo_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func2_hi_hi_alm
{
	BLOCK function_block_2;
	INDEX 30;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_hi_hi_alm_unacknowledged, func2_hi_hi_alm_state,
			func2_hi_hi_alm_time_stamp, func2_hi_hi_alm_subcode,
			func2_hi_hi_alm_value
		}
	}
}

COMMAND read_func2_hi_alm
{
	BLOCK function_block_2;
	INDEX 31;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_hi_alm_unacknowledged, func2_hi_alm_state,
			func2_hi_alm_time_stamp, func2_hi_alm_subcode,
			func2_hi_alm_value
		}
	}
}

COMMAND read_func2_lo_alm
{
	BLOCK function_block_2;
	INDEX 32;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_lo_alm_unacknowledged, func2_lo_alm_state,
			func2_lo_alm_time_stamp, func2_lo_alm_subcode,
			func2_lo_alm_value
		}
	}
}

COMMAND read_func2_lo_lo_alm
{
	BLOCK function_block_2;
	INDEX 33;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_lo_lo_alm_unacknowledged, func2_lo_lo_alm_state,
			func2_lo_lo_alm_time_stamp, func2_lo_lo_alm_subcode,
			func2_lo_lo_alm_value
		}
	}
}

COMMAND read_func2_simulate
{
	BLOCK function_block_2;
	INDEX 34;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func2_simulate_status_quality	<0xFC>,
			func2_simulate_status_limit		<0x03>,
			func2_simulate_value, 
			func2_simulation_enabled
			
		}
	}
}

COMMAND write_func2_simulate
{
	BLOCK function_block_2;
	INDEX 34;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func2_simulate_status_quality	<0xFC>,
			func2_simulate_status_limit		<0x03>,
			func2_simulate_value, 
			func2_simulation_enabled
			
		}
		REPLY
		{
		}
	}
}


/****************************************************************************************/
/*           AI FunctionBlock		3													*/
/****************************************************************************************/

VARIABLE func3_blk_highest_rel_offset
{
	LABEL		[blk_highest_rel_offset];
	HELP		[blk_highest_rel_offset_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

COMMAND read_func3_blk
{
	BLOCK function_block_3;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_blk_reserve, func3_blk_object, func3_blk_parent_class, func3_blk_class,
			func3_blk_dd_reference, func3_blk_dd_rev, func3_blk_profile, func3_blk_profile_rev,
			func3_blk_execution_time, func3_blk_highest_rel_offset, func3_blk_index_view_1,
			func3_blk_num_view_lists
		}
	}
}

COMMAND read_func3_st_rev
{
	BLOCK function_block_3;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_st_rev   
		}
	}
}

COMMAND read_func3_tag_desc
{
	BLOCK function_block_3;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_tag_desc
		}
	}
}

COMMAND write_func3_tag_desc
{
	BLOCK function_block_3;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_strategy
{
	BLOCK function_block_3;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_strategy
		}
	}
}

COMMAND write_func3_strategy
{
	BLOCK function_block_3;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_alert_key
{
	BLOCK function_block_3;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_alert_key
		}
	}
}

COMMAND write_func3_alert_key
{
	BLOCK function_block_3;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_target_mode
{
	BLOCK function_block_3;
	INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_target_mode
		}
	}
}

COMMAND write_func3_target_mode
{
	BLOCK function_block_3;
	INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_mode
{
	BLOCK function_block_3;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 func3_actual_mode, func3_permitted_mode, func3_normal_mode
		}
	}
}

COMMAND read_func3_alarm
{
	BLOCK function_block_3;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_current_state_alarm_sum, func3_unacknowledged_state_alarm_sum,
			func3_unreported_state_alarm_sum, func3_disabled_state_alarm_sum
		}
	}
}

COMMAND read_func3_out
{
	BLOCK function_block_3;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_out_value,
			func3_out_status_quality 	<0xFC>,
			func3_out_status_limit		<0x03>
		}
	}
}

COMMAND write_func3_out
{
	BLOCK function_block_3;
	INDEX 10;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_out_value,
			func3_out_status_quality 	<0xFC>,
			func3_out_status_limit		<0x03>
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_pv
{
	BLOCK function_block_3;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_pv_upper_range_value, 
			func3_pv_lower_range_value 
 		}
	}
}

COMMAND write_func3_pv
{
	BLOCK function_block_3;
	INDEX 11;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_pv_upper_range_value, 
			func3_pv_lower_range_value
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_out_scale
{
	BLOCK function_block_3;
	INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_out_upper_range_value, func3_out_lower_range_value, 
			func3_out_unit, func3_out_decimal_point
		}
	}
}

COMMAND write_func3_out_scale
{
	BLOCK function_block_3;
	INDEX 12;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_out_upper_range_value, func3_out_lower_range_value, 
			func3_out_unit, func3_out_decimal_point
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_channel
{
	BLOCK function_block_3;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_channel
		}
	}
}

COMMAND write_func3_channel
{
	BLOCK function_block_3;
	INDEX 14;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_channel
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_pv_ftime
{
	BLOCK function_block_3;
	INDEX 16;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_pv_ftime
		}
	}
}

COMMAND write_func3_pv_ftime
{
	BLOCK function_block_3;
	INDEX 16;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_pv_ftime
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_alarm_hys
{
	BLOCK function_block_3;
	INDEX 19;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_alarm_hys
		}
	}
}

COMMAND write_func3_alarm_hys
{
	BLOCK function_block_3;
	INDEX 19;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_alarm_hys
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_hi_hi_lim
{
	BLOCK function_block_3;
	INDEX 21;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_hi_hi_lim
		}
	}
}

COMMAND write_func3_hi_hi_lim
{
	BLOCK function_block_3;
	INDEX 21;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_hi_hi_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_hi_lim
{
	BLOCK function_block_3;
	INDEX 23;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_hi_lim
		}
	}
}

COMMAND write_func3_hi_lim
{
	BLOCK function_block_3;
	INDEX 23;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_hi_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_lo_lim
{
	BLOCK function_block_3;
	INDEX 25;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_lo_lim
		}
	}
}

COMMAND write_func3_lo_lim
{
	BLOCK function_block_3;
	INDEX 25;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_lo_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_lo_lo_lim
{
	BLOCK function_block_3;
	INDEX 27;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_lo_lo_lim
		}
	}
}

COMMAND write_func3_lo_lo_lim
{
	BLOCK function_block_3;
	INDEX 27;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_lo_lo_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_func3_hi_hi_alm
{
	BLOCK function_block_3;
	INDEX 30;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_hi_hi_alm_unacknowledged, func3_hi_hi_alm_state,
			func3_hi_hi_alm_time_stamp, func3_hi_hi_alm_subcode,
			func3_hi_hi_alm_value
		}
	}
}

COMMAND read_func3_hi_alm
{
	BLOCK function_block_3;
	INDEX 31;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_hi_alm_unacknowledged, func3_hi_alm_state,
			func3_hi_alm_time_stamp, func3_hi_alm_subcode,
			func3_hi_alm_value
		}
	}
}

COMMAND read_func3_lo_alm
{
	BLOCK function_block_3;
	INDEX 32;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_lo_alm_unacknowledged, func3_lo_alm_state,
			func3_lo_alm_time_stamp, func3_lo_alm_subcode,
			func3_lo_alm_value
		}
	}
}

COMMAND read_func3_lo_lo_alm
{
	BLOCK function_block_3;
	INDEX 33;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_lo_lo_alm_unacknowledged, func3_lo_lo_alm_state,
			func3_lo_lo_alm_time_stamp, func3_lo_lo_alm_subcode,
			func3_lo_lo_alm_value
		}
	}
}

COMMAND read_func3_simulate
{
	BLOCK function_block_3;
	INDEX 34;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			func3_simulate_status_quality	<0xFC>,
			func3_simulate_status_limit		<0x03>,
			func3_simulate_value, 
			func3_simulation_enabled
			
		}
	}
}

COMMAND write_func3_simulate
{
	BLOCK function_block_3;
	INDEX 34;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			func3_simulate_status_quality	<0xFC>,
			func3_simulate_status_limit		<0x03>,
			func3_simulate_value, 
			func3_simulation_enabled
			
		}
		REPLY
		{
		}
	}
}






 /*******************************************************************************/
/*****	Online-Dialogs  ********************************************************/
/*******************************************************************************/

MENU OnlineDialog_simulation
{
	LABEL		[menu_dialog_simulation];
	ITEMS
	{
		func2_simulation_enabled,
		func2_simulate_value,
//		func2_simulate_status,
		func2_simulate_status_limit,
		func2_simulate_status_quality,
//		func2_AI_simulate_status_quality,
		method_set
	}
}



/*******************************************************************************/
/*****	Table: Specialist  *****************************************************/
/*******************************************************************************/
		
MENU Tab_s_temp_input_measwindow
{
	LABEL		"Temperature Output";
	ITEMS
	{
		func2_st_rev,
 /*		Tab_s_input_measwindow,	 */
		Tab_s_output_signal,
		Tab_s_output_limits_signal,
//fbi 11.06.2007		 Tab_s_interface2_simulate,
		 Tab_s_trans2
	}
}
MENU Tab_s_input_measwindow
{
	LABEL		[menu_input_measwindow];
	ITEMS
	{
		func2_pv_lower_range_value,
		func2_pv_upper_range_value	
	}
}

MENU Tab_s_output_signal
{
	LABEL		[menu_output_signal];
	ITEMS
	{
		func2_out_lower_range_value,
		func2_out_upper_range_value,
		func2_out_unit
/*		func2_pv_ftime	  */
	}
}



MENU Tab_s_output_limits_signal
{
	LABEL		"Temperature Alarm";
	ITEMS
	{
		temp_alarm_stat_code			(DISPLAY_VALUE), 
		func2_lo_lo_lim,	
		func2_lo_lim,	
		func2_hi_lim,	
		func2_hi_hi_lim,	
		func2_alarm_hys,
		temp_en_output			(DISPLAY_VALUE), 
		temp_valve_action			(DISPLAY_VALUE)	 
//		temp_alarm 	
	}
}

/*
MENU Tab_s_interface2_simulate
{
	LABEL		[menu_interface_simulate];
	ITEMS
	{
		func2_simulation_enabled	(READ_ONLY),
		func2_simulate_value		(READ_ONLY),
		func2_simulate_status_quality		(READ_ONLY)
	}
}
//fbi 11.06.2007
*/
MENU Tab_s_trans2
{
	LABEL		"Temperature Channel";
	ITEMS
	{
		trans2_st_rev,
//fbi 11.06.2007		trans2_meas_value, 
//fbi 11.06.2007		trans2_meas_value_status_quality,
//		trans2_meas_value_status_quality[0xFC],
//fbi 11.06.2007		trans2_meas_value_status_limit,
//		trans2_meas_value_status_limit[0x03],
  /*		trans2_temperature_unit	,  */
//		trans2_bias		,
		trans2_calib_unit		(READ_ONLY)
	}
}

MENU Tab_s_aux_input_measwindow
{
	LABEL		"Aux Output";
	ITEMS
	{
		func3_st_rev,
  /*		Tab_s_input3_measwindow,	  */
		Tab_s_output3_signal,
		Tab_s_output3_limits_signal,
// fbi 11.06.2007		 Tab_s_interface3_simulate,
		 Tab_s_trans3
	}
}
MENU Tab_s_input3_measwindow
{
	LABEL		[menu_input_measwindow];
	ITEMS
	{
		func3_pv_lower_range_value,
		func3_pv_upper_range_value	
	}
}

MENU Tab_s_output3_signal
{
	LABEL		[menu_output_signal];
	ITEMS
	{
		func3_out_lower_range_value,
		func3_out_upper_range_value,
		func3_out_unit
/*		func3_pv_ftime	   */
	}
}



MENU Tab_s_output3_limits_signal
{
	LABEL		"Aux Alarm";
	ITEMS
	{
		aux_alarm_stat_code	(DISPLAY_VALUE),
		func3_lo_lo_lim,	
		func3_lo_lim,	
		func3_hi_lim,	
		func3_hi_hi_lim,	
		func3_alarm_hys,
		aux_en_output			(DISPLAY_VALUE),
		aux_valve_action	(DISPLAY_VALUE)
//		aux_off 
	}
}

/*
MENU Tab_s_interface3_simulate
{
	LABEL		[menu_interface_simulate];
	ITEMS
	{
		func3_simulation_enabled	(READ_ONLY),
		func3_simulate_value		(READ_ONLY),
		func3_simulate_status_quality		(READ_ONLY)
	}
}
//fbi 11.06.2007
*/
MENU Tab_s_trans3
{
	LABEL		"Aux Channel";
	ITEMS
	{
		trans3_st_rev,
//fbi 11.06.2007		trans3_primary_value,
//		trans3_primary_value_status_quality[0xFC],
//fbi 11.06.2007		trans3_primary_value_status_quality,
//		trans3_primary_value_status_limit[0x03],
//fbi 11.06.2007		trans3_primary_value_status_limit,
    /*	trans3_primary_value_unit,   */
		trans3_cal_point_lo,
		trans3_cal_point_hi,
		trans3_cal_unit		(READ_ONLY)
	}
}
			    
 METHOD    mode_method
{	
	HELP "The positioner can be switched out of service. In this mode the positioner may be configured"; 
	LABEL  "Mode";
	ACCESS ONLINE;
	DEFINITION 
	{
		int result;
		ReadCommand(read_func1_mode);
		result = ivar_value(func1_actual_mode);
		if (result != BLOCK_MODE_OUT_OF_SERVICE)
		{
				DELAY(2," Device mode \n In Service");
				ACKNOWLEDGE("\n Set device \n Out of Service");
				iassign(func1_target_mode, BLOCK_MODE_OUT_OF_SERVICE);
				WriteCommand(write_func1_target_mode);
				iassign(func2_target_mode, BLOCK_MODE_OUT_OF_SERVICE);
				WriteCommand(write_func2_target_mode);
				iassign(func3_target_mode, BLOCK_MODE_OUT_OF_SERVICE);
				WriteCommand(write_func3_target_mode);
 		}
		else if (result == BLOCK_MODE_OUT_OF_SERVICE)
		{
				DELAY(2," Device mode \n Out of Service");
				ACKNOWLEDGE("\n Set device \n In Service");
				iassign(func1_target_mode, BLOCK_MODE_AUTO);
				WriteCommand(write_func1_target_mode);
				iassign(func2_target_mode, BLOCK_MODE_AUTO);
				WriteCommand(write_func2_target_mode);
				iassign(func3_target_mode, BLOCK_MODE_AUTO);
				WriteCommand(write_func3_target_mode);
		}
		else
		DELAY(2," Error");	
	}
 }
